/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject2) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject2(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject2(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/GridLayout.tsx
var GridLayout_exports = {};
__export(GridLayout_exports, {
  default: () => GridLayout_default
});
module.exports = __toCommonJS(GridLayout_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:memoize-one
var memoize_one_exports = {};
__export(memoize_one_exports, {
  default: () => memoize_one_default
});
var defaultImport2 = __toESM(require("memoize-one"));
__reExport(memoize_one_exports, require("memoize-one"));
var memoize_one_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport3 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/dashboard-context
var dashboard_context_exports = {};
__export(dashboard_context_exports, {
  default: () => dashboard_context_default
});
var defaultImport4 = __toESM(require("@splunk/dashboard-context"));
__reExport(dashboard_context_exports, require("@splunk/dashboard-context"));
var dashboard_context_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/dashboard-telemetry
var dashboard_telemetry_exports = {};
__export(dashboard_telemetry_exports, {
  default: () => dashboard_telemetry_default
});
var defaultImport5 = __toESM(require("@splunk/dashboard-telemetry"));
__reExport(dashboard_telemetry_exports, require("@splunk/dashboard-telemetry"));
var dashboard_telemetry_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/dashboard-ui
var dashboard_ui_exports = {};
__export(dashboard_ui_exports, {
  default: () => dashboard_ui_default
});
var defaultImport6 = __toESM(require("@splunk/dashboard-ui"));
__reExport(dashboard_ui_exports, require("@splunk/dashboard-ui"));
var dashboard_ui_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/dashboard-utils
var dashboard_utils_exports = {};
__export(dashboard_utils_exports, {
  default: () => dashboard_utils_default
});
var defaultImport7 = __toESM(require("@splunk/dashboard-utils"));
__reExport(dashboard_utils_exports, require("@splunk/dashboard-utils"));
var dashboard_utils_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// src/BaseLayoutApi.ts
var BaseLayoutApi = class {
  constructor() {
    this.emitTelemetry = (payload) => {
      if (!this.telemetry) {
        return false;
      }
      this.telemetry.emit(__spreadValues({
        source: "layoutApi"
      }, payload));
      return true;
    };
  }
  /**
   * add new layout item synchronously
   */
  addLayoutItemSync(...args) {
    return this.addLayoutItem(...args);
  }
  /**
   * add one or more new layout items
   */
  addLayoutItems(items, metadata) {
    return this.addLayoutItemSync(
      items,
      metadata
    );
  }
  /**
   * copies item w/h and position with an offset synchronously
   */
  cloneLayoutItemsSync({ from, to }) {
    return this.cloneLayoutItems({ from, to });
  }
  /**
   * remove an item from layout synchronously
   */
  removeLayoutItemsSync(itemIds) {
    return this.removeLayoutItems(itemIds);
  }
};
var BaseLayoutApi_default = BaseLayoutApi;

// src/utils/edgeUtils.ts
var nextEdgeId = () => `edge_${(0, dashboard_utils_exports.uniqueId)()}`;
var getNextEdgeId = () => {
  return nextEdgeId();
};
var getNodes = (layoutStructure) => {
  if (layoutStructure.length === 0) {
    return null;
  }
  const nodes = {};
  layoutStructure.forEach((viz) => {
    const { x, y, w, h } = viz.position;
    const corners = [
      { x, y },
      { x: x + w, y },
      { x, y: y + h },
      { x: x + w, y: y + h }
    ];
    corners.forEach((corner) => {
      if (nodes[corner.x] === void 0) {
        nodes[corner.x] = {};
      }
      if (nodes[corner.x][corner.y] === void 0) {
        nodes[corner.x][corner.y] = [];
      }
      nodes[corner.x][corner.y].push(viz);
    });
  });
  return nodes;
};
var isTopEdge = (edge) => edge.orientation === "horizontal" && edge.edgeStart.y === 0;
var isBottomEdge = (edge, canvasHeight) => edge.orientation === "horizontal" && edge.edgeStart.y === canvasHeight;
var isLeftEdge = (edge) => edge.orientation === "vertical" && edge.edgeStart.x === 0;
var isRightEdge = (edge, canvasWidth) => edge.orientation === "vertical" && edge.edgeStart.x === canvasWidth;
var findVizAlongVerticalEdge = ({
  x,
  yStart,
  yEnd,
  yCurrent = yStart,
  nodes,
  visualizations = /* @__PURE__ */ new Set()
}) => {
  nodes[x][yCurrent].forEach((viz) => {
    if (viz.position.y >= yStart && viz.position.y < yEnd) {
      visualizations.add(viz);
    }
    if (viz.position.y >= yCurrent && yCurrent + viz.position.h <= yEnd) {
      findVizAlongVerticalEdge({
        x,
        yStart,
        yEnd,
        yCurrent: yCurrent + viz.position.h,
        nodes,
        visualizations
      });
    }
  });
  return visualizations;
};
var findVizAlongHorizontalEdge = ({
  y,
  xStart,
  xEnd,
  xCurrent = xStart,
  nodes,
  visualizations = /* @__PURE__ */ new Set()
}) => {
  var _a, _b;
  (_b = (_a = nodes[xCurrent]) == null ? void 0 : _a[y]) == null ? void 0 : _b.forEach((viz) => {
    if (viz.position.x >= xStart && viz.position.x < xEnd) {
      visualizations.add(viz);
    }
    if (viz.position.x >= xCurrent && xCurrent + viz.position.w <= xEnd) {
      findVizAlongHorizontalEdge({
        y,
        xStart,
        xEnd,
        xCurrent: xCurrent + viz.position.w,
        nodes,
        visualizations
      });
    }
  });
  return visualizations;
};
var addEdge = ({
  edges,
  edgeStart,
  edgeEnd,
  nodes
}) => {
  const orientation = edgeStart.y === edgeEnd.y ? "horizontal" : "vertical";
  const visualizations = orientation === "vertical" ? findVizAlongVerticalEdge({
    x: edgeStart.x,
    yStart: edgeStart.y,
    yEnd: edgeEnd.y,
    nodes
  }) : findVizAlongHorizontalEdge({
    y: edgeStart.y,
    xStart: edgeStart.x,
    xEnd: edgeEnd.x,
    nodes
  });
  edges.push({
    item: getNextEdgeId(),
    edgeStart,
    edgeEnd,
    visualizations: Array.from(visualizations),
    orientation
  });
};
var shouldTraverseDown = (y, visualizations) => {
  return visualizations.every((viz) => viz.position.y >= y);
};
var shouldTraverseRight = (x, visualizations) => {
  return visualizations.every((viz) => viz.position.x >= x);
};
var findOffset = ({
  x,
  y,
  visualizations,
  type
}) => {
  const vizXY = visualizations.find(
    ({ position }) => position.y === y && position.x === x
  );
  if (vizXY) {
    return vizXY.position[type];
  }
  const vizWH = visualizations.find(
    ({ position }) => (
      // horizontal canvas edge
      type === "w" && position.x === x || // vertical canvas edge
      type === "h" && position.y === y
    )
  );
  if (vizWH) {
    return vizWH.position[type];
  }
  return 0;
};
function traverseRight({
  x,
  y,
  nodes,
  edges,
  edgeStart,
  canTraverseDown = true
}) {
  if (canTraverseDown && shouldTraverseDown(y, nodes[x][y])) {
    traverseDown({
      x,
      y,
      nodes,
      edges,
      edgeStart: { x, y },
      // Start new edge when changing directions
      canTraverseRight: false
    });
  }
  const offset = findOffset({ x, y, visualizations: nodes[x][y], type: "w" });
  if (!offset) {
    addEdge({ edges, edgeStart, edgeEnd: { x, y }, nodes });
    return;
  }
  const isWindow = nodes[x][y].length === 4;
  if (isWindow) {
    addEdge({ edges, edgeStart, edgeEnd: { x, y }, nodes });
    traverseRight({
      x: x + offset,
      y,
      nodes,
      edges,
      edgeStart: { x, y }
    });
    return;
  }
  traverseRight({
    x: x + offset,
    y,
    nodes,
    edges,
    edgeStart
  });
}
function traverseDown({
  x,
  y,
  nodes,
  edges,
  edgeStart,
  canTraverseRight = true
}) {
  if (canTraverseRight && shouldTraverseRight(x, nodes[x][y])) {
    traverseRight({
      x,
      y,
      nodes,
      edges,
      edgeStart: { x, y },
      // Start new edge when changing directions
      canTraverseDown: false
    });
  }
  const offset = findOffset({ x, y, visualizations: nodes[x][y], type: "h" });
  if (!offset) {
    addEdge({ edges, edgeStart, edgeEnd: { x, y }, nodes });
    return;
  }
  const isWindow = nodes[x][y].length === 4;
  if (isWindow) {
    addEdge({ edges, edgeStart, edgeEnd: { x, y }, nodes });
    traverseDown({
      x,
      y: y + offset,
      nodes,
      edges,
      edgeStart: { x, y }
    });
    return;
  }
  traverseDown({
    x,
    y: y + offset,
    nodes,
    edges,
    edgeStart
  });
}
var computeVerticalCanvasEdges = ({
  edges,
  canvasWidth,
  layout
}) => {
  const nodes = getNodes(layout);
  if (nodes == null) {
    return;
  }
  const sortedRowEdges = edges.filter(
    (edge) => edge.orientation === "horizontal" && edge.edgeStart.x === 0 && edge.edgeEnd.x === canvasWidth
  ).sort((a, b) => a.edgeStart.y - b.edgeStart.y);
  for (let i = 0; i < sortedRowEdges.length - 1; i += 1) {
    const { edgeStart: edgeStartA, edgeEnd: edgeEndA } = sortedRowEdges[i];
    const { edgeStart: edgeStartB, edgeEnd: edgeEndB } = sortedRowEdges[i + 1];
    addEdge({
      edges,
      edgeStart: edgeStartA,
      edgeEnd: edgeStartB,
      nodes
    });
    addEdge({
      edges,
      edgeStart: edgeEndA,
      edgeEnd: edgeEndB,
      nodes
    });
  }
};
var getAllEdges = (layout) => {
  const edges = [];
  const nodes = getNodes(layout);
  if (nodes === null || nodes[0] === void 0 || nodes[0][0] === void 0) {
    return [];
  }
  traverseRight({
    x: 0,
    y: 0,
    nodes,
    edges,
    edgeStart: { x: 0, y: 0 }
  });
  return edges;
};
var computeEdges = ({
  layout,
  canvasHeight,
  canvasWidth
}) => {
  if (layout === void 0) {
    return [];
  }
  let edges = getAllEdges(layout);
  edges = edges.filter((edge) => {
    return !(isLeftEdge(edge) || isRightEdge(edge, canvasWidth));
  });
  computeVerticalCanvasEdges({ edges, layout, canvasWidth });
  edges = edges.map((edge) => {
    let isCanvasEdge = false;
    if (isTopEdge(edge) || isRightEdge(edge, canvasWidth) || isBottomEdge(edge, canvasHeight) || isLeftEdge(edge)) {
      isCanvasEdge = true;
    }
    return __spreadProps(__spreadValues({}, edge), { isCanvasEdge });
  });
  return edges;
};
var applyVizPadding = ({
  item,
  padding = 0
}) => {
  const { x, y, w, h } = item.position;
  return __spreadProps(__spreadValues({}, item), {
    position: {
      x: x + padding,
      y: y + padding,
      w: w - 2 * padding,
      h: h - 2 * padding
    }
  });
};
var getVerticalBoundaries = ({
  visualizations,
  y,
  minHeight,
  isFullWidthEdge = false
}) => {
  const boundaries = {
    upperBoundary: Number.NEGATIVE_INFINITY,
    lowerBoundary: Number.POSITIVE_INFINITY
  };
  const comparePosition = (position) => {
    if (position.y >= y && !isFullWidthEdge) {
      boundaries.lowerBoundary = Math.min(
        boundaries.lowerBoundary,
        position.y + position.h - minHeight
      );
    }
    if (position.y < y) {
      boundaries.upperBoundary = Math.max(
        boundaries.upperBoundary,
        position.y + minHeight
      );
    }
  };
  visualizations.forEach((viz) => comparePosition(viz.position));
  return boundaries;
};
var getHorizontalBoundaries = ({
  visualizations,
  x,
  minWidth
}) => {
  const boundaries = {
    rightBoundary: Number.POSITIVE_INFINITY,
    leftBoundary: Number.NEGATIVE_INFINITY
  };
  const comparePosition = (position) => {
    if (position.x >= x) {
      boundaries.rightBoundary = Math.min(
        boundaries.rightBoundary,
        position.x + position.w - minWidth
      );
    }
    if (position.x < x) {
      boundaries.leftBoundary = Math.max(
        boundaries.leftBoundary,
        position.x + minWidth
      );
    }
  };
  visualizations.forEach((viz) => comparePosition(viz.position));
  return boundaries;
};
var moveHorizontalEdge = ({
  edge,
  offset,
  edgeBoundaries: { upperBoundary, lowerBoundary }
}) => {
  const updatedY = offset < 0 ? Math.max(upperBoundary, edge.edgeStart.y + offset) : Math.min(lowerBoundary, edge.edgeStart.y + offset);
  return __spreadProps(__spreadValues({}, edge), {
    edgeStart: {
      x: edge.edgeStart.x,
      y: updatedY
    },
    edgeEnd: {
      x: edge.edgeEnd.x,
      y: updatedY
    }
  });
};
var moveVerticalEdge = ({
  edge,
  offset,
  edgeBoundaries: { leftBoundary, rightBoundary }
}) => {
  const updatedX = offset < 0 ? Math.max(leftBoundary, edge.edgeStart.x + offset) : Math.min(rightBoundary, edge.edgeStart.x + offset);
  return __spreadProps(__spreadValues({}, edge), {
    edgeStart: {
      x: updatedX,
      y: edge.edgeStart.y
    },
    edgeEnd: {
      x: updatedX,
      y: edge.edgeEnd.y
    }
  });
};
var findSnappableEdges = ({
  edge,
  edges,
  snapRange
}) => {
  const coordinate = edge.orientation === "horizontal" ? "y" : "x";
  const snappableEdges = edges.reduce(
    (currentSnappableEdges, nextEdge) => {
      const nextEdgeDistance = Math.abs(
        nextEdge.edgeStart[coordinate] - edge.edgeStart[coordinate]
      );
      if (nextEdgeDistance <= snapRange) {
        if (currentSnappableEdges.length === 0) {
          return [nextEdge];
        }
        const lastEdge = currentSnappableEdges[currentSnappableEdges.length - 1];
        const lastEdgeDistance = Math.abs(
          lastEdge.edgeStart[coordinate] - edge.edgeStart[coordinate]
        );
        if (nextEdgeDistance < lastEdgeDistance) {
          return [nextEdge];
        }
        if (nextEdgeDistance === lastEdgeDistance) {
          return [...currentSnappableEdges, nextEdge];
        }
      }
      return [...currentSnappableEdges];
    },
    []
  );
  const firstSnappableEdge = snappableEdges.length > 0 ? snappableEdges[0] : edge;
  return {
    updatedEdge: __spreadProps(__spreadValues({}, edge), {
      edgeStart: __spreadProps(__spreadValues({}, edge.edgeStart), {
        [coordinate]: firstSnappableEdge.edgeStart[coordinate]
      }),
      edgeEnd: __spreadProps(__spreadValues({}, edge.edgeEnd), {
        [coordinate]: firstSnappableEdge.edgeEnd[coordinate]
      })
    }),
    snappableEdges
  };
};
var findEdgesInBoundary = ({
  edge,
  edges,
  edgeBoundaries
}) => {
  const { orientation } = edge;
  if (orientation === "horizontal") {
    return edges.filter(
      (e) => e.orientation === "horizontal" && e.edgeStart.y >= edgeBoundaries.upperBoundary && e.edgeStart.y <= edgeBoundaries.lowerBoundary && e !== edge
    );
  }
  if (orientation === "vertical") {
    return edges.filter(
      (e) => e.orientation === "vertical" && e.edgeStart.x >= edgeBoundaries.leftBoundary && e.edgeStart.x <= edgeBoundaries.rightBoundary && e !== edge
    );
  }
  return [];
};

// src/utils/layoutUtils.ts
var computeMaxHeight = dashboard_utils_exports.computeMaxHeight;
var positionToStyle = (pos) => ({
  width: `${pos.w}px`,
  height: `${pos.h}px`,
  transform: `translate(${pos.x}px, ${pos.y}px)`
});
var getClientPosition = (e, scaleFactor = 1) => ({
  x: Math.round(e.clientX / scaleFactor),
  y: Math.round(e.clientY / scaleFactor)
});
var getOffset = (currentPosition, startPosition) => ({
  offsetX: currentPosition.x - startPosition.x,
  offsetY: currentPosition.y - startPosition.y
});
var considerMoved = ({
  offsetX,
  offsetY
}) => offsetX !== 0 || offsetY !== 0;
var positionsToBoundary = (startPos, endPos) => ({
  x: Math.min(startPos.x, endPos.x),
  y: Math.min(startPos.y, endPos.y),
  w: Math.abs(startPos.x - endPos.x),
  h: Math.abs(startPos.y - endPos.y)
});
var filterBlockItemsByBoundary = (items, boundary) => items.filter((item) => {
  const itemPosition = item.position;
  return !(boundary.x > itemPosition.x + itemPosition.w || boundary.x + boundary.w < itemPosition.x || boundary.y > itemPosition.y + itemPosition.h || boundary.y + boundary.h < itemPosition.y);
});
var findTopBlockItemByPosition = (items, pos, padding = 0) => (0, lodash_exports.findLast)(items, (item) => {
  const itemPosition = padding ? applyVizPadding({ item, padding }).position : item.position;
  return itemPosition.x <= pos.x && itemPosition.x + itemPosition.w >= pos.x && itemPosition.y <= pos.y && itemPosition.y + itemPosition.h >= pos.y;
});
var updateBlockItemSize = ({
  item,
  offset,
  dir,
  options: { minWidth = 0, minHeight = 0 } = {}
}) => {
  const { w, h } = item.position;
  const { offsetX, offsetY } = offset;
  const updatedPosition = __spreadValues({}, item.position);
  if (["n", "ne", "nw"].includes(dir)) {
    updatedPosition.y += Math.min(h - minHeight, offsetY);
    updatedPosition.h -= offsetY;
  }
  if (["s", "se", "sw"].includes(dir)) {
    updatedPosition.h += offsetY;
  }
  if (["e", "ne", "se"].includes(dir)) {
    updatedPosition.w += offsetX;
  }
  if (["w", "nw", "sw"].includes(dir)) {
    updatedPosition.x += Math.min(w - minWidth, offsetX);
    updatedPosition.w -= offsetX;
  }
  updatedPosition.w = Math.max(minWidth, updatedPosition.w);
  updatedPosition.h = Math.max(minHeight, updatedPosition.h);
  return __spreadProps(__spreadValues({}, item), {
    position: updatedPosition
  });
};
var updateBlockItemPosition = (item, offset) => {
  const { offsetX, offsetY } = offset;
  return __spreadProps(__spreadValues({}, item), {
    position: __spreadProps(__spreadValues({}, item.position), {
      x: item.position.x + offsetX,
      y: item.position.y + offsetY
    })
  });
};
var computeScaleToFit = ({
  canvasWidth,
  canvasHeight,
  containerWidth,
  containerHeight,
  scrollbarWidth,
  max = Infinity,
  enableGridLayoutCssScaling = true
}) => {
  if (!((0, lodash_exports.isNumber)(containerWidth) && containerWidth > 0 && (0, lodash_exports.isNumber)(canvasWidth) && canvasWidth > 0)) {
    dashboard_utils_exports.console.warn(
      `Failed to calculate layout scale: canvasWidth=${canvasWidth}, containerWidth=${containerWidth}; falling back to scale=1`
    );
    return 1;
  }
  const scale = Math.min(containerWidth / canvasWidth, max);
  const scrollbarScale = Math.min(
    (containerWidth - scrollbarWidth) / canvasWidth,
    max
  );
  if (!enableGridLayoutCssScaling) {
    return scrollbarScale;
  }
  if (canvasHeight * scale > containerHeight) {
    return scrollbarScale;
  }
  return scale;
};
var computeRelativePosition = (e, canvasRef, scale = 1) => {
  var _a;
  const pos = getClientPosition(e, scale);
  const canvasDomNode = canvasRef == null ? void 0 : canvasRef.current;
  const rect = (_a = canvasDomNode == null ? void 0 : canvasDomNode.getBoundingClientRect) == null ? void 0 : _a.call(canvasDomNode);
  if (pos && rect) {
    return {
      x: pos.x - rect.left / scale,
      y: pos.y - rect.top / scale
    };
  }
  return pos;
};
var scaleGridLayoutStructureByWidth = ({
  layout,
  scale = 1
}) => {
  if (scale === 1) {
    return layout;
  }
  const edges = getAllEdges(layout);
  const verticalEdges = (0, lodash_exports.sortBy)(
    edges.filter((edge) => edge.orientation === "vertical"),
    ["edgeStart.x"]
  );
  const newLayout = [];
  verticalEdges.forEach((edge) => {
    const {
      visualizations,
      edgeStart: { x }
    } = edge;
    const scaledEdgeX = Math.round(x * scale);
    const left = visualizations.filter((viz) => viz.position.x < x);
    const right = visualizations.filter((viz) => viz.position.x >= x);
    left.forEach((layoutItem) => {
      const newLayoutItem = newLayout.find(
        ({ item: id }) => layoutItem.item === id
      );
      if (newLayoutItem) {
        newLayoutItem.position.w = scaledEdgeX - newLayoutItem.position.x;
      }
    });
    right.forEach((layoutItem) => {
      newLayout.push(__spreadProps(__spreadValues({}, layoutItem), {
        position: __spreadProps(__spreadValues({}, layoutItem.position), {
          x: scaledEdgeX
        })
      }));
    });
  });
  return newLayout;
};

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport8 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// src/utils/blockUtils.ts
var InvalidBlockItemError = "refers to an invalid block item";
var InvalidBlockItemErrorMessage = (0, i18n_exports._)(`%s ${InvalidBlockItemError}`);
var getBlockItem = ({
  layoutStructure,
  id
}) => {
  const blockItem = layoutStructure.find(({ item }) => item === id);
  if (!blockItem || blockItem.type === "line") {
    throw Error(InvalidBlockItemErrorMessage.replace("%s", id));
  }
  return blockItem;
};

// src/utils/imageUtils.ts
var getImageDimension = (0, lodash_exports.memoize)(
  (imgSrc) => {
    const img = new Image();
    try {
      img.src = imgSrc;
      img.style.position = "absolute";
      img.style.left = "-9999";
      img.style.visibility = "hidden";
      document.body.appendChild(img);
      const height = img.naturalHeight;
      const width = img.naturalWidth;
      return { width, height };
    } catch (e) {
      return { width: 0, height: 0 };
    } finally {
      if (document.body.contains(img)) {
        document.body.removeChild(img);
      }
    }
  }
);
var validateOpacity = (opacity) => {
  if (typeof opacity !== "number" || opacity > 1) {
    return 1;
  }
  if (opacity < 0) {
    return 0;
  }
  return opacity;
};

// src/DefaultOptions.ts
var gridLayoutOptions = {
  width: dashboard_utils_exports.DEFAULT_CANVAS_WIDTH,
  gutterSize: 8
};

// src/GridLayoutConstants.ts
var CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL = (0, i18n_exports._)(
  "This panel is too small to be split into duplicates. Stretch or move the panel to make it bigger first."
);
var GRID_PADDING_PX = 1;
var GRID_SIZE_PX = 10;
var MIN_HEIGHT_PX = 64;
var MIN_WIDTH_PX = 64;
var SNAP_RANGE_PX = 8;
var PLACEHOLDER_SIZE_PX = 128;
var ITEM_DROP_TARGET_PX = 12;
var VIZ_PREVIEW_DELAY_MS = 50;
var EDGE_PREVIEW_DELAY_MS = 500;

// src/apis/GridLayoutApi.ts
var empty = {};
var GridLayoutApi = class extends BaseLayoutApi_default {
  constructor({
    layoutStructureRef,
    options = empty,
    userMessage,
    onItemAdded,
    getCanvasDomElement,
    telemetry
  }) {
    super();
    /**
     * Add a new item to grid layout synchronously
     * @method
     * @param {Object} options
     * @param {String} options.itemId visualization id
     * @returns {Object[]} updated layout structure
     * @public
     */
    this.addLayoutItemSync = ({
      itemId,
      type = "block",
      metadata
    }) => {
      this.emitTelemetry({
        pageAction: "addLayoutItem",
        metadata
      });
      return this.addLayoutItemsInternal({ items: [{ itemId, type }] });
    };
    /**
     * Add a new item to grid layout
     * @method
     * @param {Object} options
     * @param {String} options.itemId visualization id
     * @returns {Object[]} updated layout structure
     * @public
     */
    this.addLayoutItem = ({
      itemId,
      type = "block",
      metadata
    }) => this.addLayoutItemSync({ itemId, type, metadata });
    /**
     * @method addLayoutItemsSync
     * Synchronously generate a new layout structure with one one or more items added
     * @param {Object[]} items
     * @param {Object} [metadata]
     * @returns {GridLayoutStructure} New layout structure
     * @public
     */
    this.addLayoutItemsSync = (items, metadata) => {
      this.emitTelemetry({
        pageAction: "addLayoutItems",
        metadata
      });
      return this.addLayoutItemsInternal({ items });
    };
    /**
     * @method addLayoutItems
     * Generate a new layout structure with one one or more items added
     * @param {Object[]} items
     * @param {Object} [metadata]
     * @returns {GridLayoutStructure} New layout structure
     * @public
     */
    this.addLayoutItems = (items, metadata) => this.addLayoutItemsSync(items, metadata);
    /**
     * Add multiple new items to grid layout
     * @method
     * @param {Object} options
     * @param {Object[]} options.items item data
     * @returns {Object[]} updated layout structure
     * @private
     */
    this.addLayoutItemsInternal = ({
      items
    }) => {
      var _a;
      const width = (_a = this.options.width) != null ? _a : gridLayoutOptions.width;
      const proposedLayoutStructure = items.reduce(
        (structure, { itemId, type }) => {
          const newStructureItem = (0, dashboard_utils_exports.computeNewGridStructureItem)({
            itemId,
            type: type != null ? type : "block",
            canvasWidth: width,
            layoutItems: structure
          });
          structure.push(newStructureItem);
          return structure;
        },
        [...this.layoutStructureRef.current]
      );
      this.onItemAdded();
      return proposedLayoutStructure;
    };
    /**
     * Remove item specified in itemIds list synchronously
     * Note: Only removes one item even though it accepts a list of item ids.
     * @method
     * @param {string[]} item ids to remove.
     * @returns {object[]} updated layout structure
     * @public
     */
    this.removeLayoutItemsSync = (itemIds = [], metadata = void 0) => {
      var _a;
      this.emitTelemetry({
        pageAction: "removeLayoutItems",
        metadata
      });
      const items = this.layoutStructureRef.current;
      let itemToRemove;
      try {
        itemToRemove = getBlockItem({
          layoutStructure: items,
          id: itemIds[0]
        });
      } catch (e) {
        return items;
      }
      const width = (_a = this.options.width) != null ? _a : gridLayoutOptions.width;
      const updatedItems = (0, dashboard_utils_exports.updateRemovedVizNeighbors)({
        itemToRemove,
        items,
        width
      });
      const keys = updatedItems.map((item) => item.item);
      const filteredItems = items.filter(
        (vizItem) => vizItem.item !== itemToRemove.item && keys.indexOf(vizItem.item) < 0
      );
      return [...updatedItems, ...filteredItems];
    };
    /**
     * Remove item specified in itemIds list.
     * Note: Only removes one item even though it accepts a list of item ids.
     * @method
     * @param {string[]} item ids to remove.
     * @returns {object[]} updated layout structure
     * @public
     */
    this.removeLayoutItems = (itemIds = [], metadata = void 0) => this.removeLayoutItemsSync(itemIds, metadata);
    /**
     * There are 3 actors in this cloning algorithm:
     * 1. Clone Ancestor
     * 2. Left-side Descendant
     * 3. Right-side Descendant
     * @method
     * @param {Object} options
     * @param {String[]} options.from List of original viz ids (ancestors). These id's will be re-used to produce left-side descendants.
     * @param {String[]} options.to List of new viz ids. Has the id's of right-side descendants.
     * @returns {Object[]} Layout structure of all known items
     * @public
     */
    this.cloneLayoutItemsSync = ({
      from,
      to,
      metadata
    }) => {
      if (!Array.isArray(from) || !Array.isArray(to) || from.length !== to.length) {
        throw new Error(
          `Cannot clone viz, incorrect inputs from ${from}, to: ${to}`
        );
      }
      this.emitTelemetry({
        pageAction: "cloneLayoutItems",
        metadata
      });
      const items = this.layoutStructureRef.current;
      return from.reduce((accumulator, fromItemId, index) => {
        const ancestor = getBlockItem({
          layoutStructure: items,
          id: fromItemId
        });
        if (ancestor.position.w < MIN_WIDTH_PX * 2) {
          this.userMessage({
            message: CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL,
            level: "warning",
            sender: "GridLayoutApi"
          });
          return accumulator;
        }
        const lsDescendant = updateBlockItemSize({
          item: __spreadValues({}, ancestor),
          offset: {
            offsetX: -1 * Math.floor(ancestor.position.w / 2),
            offsetY: 0
          },
          dir: "e"
        });
        const rsDescendant = updateBlockItemSize({
          item: __spreadProps(__spreadValues({}, ancestor), {
            item: to[index]
          }),
          offset: {
            offsetX: Math.ceil(ancestor.position.w / 2),
            offsetY: 0
          },
          dir: "w"
        });
        const accumulatorSansAncestor = (0, lodash_exports.reject)(accumulator, {
          item: fromItemId
        });
        return [...accumulatorSansAncestor, lsDescendant, rsDescendant];
      }, items);
    };
    /**
     * There are 3 actors in this cloning algorithm:
     * 1. Clone Ancestor
     * 2. Left-side Descendant
     * 3. Right-side Descendant
     * @method
     * @param {Object} options
     * @param {String[]} options.from List of original viz ids (ancestors). These id's will be re-used to produce left-side descendants.
     * @param {String[]} options.to List of new viz ids. Has the id's of right-side descendants.
     * @returns {Object[]} Layout structure of all known items
     * @public
     */
    this.cloneLayoutItems = ({
      from,
      to,
      metadata
    }) => this.cloneLayoutItemsSync({ from, to, metadata });
    /**
     * Return snapshot as an empty object for the time being
     * @method
     */
    // eslint-disable-next-line class-methods-use-this
    this.snapshot = () => {
      return {};
    };
    /**
     * Return zoom level as null for now
     * @method
     */
    // eslint-disable-next-line class-methods-use-this
    this.getZoomLevel = () => {
      return null;
    };
    this.layoutStructureRef = layoutStructureRef;
    this.options = options;
    this.userMessage = userMessage;
    this.onItemAdded = onItemAdded;
    this.getCanvasDomElement = getCanvasDomElement;
    this.telemetry = telemetry;
  }
};
var GridLayoutApi_default = GridLayoutApi;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport9 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport10 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// src/hooks/useBackgroundImage.ts
var useBackgroundImage = (backgroundImageSrc) => {
  const [imageSrc, setImageSrc] = (0, react_exports.useState)("");
  const imageRegistry = (0, dashboard_context_exports.useImageRegistry)();
  const fetchBackgroundImage = (registry, bgImageSrc) => __async(void 0, null, function* () {
    try {
      if (registry) {
        if (registry.isResourceURL(bgImageSrc)) {
          const imageObject = yield registry.getByURL(bgImageSrc);
          setImageSrc(imageObject.dataURI);
        } else {
          setImageSrc(bgImageSrc);
        }
      } else {
        setImageSrc(bgImageSrc);
      }
    } catch (error) {
      if (error instanceof Error) {
        dashboard_utils_exports.console.error(error.message);
      } else {
        dashboard_utils_exports.console.error("An unknown error occurred");
      }
    }
  });
  (0, react_exports.useEffect)(() => {
    if (backgroundImageSrc) {
      fetchBackgroundImage(
        imageRegistry,
        backgroundImageSrc
      );
    } else {
      setImageSrc("");
    }
  }, [imageRegistry, backgroundImageSrc]);
  return imageSrc;
};

// esm-externals:@splunk/dashboard-state
var dashboard_state_exports = {};
__export(dashboard_state_exports, {
  default: () => dashboard_state_default
});
var defaultImport11 = __toESM(require("@splunk/dashboard-state"));
__reExport(dashboard_state_exports, require("@splunk/dashboard-state"));
var dashboard_state_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/datasource-utils
var datasource_utils_exports = {};
__export(datasource_utils_exports, {
  default: () => datasource_utils_default
});
var defaultImport12 = __toESM(require("@splunk/datasource-utils"));
__reExport(datasource_utils_exports, require("@splunk/datasource-utils"));
var datasource_utils_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// src/utils/showHideUtils.ts
var hasNoResults = (searchData) => {
  var _a, _b, _c;
  if (typeof searchData === "undefined") {
    return true;
  }
  return ((_b = (_a = searchData.meta) == null ? void 0 : _a.totalCount) != null ? _b : 0) === 0 && ((_c = searchData == null ? void 0 : searchData.meta) == null ? void 0 : _c.status) !== datasource_utils_exports.DS_STATUS.REFRESHING;
};
var shouldHideItem = ({
  item,
  definition,
  searchData,
  conditionResults
}) => {
  var _a, _b, _c, _d;
  if (!definition) {
    return false;
  }
  if (item.type === "line") {
    return false;
  }
  const {
    hideWhenNoData,
    conditions = [],
    hideWhenConditions
  } = (_b = (_a = definition.containerOptions) == null ? void 0 : _a.visibility) != null ? _b : {};
  if (!!(hideWhenNoData != null ? hideWhenNoData : definition.hideWhenNoData) && hasNoResults(searchData)) {
    return true;
  }
  if (((_c = definition.containerOptions) == null ? void 0 : _c.visibility) && "hideInViewMode" in definition.containerOptions.visibility && !!((_d = definition.containerOptions.visibility) == null ? void 0 : _d.hideInViewMode)) {
    return true;
  }
  if (conditions.length !== 0) {
    return hideWhenConditions === "all-true" ? conditions.every((condId) => conditionResults[condId]) : conditions.some((condId) => conditionResults[condId]);
  }
  return false;
};

// src/hooks/useLayoutShowHide.ts
var getCondIds = (allItems) => allItems === void 0 ? [] : Object.values(allItems).flatMap(
  (itemDef) => {
    var _a, _b, _c;
    return (_c = (_b = (_a = itemDef.containerOptions) == null ? void 0 : _a.visibility) == null ? void 0 : _b.conditions) != null ? _c : [];
  }
);
var useLayoutShowHide = (layoutStructure, handleReflow) => {
  const allVizs = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectVisualizations);
  const allInputs = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectInputs);
  const mode = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectMode);
  const allConditionIds = (0, react_exports.useMemo)(
    () => /* @__PURE__ */ new Set([...getCondIds(allVizs), ...getCondIds(allInputs)]),
    [allInputs, allVizs]
  );
  const conditionResults = (0, dashboard_state_exports.useSelector)(
    (state) => (0, dashboard_state_exports.selectConditionResults)(state, Array.from(allConditionIds))
  );
  const subscriptions = (0, dashboard_ui_exports.useBatchSubscribeToSearches)({
    consumerId: "<layout>"
  });
  const { enableShowHide } = (0, dashboard_context_exports.useFeatureFlags)();
  return (0, react_exports.useMemo)(() => {
    if (!enableShowHide || mode === "edit") {
      return layoutStructure;
    }
    const itemsToRemove = [];
    const filteredStructure = layoutStructure.filter((item) => {
      var _a;
      if (shouldHideItem({
        item,
        definition: (_a = allVizs[item.item]) != null ? _a : allInputs == null ? void 0 : allInputs[item.item],
        searchData: subscriptions[item.item],
        conditionResults
      })) {
        itemsToRemove.push(item);
        return false;
      }
      return true;
    });
    return itemsToRemove.length && handleReflow ? handleReflow(layoutStructure, itemsToRemove) : filteredStructure;
  }, [
    enableShowHide,
    mode,
    layoutStructure,
    handleReflow,
    allVizs,
    allInputs,
    subscriptions,
    conditionResults
  ]);
};

// src/hooks/useMouseDownWithHandleEventListeners.ts
var useMouseDownWithHandleEventListeners = ({
  handleMouseDownOnItem,
  canvasRef,
  scale,
  setStartPosition,
  movable,
  setIsMoving,
  isMovingRef
}) => {
  const handleMouseDownOnVizWithHandle = (0, dashboard_ui_exports.useEventCallback)(
    (e) => {
      const { vizId, initialEvent, type } = e.detail;
      const pos = computeRelativePosition(initialEvent, canvasRef, scale);
      setStartPosition(pos);
      const block = {
        id: vizId,
        type
      };
      handleMouseDownOnItem(initialEvent, block);
    }
  );
  const handleMouseDownOnHandle = (0, dashboard_ui_exports.useEventCallback)((e) => {
    const { vizId, initialEvent, type } = e.detail;
    const pos = computeRelativePosition(initialEvent, canvasRef, scale);
    setStartPosition(pos);
    const block = {
      id: vizId,
      type
    };
    handleMouseDownOnItem(initialEvent, block);
    if (movable) {
      setIsMoving(true);
      if (isMovingRef) {
        isMovingRef.current = true;
      }
    }
  });
  (0, dashboard_ui_exports.useEventListener)({
    eventName: dashboard_ui_exports.EVENT_MOUSE_DOWN_ON_VIZ_WITH_HANDLE,
    target: document,
    listener: handleMouseDownOnVizWithHandle
  });
  (0, dashboard_ui_exports.useEventListener)({
    eventName: dashboard_ui_exports.EVENT_MOUSE_DOWN_ON_HANDLE,
    target: document,
    listener: handleMouseDownOnHandle
  });
};

// esm-externals:rxjs
var rxjs_exports = {};
__export(rxjs_exports, {
  default: () => rxjs_default
});
var defaultImport13 = __toESM(require("rxjs"));
__reExport(rxjs_exports, require("rxjs"));
var rxjs_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// src/AbsoluteLayoutConstants.ts
var GRID_SIZE = 10;
var MIN_WIDTH = GRID_SIZE * 2;
var MIN_HEIGHT = GRID_SIZE * 2;

// src/components/Canvas/BackgroundImage.tsx
var toBackgroundImageSize = ({
  src,
  imageHeight,
  imageWidth,
  sizeType
}) => {
  const { width: w, height: h } = getImageDimension(src != null ? src : "");
  if (imageWidth && imageHeight) {
    return `${(0, dashboard_utils_exports.toPx)(imageWidth)} ${(0, dashboard_utils_exports.toPx)(imageHeight)}`;
  }
  if (imageWidth || imageHeight) {
    return `${(0, dashboard_utils_exports.toPx)(imageWidth != null ? imageWidth : w)} ${(0, dashboard_utils_exports.toPx)(imageHeight != null ? imageHeight : h)}`;
  }
  return sizeType != null ? sizeType : "contain";
};
var BackgroundImageDiv = styled_components_default.div.attrs(() => ({
  "data-test": "background-image"
}))`
    ${themes_exports.mixins.reset("inline-block")};
    width: 100%;
    height: 100%;
    position: relative;
    background-repeat: no-repeat;
    background-image: ${(props) => `url("${props.src}")`};
    background-size: ${(props) => toBackgroundImageSize(props)};
    background-position: ${(props) => `${(0, dashboard_utils_exports.toPx)(props.imageX)} ${(0, dashboard_utils_exports.toPx)(props.imageY)}`};
    opacity: ${(prop) => validateOpacity(prop.opacity)};
`;
var BackgroundImage = (_a) => {
  var _b = _a, { src } = _b, rest = __objRest(_b, ["src"]);
  const imageSrc = useBackgroundImage(src);
  if (!imageSrc) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(BackgroundImageDiv, __spreadProps(__spreadValues({}, rest), { src: imageSrc }));
};

// src/components/Canvas/CanvasBorder.tsx
var Border = styled_components_default.div.attrs(() => ({
  "data-test": "canvas-border"
}))`
    position: absolute;
    box-sizing: border-box;
    border: 2px dashed
        ${(0, themes_exports.pick)({
  enterprise: {
    light: themes_exports.variables.gray80,
    dark: themes_exports.variables.gray30
  },
  prisma: themes_exports.variables.interactiveColorBorder
})};
    left: 0px;
    top: 0px;
    right: 0px;
    bottom: 0px;
    width: 100%;
    height: 100%;
`;
var CanvasBorder = ({
  showBorder = false
}) => {
  if (!showBorder) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(Border, null);
};

// src/components/Canvas/CanvasGridlines.tsx
var GRID_LINE_OPACITY = 0.1;
var getGridLineColor = (props) => {
  var _a;
  return (_a = props.gridLineColor) != null ? _a : (0, themes_exports.pick)({
    light: "#D8D8D8",
    dark: "#9B9B9B"
  });
};
var GridLines = styled_components_default.div`
    position: absolute;
    box-sizing: border-box;
    left: 0px;
    top: 0px;
    right: 0px;
    bottom: 0px;
    width: 100%;
    height: 100%;
    opacity: ${(prop) => {
  var _a;
  return (_a = prop.gridLineOpacity) != null ? _a : GRID_LINE_OPACITY;
}};
    background-size: ${(prop) => prop.gridWidth + prop.gridLineWidth}px
        ${(prop) => prop.gridHeight + prop.gridLineWidth}px;
    background-image: repeating-linear-gradient(
            0deg,
            ${getGridLineColor},
            ${getGridLineColor} ${(prop) => (0, dashboard_utils_exports.toPx)(prop.gridLineWidth)},
            transparent ${(prop) => prop.gridLineWidth}px,
            transparent ${(prop) => prop.gridHeight + prop.gridLineWidth}px
        ),
        repeating-linear-gradient(
            -90deg,
            ${getGridLineColor},
            ${getGridLineColor} ${(prop) => (0, dashboard_utils_exports.toPx)(prop.gridLineWidth)},
            transparent ${(prop) => prop.gridLineWidth}px,
            transparent ${(prop) => prop.gridWidth + prop.gridLineWidth}px
        );
`;
var CanvasGridlines = (_a) => {
  var _b = _a, { showGrid } = _b, rest = __objRest(_b, ["showGrid"]);
  if (!showGrid) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(GridLines, __spreadProps(__spreadValues({}, rest), { "data-test": "gridlines" }));
};

// src/components/Canvas/Background.tsx
var toScale = (scale) => scale ? {
  transform: `scale(${scale})`,
  transformOrigin: "0 0",
  width: `${100 / scale}%`
} : {
  width: "100%"
};
var Background = styled_components_default.div.attrs((props) => ({
  style: __spreadValues({
    height: props.height
  }, toScale(props.scale))
}))`
    ${themes_exports.mixins.reset("inline-block")};
    position: relative;
    background: ${(prop) => prop.bgColor || // NOTE: this needs to match packages/dashboard-editors/src/layouts/AbsoluteLayoutEditor.jsx
dashboard_ui_exports.customThemeVariables.dashboardBackgroundColor};
`;

// src/components/Canvas/Canvas.tsx
var CanvasContainer = styled_components_default.div.attrs((props) => ({
  style: { width: props.width, height: props.height }
}))`
    ${themes_exports.mixins.reset("block")};
    overflow: ${(prop) => prop.showOverflowContent ? "visible" : "hidden"};
    user-select: ${(prop) => prop.userSelect ? "text" : "none"};
    position: relative;
`;
var Canvas = (_a, canvasRef) => {
  var _b = _a, {
    width,
    height,
    scale,
    backgroundColor: unsanitizedBgColor = "",
    backgroundImageSrc,
    backgroundImageSizeType,
    backgroundImageWidth,
    backgroundImageHeight,
    backgroundImagePositionX,
    backgroundImagePositionY,
    backgroundImageOpacity,
    gridLineOpacity,
    children,
    showOverflowContent = false,
    userSelect = false,
    showGrid = false,
    gridPadding = 0,
    gridLineWidth = 1,
    gridLineColor,
    gridWidth = 9,
    gridHeight = 9,
    showBorder = false,
    cssScaling = true
  } = _b, others = __objRest(_b, [
    "width",
    "height",
    "scale",
    "backgroundColor",
    "backgroundImageSrc",
    "backgroundImageSizeType",
    "backgroundImageWidth",
    "backgroundImageHeight",
    "backgroundImagePositionX",
    "backgroundImagePositionY",
    "backgroundImageOpacity",
    "gridLineOpacity",
    "children",
    "showOverflowContent",
    "userSelect",
    "showGrid",
    "gridPadding",
    "gridLineWidth",
    "gridLineColor",
    "gridWidth",
    "gridHeight",
    "showBorder",
    "cssScaling"
  ]);
  const containerWidth = scale != null ? width * scale : width;
  const containerHeight = scale != null && cssScaling ? height * scale : height;
  const backgroundColor = (0, dashboard_ui_exports.sanitizeColor)(unsanitizedBgColor);
  return /* @__PURE__ */ react_default.createElement(
    CanvasContainer,
    __spreadValues({
      "data-test": "canvas-container",
      "data-width": containerWidth,
      "data-height": containerHeight,
      width: cssScaling ? containerWidth : width,
      height: containerHeight,
      showOverflowContent,
      userSelect,
      ref: canvasRef
    }, others),
    /* @__PURE__ */ react_default.createElement(
      Background,
      {
        "data-test": "canvas",
        "data-width": width,
        "data-height": height,
        "data-scale": scale,
        height,
        scale: cssScaling ? scale : void 0,
        bgColor: backgroundColor
      },
      /* @__PURE__ */ react_default.createElement(
        BackgroundImage,
        {
          src: backgroundImageSrc,
          sizeType: backgroundImageSizeType,
          imageWidth: backgroundImageWidth,
          imageHeight: backgroundImageHeight,
          imageX: backgroundImagePositionX,
          imageY: backgroundImagePositionY,
          opacity: backgroundImageOpacity
        }
      ),
      /* @__PURE__ */ react_default.createElement(CanvasBorder, { showBorder }),
      /* @__PURE__ */ react_default.createElement(
        CanvasGridlines,
        {
          showGrid,
          gridLineOpacity,
          gridPadding,
          gridLineWidth,
          gridLineColor,
          gridWidth,
          gridHeight
        }
      ),
      children
    )
  );
};
var Canvas_default = (0, react_exports.forwardRef)(Canvas);

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport14 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// src/components/SelectBox.jsx
var SelectDiv = styled_components_default.div.attrs(({ x, y, w, h }) => ({
  style: {
    width: w,
    height: h,
    transform: `translate(${x}px, ${y}px)`
  }
}))`
    ${themes_exports.mixins.reset("block")};
    position: absolute;
    background: transparent;
    // the next line is important to avoid blocking the drilldowns, and it allows to select text from visualizations
    pointer-events: none;
    border: 1px solid
        ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    z-index: 1000;
`;
var Wrapper = styled_components_default.div`
    ${themes_exports.mixins.reset("block")};
    background: transparent;
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
`;
var SelectBox = ({ start, end }) => /* @__PURE__ */ react_default.createElement(Wrapper, null, /* @__PURE__ */ react_default.createElement(
  SelectDiv,
  {
    w: Math.abs(start.x - end.x),
    h: Math.abs(start.y - end.y),
    x: Math.min(start.x, end.x),
    y: Math.min(start.y, end.y)
  }
));
SelectBox.propTypes = {
  /**
   * starting position
   */
  start: prop_types_default.shape({
    x: prop_types_default.number,
    y: prop_types_default.number
  }),
  /**
   * end position
   */
  end: prop_types_default.shape({
    x: prop_types_default.number,
    y: prop_types_default.number
  })
};
var SelectBox_default = SelectBox;

// src/utils/findStatusIcon.ts
var findStatusIcon = ({
  canvasRef,
  id
}) => {
  const canvas = canvasRef == null ? void 0 : canvasRef.current;
  if (!canvas) {
    return null;
  }
  return canvas.querySelector(
    `[data-id="${id}"] [data-test="simple-status-icon-container"]`
  );
};

// src/components/AbsoluteCanvas.tsx
var defaultState = {
  startPosition: null,
  currentPosition: null,
  isMoving: false,
  isSelecting: false
};
var DEFAULT_SELECTED_LAYOUT_ITEMS = [];
var AbsoluteCanvas = (props) => {
  const _a = props, {
    scale,
    children,
    canvasRef,
    blockItems,
    onItemMove = dashboard_utils_exports.noop,
    onItemMoved = dashboard_utils_exports.noop,
    onItemSelected,
    movable = false,
    allowMultiselect,
    selectedLayoutItems = DEFAULT_SELECTED_LAYOUT_ITEMS,
    initialState = defaultState,
    onMouseDownCapture,
    onMouseUpCapture
  } = _a, canvasProps = __objRest(_a, [
    "scale",
    "children",
    "canvasRef",
    "blockItems",
    "onItemMove",
    "onItemMoved",
    "onItemSelected",
    "movable",
    "allowMultiselect",
    "selectedLayoutItems",
    "initialState",
    "onMouseDownCapture",
    "onMouseUpCapture"
  ]);
  const [startPosition, setStartPosition] = (0, react_exports.useState)(
    initialState.startPosition
  );
  const [currentPosition, setCurrentPosition] = (0, react_exports.useState)(
    initialState.currentPosition
  );
  const [isMoving, setIsMoving] = (0, react_exports.useState)(initialState.isMoving);
  const [isSelecting, setIsSelecting] = (0, react_exports.useState)(initialState.isSelecting);
  const isMovingRef = (0, react_exports.useRef)(false);
  const { isMouseDownOnItemWithHandle, setIsMouseDownOnItemWithHandle } = (0, dashboard_context_exports.useMouseEventsContext)();
  const isMetaKeyUsed = (0, react_exports.useRef)(false);
  const isSelectedWithMetaKey = (0, react_exports.useRef)(false);
  const isMacOS = (0, dashboard_utils_exports.isMac)();
  const profiler = (0, dashboard_telemetry_exports.useDashboardProfiler)();
  const resetState = (0, react_exports.useCallback)(() => {
    setStartPosition(defaultState.startPosition);
    setCurrentPosition(defaultState.currentPosition);
    setIsMoving(defaultState.isMoving);
    setIsSelecting(defaultState.isSelecting);
    isMovingRef.current = false;
    isMetaKeyUsed.current = false;
    isSelectedWithMetaKey.current = false;
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isMovingRef.current && blockItems && (profiler == null ? void 0 : profiler.hasPartialMeasurement(dashboard_telemetry_exports.VIZ_MOVE_EVENT))) {
      profiler == null ? void 0 : profiler.endMeasurement(dashboard_telemetry_exports.VIZ_MOVE_EVENT);
    }
  }, [blockItems, profiler]);
  (0, react_exports.useEffect)(() => {
    if (selectedLayoutItems.length) {
      profiler == null ? void 0 : profiler.emitAndClearTimer({
        timerName: dashboard_telemetry_exports.VIZ_SELECT_EVENT,
        metadata: {
          numOfSelectedItems: selectedLayoutItems.length
        }
      });
    }
  }, [profiler, selectedLayoutItems]);
  const handleItemSelected = (0, react_exports.useCallback)(
    (e, items = []) => {
      if (items.some(
        ({ id, type }) => {
          var _a2;
          return type === "input" && ((_a2 = findStatusIcon({ canvasRef, id })) == null ? void 0 : _a2.contains(
            e.target
          ));
        }
      )) {
        return;
      }
      profiler == null ? void 0 : profiler.startTimer({
        timerName: dashboard_telemetry_exports.VIZ_SELECT_EVENT
      });
      if (isMacOS && e.metaKey || !isMacOS && e.ctrlKey) {
        const selectedItems = selectedLayoutItems.filter(
          ({ type }) => type === "block" || type === "input"
        );
        isSelectedWithMetaKey.current = true;
        onItemSelected(e, (0, lodash_exports.uniqBy)([...selectedItems, ...items], "id"));
      } else {
        onItemSelected(e, items);
      }
    },
    [canvasRef, profiler, selectedLayoutItems, onItemSelected, isMacOS]
  );
  const handleMouseDownOnItem = (0, react_exports.useCallback)(
    (event, blockItem) => {
      if (isMacOS && event.metaKey || !isMacOS && event.ctrlKey) {
        isMetaKeyUsed.current = true;
      }
      const { id, type = "block" } = blockItem;
      if (selectedLayoutItems.find(
        ({ id: selectedId }) => selectedId === id
      )) {
        return;
      }
      handleItemSelected(event, [{ id, type }]);
    },
    [handleItemSelected, selectedLayoutItems, isMacOS]
  );
  const handleMouseMove = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (!startPosition) {
      return;
    }
    const newPosition = computeRelativePosition(e, canvasRef, scale);
    const offset = getOffset(newPosition, startPosition);
    if (isMoving && considerMoved(offset)) {
      e.stopImmediatePropagation();
      e.preventDefault();
      onItemMove(e, offset);
    }
    setCurrentPosition(newPosition);
  });
  const handleMouseUpWithMetaKey = (event, item) => {
    var _a2;
    if (!item) {
      return;
    }
    const { item: itemId } = item;
    if (itemId && isMetaKeyUsed.current && !isSelectedWithMetaKey.current) {
      const selectedItems = selectedLayoutItems.filter(
        ({ type }) => type === "block" || type === "input"
      );
      const alreadySelected = selectedItems.filter(
        (element) => element.id === itemId
      );
      if (alreadySelected.length) {
        const removedAlreadySelected = selectedItems.filter(
          (element) => element.id !== itemId
        );
        onItemSelected(
          event,
          (0, lodash_exports.uniqBy)([...removedAlreadySelected], "id")
        );
      } else {
        handleItemSelected(event, [
          { id: itemId, type: (_a2 = item == null ? void 0 : item.type) != null ? _a2 : "block" }
        ]);
      }
    }
  };
  const handleMouseUp = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (!startPosition) {
      return;
    }
    e.preventDefault();
    const curPosition = computeRelativePosition(e, canvasRef, scale);
    const offset = getOffset(curPosition, startPosition);
    const isMoved = considerMoved(offset);
    if (isMoving && isMoved) {
      isMovingRef.current = false;
      onItemMoved(e, offset);
    } else if (isSelecting) {
      const boundary = positionsToBoundary(startPosition, curPosition);
      const selectedBlocks = filterBlockItemsByBoundary(
        blockItems,
        boundary
      ).map(
        ({ item, type = "block" }) => ({
          id: item,
          type
        })
      );
      let selectedBlockItems = [];
      if (!isMoved && selectedBlocks.length) {
        selectedBlockItems.push((0, lodash_exports.last)(selectedBlocks));
      } else {
        selectedBlockItems = selectedBlocks;
      }
      handleItemSelected(e, selectedBlockItems);
    } else {
      const item = findTopBlockItemByPosition(blockItems, curPosition);
      const { item: itemId, type = "block" } = item != null ? item : {};
      if (isMetaKeyUsed.current) {
        handleMouseUpWithMetaKey(e, item);
      } else if (itemId && !(selectedLayoutItems.length === 1 && selectedLayoutItems[0].id === itemId) && !isMoved && !isMetaKeyUsed.current) {
        handleItemSelected(e, [{ id: itemId, type }]);
      } else if (!itemId && !findTopBlockItemByPosition(blockItems, startPosition)) {
        handleItemSelected(e, []);
      }
    }
    resetState();
  });
  const handleMouseDown = (0, dashboard_ui_exports.useEventCallback)(
    (e, selectedBlockItem) => {
      if (isMouseDownOnItemWithHandle == null ? void 0 : isMouseDownOnItemWithHandle.current) {
        setIsMouseDownOnItemWithHandle(false);
        return;
      }
      const pos = computeRelativePosition(e, canvasRef, scale);
      setStartPosition(pos);
      const block = selectedBlockItem != null ? selectedBlockItem : findTopBlockItemByPosition(blockItems, pos);
      if (!block) {
        if (allowMultiselect) {
          setIsSelecting(true);
        }
        return;
      }
      const { item, type } = block;
      handleMouseDownOnItem(e, {
        id: item,
        type
      });
      if (movable) {
        setIsMoving(true);
        isMovingRef.current = true;
      }
    }
  );
  const handleMouseDownCapture = (0, dashboard_ui_exports.useEventCallback)((e) => {
    onMouseDownCapture == null ? void 0 : onMouseDownCapture(e);
    const pos = computeRelativePosition(e, canvasRef, scale);
    const selectedBlockItems = blockItems.filter(
      (item) => selectedLayoutItems.some(
        (selectedItem) => selectedItem.id === item.item
      )
    );
    const topSelectedBlock = findTopBlockItemByPosition(
      selectedBlockItems,
      pos
    );
    const topBlock = findTopBlockItemByPosition(blockItems, pos);
    if (topSelectedBlock && topSelectedBlock !== topBlock) {
      handleMouseDown(e, topSelectedBlock);
      e.stopPropagation();
      e.preventDefault();
    }
  });
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mousemove", handleMouseMove, true);
    return () => {
      document.removeEventListener("mousemove", handleMouseMove, true);
    };
  }, [handleMouseMove]);
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mouseup", handleMouseUp);
    return () => {
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [handleMouseUp]);
  useMouseDownWithHandleEventListeners({
    handleMouseDownOnItem,
    canvasRef,
    scale,
    setStartPosition,
    movable,
    setIsMoving,
    isMovingRef
  });
  const selectBox = (0, react_exports.useMemo)(() => {
    if (allowMultiselect && isSelecting && !isMoving && startPosition && currentPosition) {
      return /* @__PURE__ */ react_default.createElement(SelectBox_default, { start: startPosition, end: currentPosition });
    }
    return null;
  }, [
    allowMultiselect,
    isSelecting,
    isMoving,
    startPosition,
    currentPosition
  ]);
  return /* @__PURE__ */ react_default.createElement(
    Canvas_default,
    __spreadProps(__spreadValues({
      ref: canvasRef
    }, canvasProps), {
      scale,
      onMouseDown: handleMouseDown,
      onContextMenu: resetState,
      onMouseDownCapture: handleMouseDownCapture,
      onMouseUpCapture
    }),
    selectBox,
    children
  );
};
var AbsoluteCanvas_default = (0, react_exports.forwardRef)((props, ref) => {
  return /* @__PURE__ */ react_default.createElement(AbsoluteCanvas, __spreadValues({ canvasRef: ref }, props));
});

// src/components/AbsoluteItem.jsx
var AbsoluteDiv = styled_components_default.div.attrs(({ x, y, w, h }) => ({
  style: {
    width: w,
    height: h,
    top: `${y}px`,
    left: `${x}px`
  }
}))`
    display: block;
    position: absolute;
    background: transparent;
`;
var AbsoluteItem = ({
  itemId,
  type = "block",
  x,
  y,
  w,
  h,
  renderLayoutItem
}) => /* @__PURE__ */ react_default.createElement(
  AbsoluteDiv,
  {
    x,
    y,
    w,
    h,
    "data-test": "absolute-item",
    "data-x": x,
    "data-y": y,
    "data-w": w,
    "data-h": h
  },
  renderLayoutItem(
    itemId,
    {
      width: w,
      height: h
    },
    type
  )
);
AbsoluteItem.propTypes = {
  itemId: prop_types_default.string.isRequired,
  type: prop_types_default.string,
  x: prop_types_default.number.isRequired,
  y: prop_types_default.number.isRequired,
  w: prop_types_default.number.isRequired,
  h: prop_types_default.number.isRequired,
  renderLayoutItem: prop_types_default.func.isRequired
};

// src/components/ActionMenuPortal.ts
var ActionMenuPortal = styled_components_default.div.attrs((props) => ({
  "data-test": "action-menu-portal",
  style: {
    width: props.w,
    top: props.y + props.h,
    left: props.x
  }
}))`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: all;
    box-sizing: border-box;
    height: 0px;
    z-index: ${(props) => props.zIndex};
`;
var ActionMenuPortal_default = ActionMenuPortal;

// src/components/Edge.tsx
var EdgeWrapper = styled_components_default.div.attrs(
  ({ x, y, w, h }) => {
    return {
      style: {
        width: w,
        height: h,
        transform: `translate(${x}px, ${y}px)`
      }
    };
  }
)`
    display: block;
    position: absolute;
    background: transparent;
    box-sizing: border-box;

    &:hover {
        cursor: ${(props) => props.orientation === "vertical" ? "col-resize" : "row-resize"};
        background: ${(0, themes_exports.pickVariant)("appearance", {
  invalid: dashboard_ui_exports.customThemeVariables.invalidDropTargetBackgroundColor,
  dropTarget: dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor,
  normal: "transparent",
  hidden: "transparent"
})};
        border: ${(0, themes_exports.pickVariant)("appearance", {
  invalid: `1px solid ${dashboard_ui_exports.customThemeVariables.invalidDropTargetBorderColor}`,
  dropTarget: `1px solid ${dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor}`,
  normal: "none",
  hidden: "none"
})};
        transition: background 0.2s ease-out;
    }
`;
var EdgeComponent = styled_components_default.div.attrs(
  ({ x, y, w, h }) => {
    return {
      style: {
        width: w,
        height: h,
        transform: `translate(${x}px, ${y}px)`
      }
    };
  }
)`
    display: block;
    position: absolute;
    opacity: 0.35;
    pointer-events: none;
    background-color: ${(props) => props.appearance === "dropTarget" ? dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor : (0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    ${EdgeWrapper}:hover + & {
        opacity: 0.7;
    }
`;
var Edge = ({
  itemId,
  x,
  y,
  h,
  w,
  orientation,
  isCanvasEdge,
  padding = 0,
  appearance = "normal",
  onMouseDown,
  "data-test-edge-position": edgePositionTestHook
}) => {
  const handleMouseDown = (0, react_exports.useCallback)(
    (e) => {
      e.preventDefault();
      e.stopPropagation();
      onMouseDown(e, { id: itemId });
    },
    [onMouseDown, itemId]
  );
  if (appearance === "hidden" || isCanvasEdge && appearance !== "dropTarget" && (orientation === "vertical" || y + padding === 0)) {
    return null;
  }
  const coord = { x, y, w, h };
  const shift = padding / 2;
  if (orientation === "horizontal") {
    coord.y += shift;
    coord.h -= padding;
  }
  if (orientation === "vertical") {
    coord.x += shift;
    coord.w -= padding;
  }
  return /* @__PURE__ */ react_default.createElement(react_default.Fragment, null, /* @__PURE__ */ react_default.createElement(
    EdgeWrapper,
    {
      x,
      y,
      w,
      h,
      orientation,
      appearance,
      onMouseDown: handleMouseDown,
      "data-test": "edge",
      "data-test-edge-position": edgePositionTestHook
    }
  ), /* @__PURE__ */ react_default.createElement(
    EdgeComponent,
    {
      x: coord.x,
      y: coord.y,
      w: coord.w,
      h: coord.h,
      appearance
    }
  ));
};

// src/components/ErrorMessageOverlay.tsx
var ErrorOverlay = styled_components_default.div`
    position: absolute;
    box-sizing: border-box;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    pointer-events: none;
    background-color: ${(0, themes_exports.pick)({
  light: "#a81916cc",
  dark: "#a81916b3"
})};
    color: white;
    overflow: hidden;
    padding: 8px;
    z-index: 2;
`;
var MessageContainer = styled_components_default.div`
    padding-top: 8px;
`;
var OverlayTitle = styled_components_default.div`
    font-weight: bold;
`;
var ErrorMessageOverlay = ({ messages }) => {
  if (!Array.isArray(messages) || messages.length === 0) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(ErrorOverlay, { "data-test": "error-overlay" }, /* @__PURE__ */ react_default.createElement(OverlayTitle, null, (0, i18n_exports._)("Layout Errors:")), messages.map((message) => /* @__PURE__ */ react_default.createElement(
    MessageContainer,
    {
      "data-test": "error-overlay-message",
      key: message
    },
    message
  )));
};

// src/components/GridCanvas.tsx
var defaultState2 = {
  startPosition: null,
  isMoving: false
};
var DEFAULT_SELECTED_LAYOUT_ITEMS2 = [];
var noop3 = () => void 0;
var GridCanvas = (props) => {
  const _a = props, {
    movable = false,
    selectable = false,
    selectedLayoutItems = DEFAULT_SELECTED_LAYOUT_ITEMS2,
    panelPadding = 0,
    scale = 1,
    onItemMove = noop3,
    onItemMoved = noop3,
    onItemSelected,
    children,
    canvasRef,
    blockItems
  } = _a, canvasProps = __objRest(_a, [
    "movable",
    "selectable",
    "selectedLayoutItems",
    "panelPadding",
    "scale",
    "onItemMove",
    "onItemMoved",
    "onItemSelected",
    "children",
    "canvasRef",
    "blockItems"
  ]);
  const { enableGridLayoutCssScaling } = (0, dashboard_context_exports.useFeatureFlags)();
  const [startPosition, setStartPosition] = (0, react_exports.useState)(
    defaultState2.startPosition
  );
  const [isMoving, setIsMoving] = (0, react_exports.useState)(defaultState2.isMoving);
  const { isMouseDownOnItemWithHandle, setIsMouseDownOnItemWithHandle } = (0, dashboard_context_exports.useMouseEventsContext)();
  const resetState = (0, react_exports.useCallback)(() => {
    setIsMoving(defaultState2.isMoving);
    setStartPosition(defaultState2.startPosition);
  }, []);
  const mouseScale = enableGridLayoutCssScaling ? scale : 1;
  const handleItemSelected = (0, react_exports.useCallback)(
    (e, itemIds = []) => {
      if (itemIds.some(
        ({ id, type }) => {
          var _a2;
          return type === "input" && ((_a2 = findStatusIcon({ canvasRef, id })) == null ? void 0 : _a2.contains(
            e.target
          ));
        }
      )) {
        return;
      }
      if (e.metaKey) {
        const selectedItems = selectedLayoutItems.filter(
          ({ type }) => type === "block"
        );
        onItemSelected(e, (0, lodash_exports.uniqBy)([...selectedItems, ...itemIds], "id"));
      } else {
        onItemSelected(e, itemIds);
      }
    },
    [canvasRef, selectedLayoutItems, onItemSelected]
  );
  const handleMouseDownOnItem = (0, react_exports.useCallback)(
    (event, blockItem) => {
      const { id, type = "block" } = blockItem;
      if (!selectedLayoutItems.find(
        ({ id: selectedId }) => selectedId === id
      )) {
        handleItemSelected(event, [{ id, type }]);
      }
    },
    [handleItemSelected, selectedLayoutItems]
  );
  const handleMouseDown = (0, react_exports.useCallback)(
    (e) => {
      if (isMouseDownOnItemWithHandle == null ? void 0 : isMouseDownOnItemWithHandle.current) {
        setIsMouseDownOnItemWithHandle(false);
        return;
      }
      const pos = computeRelativePosition(e, canvasRef, mouseScale);
      const block = findTopBlockItemByPosition(
        blockItems,
        pos,
        panelPadding
      );
      if (selectable) {
        setStartPosition(pos);
      }
      if (block) {
        handleMouseDownOnItem(e, {
          id: block.item,
          type: block.type
        });
        if (movable) {
          setIsMoving(true);
        }
      }
    },
    [
      isMouseDownOnItemWithHandle,
      canvasRef,
      mouseScale,
      blockItems,
      panelPadding,
      selectable,
      setIsMouseDownOnItemWithHandle,
      handleMouseDownOnItem,
      movable
    ]
  );
  const handleMouseMove = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (startPosition) {
      const currentPosition = computeRelativePosition(
        e,
        canvasRef,
        mouseScale
      );
      if (currentPosition) {
        const offset = getOffset(currentPosition, startPosition);
        if (isMoving && considerMoved(offset)) {
          e.preventDefault();
          onItemMove(e, { currentPosition });
        }
      }
    }
  });
  const handleMouseUp = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (startPosition) {
      const currentPosition = computeRelativePosition(
        e,
        canvasRef,
        mouseScale
      );
      if (currentPosition) {
        const offset = getOffset(currentPosition, startPosition);
        if (isMoving && considerMoved(offset)) {
          onItemMoved(e, offset);
        } else {
          let blocks = blockItems;
          if (panelPadding) {
            blocks = blocks.map(
              (block) => applyVizPadding({
                item: block,
                padding: panelPadding
              })
            );
          }
          const boundary = positionsToBoundary(
            startPosition,
            currentPosition
          );
          const selectedBlocks = filterBlockItemsByBoundary(
            blocks,
            boundary
          ).map(({ item, type = "block" }) => ({
            id: item,
            type
          }));
          const topItem = selectedBlocks[selectedBlocks.length - 1];
          handleItemSelected(e, topItem ? [topItem] : []);
        }
        resetState();
      }
    }
  });
  useMouseDownWithHandleEventListeners({
    handleMouseDownOnItem,
    canvasRef,
    scale: mouseScale,
    setStartPosition,
    movable,
    setIsMoving
  });
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mouseup", handleMouseUp);
    return () => {
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [handleMouseUp]);
  (0, dashboard_ui_exports.useMouseMoveHandler)({ onMouseMove: handleMouseMove, isEnabled: movable });
  return /* @__PURE__ */ react_default.createElement(
    Canvas_default,
    __spreadProps(__spreadValues({
      ref: canvasRef
    }, canvasProps), {
      scale,
      onMouseDown: handleMouseDown,
      onContextMenu: resetState,
      cssScaling: enableGridLayoutCssScaling,
      showGrid: false
    }),
    children
  );
};
var GridCanvas_default = (0, react_exports.forwardRef)(
  (props, ref) => /* @__PURE__ */ react_default.createElement(GridCanvas, __spreadValues({ canvasRef: ref }, props))
);

// src/components/GridItem.tsx
var GridDiv = styled_components_default.div`
    height: 100%;
    width: 100%;
    grid-row: ${(props) => props.id}-start / ${(props) => props.id}-end;
    grid-column: ${(props) => props.id}-start / ${(props) => props.id}-end;
    background: transparent;
`;
var GridItem = ({
  itemId,
  type = "block",
  renderLayoutItem
}) => /* @__PURE__ */ react_default.createElement(GridDiv, { id: itemId, "data-test": "grid-item" }, renderLayoutItem(itemId, { width: "100%", height: "100%" }, type));
GridItem.propTypes = {
  itemId: prop_types_default.string.isRequired,
  type: prop_types_default.string,
  renderLayoutItem: prop_types_default.func.isRequired
};

// src/components/ItemDragPlaceholder.tsx
var Placeholder = styled_components_default.div.attrs(
  ({ position }) => ({
    style: positionToStyle(position)
  })
)`
    background-color: ${(0, themes_exports.pick)({
  enterprise: {
    light: themes_exports.variables.backgroundColorHover,
    dark: themes_exports.variables.neutral300
  },
  prisma: themes_exports.variables.interactiveColorOverlayDrag
})};
    opacity: 0.75;
    user-select: none;
    position: absolute;
    flex-direction: column;
    top: 0;
    left: 0;
    cursor: move;
`;
var ItemDragPlaceholder = ({
  position,
  size = 128
}) => {
  const placeHolderPosition = (0, react_exports.useMemo)(() => {
    return {
      // update x and y to be the center of the placeholder
      x: position.x - Math.round(size / 2),
      y: position.y - Math.round(size / 2),
      w: size,
      h: size
    };
  }, [position, size]);
  return /* @__PURE__ */ react_default.createElement(
    Placeholder,
    {
      "data-test": "item-drag-placeholder",
      position: placeHolderPosition
    }
  );
};

// src/components/ItemDropTarget.jsx
var DropTarget = styled_components_default.div.attrs(({ position }) => ({
  style: positionToStyle(position)
}))`
    background-color: ${(0, themes_exports.pickVariant)("validDropTarget", {
  true: dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor,
  false: dashboard_ui_exports.customThemeVariables.invalidDropTargetBackgroundColor
})};
    border-width: '1px';
    border-style: 'solid';
    border-color: ${(0, themes_exports.pickVariant)("validDropTarget", {
  true: dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor,
  false: dashboard_ui_exports.customThemeVariables.invalidDropTargetBorderColor
})};
    user-select: none;
    position: absolute;
    pointer-events: none;
`;
var ItemDropTarget = ({ position, direction }) => {
  const validDropTarget = (direction === "e" || direction === "w") && position.w >= 128 || (direction === "n" || direction === "s") && position.h >= 128;
  const dropTargetPosition = (0, react_exports.useMemo)(() => {
    let updatedPosition = null;
    switch (direction) {
      case "n":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          h: ITEM_DROP_TARGET_PX
        });
        break;
      case "s":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          y: position.y + position.h - ITEM_DROP_TARGET_PX,
          h: ITEM_DROP_TARGET_PX
        });
        break;
      case "w":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          w: ITEM_DROP_TARGET_PX
        });
        break;
      case "e":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          x: position.x + position.w - ITEM_DROP_TARGET_PX,
          w: ITEM_DROP_TARGET_PX
        });
        break;
      default:
        updatedPosition = position;
        break;
    }
    return updatedPosition;
  }, [position, direction]);
  if (validDropTarget) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(
    DropTarget,
    {
      "data-test": "item-drop-target",
      position: dropTargetPosition,
      validDropTarget
    }
  );
};
ItemDropTarget.propTypes = {
  position: prop_types_default.shape({
    x: prop_types_default.number.isRequired,
    y: prop_types_default.number.isRequired,
    w: prop_types_default.number.isRequired,
    h: prop_types_default.number.isRequired
  }).isRequired,
  direction: prop_types_default.oneOf(["n", "s", "w", "e"]).isRequired
};

// src/components/Layer.tsx
var Layer = styled_components_default.div`
    position: absolute;
    top: 0px;
    left: 0px;
    right: 0px;
    bottom: 0px;
    pointer-events: none;
    z-index: ${(props) => props.zIndex};
`;
var Layer_default = Layer;

// esm-externals:@splunk/react-icons/enterprise/Plus
var Plus_exports = {};
__export(Plus_exports, {
  default: () => Plus_default
});
var defaultImport15 = __toESM(require("@splunk/react-icons/enterprise/Plus"));
__reExport(Plus_exports, require("@splunk/react-icons/enterprise/Plus"));
var Plus_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// src/utils/outlineUtils.ts
var getVerticalPosition = (dir, offset) => {
  if (dir[0] === "n") {
    return `top: -${offset}px`;
  }
  if (dir[0] === "s") {
    return `bottom: -${offset}px`;
  }
  return `top: calc(50% - ${offset}px)`;
};
var getHorizontalPosition = (dir, offset) => {
  if (dir.slice(-1) === "w") {
    return `left: -${offset}px`;
  }
  if (dir.slice(-1) === "e") {
    return `right: -${offset}px`;
  }
  return `left: calc(50% - ${offset}px)`;
};

// src/components/Port.tsx
var portOffset = 8;
var PORT_DIRECTIONS = ["n", "e", "s", "w"];
var PortContainer = styled_components_default.div.attrs(({ port }) => ({
  "data-test": "port",
  "data-test-port": port
}))`
    text-align: center;
    width: 16px;
    height: 16px;
    line-height: 16px;
    box-sizing: border-box;
    border-radius: 50%;
    position: absolute;
    color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    ${({ port }) => getVerticalPosition(port, portOffset)};
    ${({ port }) => getHorizontalPosition(port, portOffset)};
    z-index: 999;
    pointer-events: auto;
    user-select: none;
    &:hover {
        background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    }
`;
var Port = ({
  port,
  onMouseEnter,
  onMouseLeave
}) => /* @__PURE__ */ react_default.createElement(
  PortContainer,
  {
    port,
    onMouseEnter,
    onMouseLeave
  },
  /* @__PURE__ */ react_default.createElement(Plus_default, null)
);

// src/components/PreviewPlaceholderItem.jsx
var PlaceholderComponent = styled_components_default.div.attrs(({ position }) => ({
  style: {
    width: position.w,
    height: position.h,
    transform: `translate(${position.x}px, ${position.y}px)`
  }
}))`
    display: block;
    position: absolute;
    pointer-events: none;
    box-sizing: border-box;
    border: 1px solid ${dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor};
    background-color: ${dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor};
`;
var PreviewPlaceholderItem = ({ position }) => {
  return /* @__PURE__ */ react_default.createElement(
    PlaceholderComponent,
    {
      position,
      "data-test": "preview-placeholder",
      "data-test-preview-position": `${position.x},${position.y}-${position.w},${position.h}`
    }
  );
};
PreviewPlaceholderItem.propTypes = {
  position: prop_types_default.shape({
    x: prop_types_default.number.isRequired,
    y: prop_types_default.number.isRequired,
    w: prop_types_default.number.isRequired,
    h: prop_types_default.number.isRequired
  }).isRequired
};

// esm-externals:@splunk/ui-utils/format
var format_exports = {};
__export(format_exports, {
  default: () => format_default
});
var defaultImport16 = __toESM(require("@splunk/ui-utils/format"));
__reExport(format_exports, require("@splunk/ui-utils/format"));
var format_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// src/components/ResizeHandle.tsx
var resizeHandleOffset = 7;
var computeCursor = (dir) => {
  switch (dir) {
    case "n":
    case "s":
      return "ns-resize";
    case "e":
    case "w":
      return "ew-resize";
    case "ne":
    case "sw":
      return "nesw-resize";
    case "se":
    case "nw":
    default:
      return "nwse-resize";
  }
};
var computeDirection = (dir) => {
  switch (dir) {
    case "n":
      return (0, i18n_exports._)("North");
    case "s":
      return (0, i18n_exports._)("South");
    case "e":
      return (0, i18n_exports._)("East");
    case "w":
      return (0, i18n_exports._)("West");
    case "ne":
      return (0, i18n_exports._)("North-East");
    case "sw":
      return (0, i18n_exports._)("South-West");
    case "se":
      return (0, i18n_exports._)("South-East");
    case "nw":
      return (0, i18n_exports._)("North-West");
    default:
      return "";
  }
};
var Handle = styled_components_default.button.attrs(({ direction }) => ({
  "data-test": "handle",
  "data-test-direction": direction
}))`
    width: 10px;
    height: 10px;
    background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    border: none;
    border-radius: 20%;
    padding: 0;
    position: absolute;
    ${({ direction }) => getVerticalPosition(direction, resizeHandleOffset)};
    ${({ direction }) => getHorizontalPosition(direction, resizeHandleOffset)};
    cursor: ${({ direction }) => computeCursor(direction)};
    z-index: 999;
    pointer-events: auto;
    user-select: none;
`;
var ResizeHandle = ({
  onMouseDown,
  onKeyDown,
  direction
}) => {
  const handleMouseDown = (0, react_exports.useCallback)(
    (e) => {
      onMouseDown(e, direction);
    },
    [onMouseDown, direction]
  );
  const handleKeyDown = (0, react_exports.useCallback)(
    (e) => {
      onKeyDown(e, direction);
    },
    [onKeyDown, direction]
  );
  return /* @__PURE__ */ react_default.createElement(
    Handle,
    {
      "aria-label": (0, format_exports.sprintf)((0, i18n_exports._)("Move %(direction)s direction"), {
        direction: computeDirection(direction)
      }),
      direction,
      onMouseDown: handleMouseDown,
      onKeyDown: handleKeyDown
    }
  );
};

// src/components/ResponsiveBox.tsx
var ResponsiveBox = styled_components_default.div.attrs(
  ({ itemId, x, y, w, h, "data-test": dataTest, zIndex }) => {
    const attributes = {
      "data-test": dataTest != null ? dataTest : "responsive-box",
      "data-id": itemId,
      "data-test-viz-item-position": `${x},${y},${w},${h}`,
      style: {
        width: `${w}px`,
        height: `${h}px`,
        top: `${y}px`,
        left: `${x}px`,
        zIndex
      }
    };
    if (!zIndex) {
      delete attributes.style.zIndex;
    }
    return attributes;
  }
)`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: none;
    box-sizing: border-box;
    visibility: ${(props) => {
  return props.appearance === "hidden" ? "hidden" : "visible";
}};
    opacity: ${(props) => props.appearance === "highlighted" ? 1 : 0.5};
`;
ResponsiveBox.defaultProps = {
  appearance: "highlighted"
};
var ResponsiveBox_default = ResponsiveBox;

// src/components/DragHandlePortal.tsx
var DragHandlePortal = styled_components_default.div.attrs(
  (props) => ({
    "data-test": "drag-handle-portal",
    style: {
      width: props.w,
      top: props.y,
      left: props.x
    }
  })
)`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: all;
    box-sizing: border-box;
    height: 0px;
    z-index: ${(props) => props.zIndex};
    visibility: ${({ isHidden }) => isHidden ? "hidden" : "visible"};
`;

// src/components/ResponsiveBlockItem.tsx
var defaultPortalState = Object.freeze({
  current: null
});
var ResponsiveBlockItem = ({
  x: originalX,
  y: originalY,
  w: originalW,
  h: originalH,
  canvasHeight,
  padding,
  itemId,
  type = "block",
  errorMessages,
  onItemSelected,
  renderLayoutItem,
  appearance = "highlighted",
  isMouseDownEventRef
}) => {
  var _a;
  const selectIsSelected = (0, react_exports.useMemo)(dashboard_state_exports.makeSelectIsSelected, []);
  const mode = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectMode);
  const isSelected = (0, dashboard_state_exports.useSelector)((state) => selectIsSelected(state, itemId));
  const [isClicked, setIsClicked] = (0, react_exports.useState)(false);
  const [actionMenuPortal, setActionMenuPortal] = (0, react_exports.useState)(defaultPortalState);
  const [dragHandlePortal, setDragHandlePortal] = (0, react_exports.useState)(defaultPortalState);
  const layerData = (0, dashboard_context_exports.useLayoutLayers)();
  const {
    layer: itemLayer,
    actionMenu: actionMenuLayer,
    dragHandle: dragHandleLayer
  } = (_a = layerData == null ? void 0 : layerData[itemId]) != null ? _a : {};
  const renderActionMenuInPortal = typeof itemLayer === "number";
  const {
    position: { x, y, w, h }
  } = applyVizPadding({
    item: {
      position: {
        x: originalX,
        y: originalY,
        w: originalW,
        h: originalH
      }
    },
    padding
  });
  const layoutItem = (0, react_exports.useMemo)(
    () => renderLayoutItem(
      itemId,
      {
        width: w,
        height: h,
        y,
        canvasHeight,
        renderActionMenuInPortal,
        actionMenuPortal,
        dragHandlePortal
      },
      type,
      onItemSelected
    ),
    [
      renderLayoutItem,
      itemId,
      type,
      w,
      h,
      y,
      canvasHeight,
      onItemSelected,
      renderActionMenuInPortal,
      actionMenuPortal,
      dragHandlePortal
    ]
  );
  const handleFocus = (0, react_exports.useCallback)(
    (event) => {
      if (isMouseDownEventRef == null ? void 0 : isMouseDownEventRef.current) {
        setIsClicked(true);
        return;
      }
      if (!event.relatedTarget) {
        return;
      }
      setIsClicked(false);
      if (
        // The tabindex was moved to the SelectableContainer (in renderLayoutItem), so we'll check that thats the target
        event.target.getAttribute("data-test") === "select-outline" && event.target.getAttribute("data-id") === itemId
      ) {
        onItemSelected(event, [{ id: itemId, type }]);
      }
    },
    [isMouseDownEventRef, itemId, onItemSelected, type]
  );
  const trackActionMenuPortal = (0, react_exports.useCallback)((element) => {
    setActionMenuPortal({ current: element });
  }, []);
  const trackDragHandlePortal = (0, react_exports.useCallback)((element) => {
    setDragHandlePortal({ current: element });
  }, []);
  const isHidden = appearance === "hidden";
  return /* @__PURE__ */ react_default.createElement(
    dashboard_ui_exports.AbsoluteItemContainer,
    {
      "data-id": itemId,
      "data-selected": `${isSelected}`,
      "data-click-focus": `${isClicked && isSelected && mode === "view"}`
    },
    /* @__PURE__ */ react_default.createElement(
      ResponsiveBox_default,
      {
        "data-test": "absolute-item",
        itemId,
        appearance,
        x,
        y,
        w,
        h,
        onFocusCapture: handleFocus
      },
      layoutItem,
      /* @__PURE__ */ react_default.createElement(ErrorMessageOverlay, { messages: errorMessages })
    ),
    renderActionMenuInPortal && /* @__PURE__ */ react_default.createElement(
      ActionMenuPortal_default,
      {
        x,
        y,
        w,
        h,
        ref: trackActionMenuPortal,
        zIndex: actionMenuLayer
      }
    ),
    /* @__PURE__ */ react_default.createElement(
      DragHandlePortal,
      {
        x,
        y,
        w,
        ref: trackDragHandlePortal,
        zIndex: dragHandleLayer,
        isHidden
      }
    )
  );
};
var ResponsiveBlockItem_default = react_default.memo(ResponsiveBlockItem);

// src/components/ResponsiveBlockOutline.tsx
var keyDirectionMap = {
  ArrowUp: ["n", "ne", "se", "s", "sw", "nw"],
  ArrowDown: ["n", "ne", "se", "s", "sw", "nw"],
  ArrowLeft: ["ne", "e", "se", "sw", "w", "nw"],
  ArrowRight: ["ne", "e", "se", "sw", "w", "nw"]
};
var isKeyAllowedCheck = (key) => Object.keys(keyDirectionMap).includes(key);
var noop4 = () => void 0;
var ResponsiveBlockOutline = ({
  itemId,
  scale = 1,
  connectable = false,
  resizable = false,
  onResize = noop4,
  onResized = noop4,
  onLineConnect = noop4,
  onLineDisconnect = noop4,
  handleDirections,
  x,
  y,
  w,
  h
}) => {
  const startPosition = (0, react_exports.useRef)(
    null
  );
  const resizing = (0, react_exports.useRef)(false);
  const resizeDir = (0, react_exports.useRef)(null);
  const keyUpOffset = (0, react_exports.useRef)({ offsetX: 0, offsetY: 0 });
  const handleResizeMouseDown = (0, react_exports.useCallback)(
    (e, dir) => {
      e.preventDefault();
      e.stopPropagation();
      startPosition.current = getClientPosition(e, scale);
      resizing.current = true;
      resizeDir.current = dir;
    },
    [scale]
  );
  const handleMouseMove = (0, react_exports.useCallback)(
    (e) => {
      if (startPosition.current && resizing.current && resizeDir.current) {
        e.preventDefault();
        const currentPosition = getClientPosition(e, scale);
        const offset = getOffset(
          currentPosition,
          startPosition.current
        );
        onResize(e, itemId, offset, resizeDir.current);
      }
    },
    [scale, onResize, itemId]
  );
  const handleMouseUp = (0, react_exports.useCallback)(
    (e) => {
      if (startPosition.current && resizing.current && resizeDir.current) {
        e.preventDefault();
        const currentPosition = getClientPosition(e, scale);
        const offset = getOffset(
          currentPosition,
          startPosition.current
        );
        startPosition.current = null;
        resizing.current = false;
        onResized(e, itemId, offset, resizeDir.current);
        resizeDir.current = null;
      }
    },
    [itemId, scale, onResized]
  );
  const handleResizeKeyDown = (0, react_exports.useCallback)(
    (e, dir) => {
      const { key } = e;
      const isKeyAllowed = isKeyAllowedCheck(key);
      const isDirectionAllowed = isKeyAllowed && keyDirectionMap[key].includes(dir);
      if (!isDirectionAllowed) {
        return;
      }
      e.preventDefault();
      e.stopPropagation();
      resizeDir.current = dir;
      if (e.key === "ArrowUp") {
        keyUpOffset.current.offsetY -= GRID_SIZE;
      }
      if (e.key === "ArrowDown") {
        keyUpOffset.current.offsetY += GRID_SIZE;
      }
      if (e.key === "ArrowLeft") {
        keyUpOffset.current.offsetX -= GRID_SIZE;
      }
      if (e.key === "ArrowRight") {
        keyUpOffset.current.offsetX += GRID_SIZE;
      }
      onResize(e, itemId, keyUpOffset.current, dir);
    },
    [itemId, onResize]
  );
  const handleKeyUp = (0, react_exports.useCallback)(
    (e) => {
      if (keyUpOffset.current && resizeDir.current) {
        onResized(e, itemId, keyUpOffset.current, resizeDir.current);
        resizeDir.current = null;
        keyUpOffset.current = { offsetX: 0, offsetY: 0 };
      }
    },
    [itemId, onResized]
  );
  const handlePortEnter = (0, react_exports.useCallback)(
    (port) => (e) => {
      e.preventDefault();
      onLineConnect(itemId, port);
    },
    [itemId, onLineConnect]
  );
  const handlePortLeave = (0, react_exports.useCallback)(
    (port) => (e) => {
      e.preventDefault();
      onLineDisconnect(itemId, port);
    },
    [itemId, onLineDisconnect]
  );
  (0, react_exports.useLayoutEffect)(() => {
    if (resizable) {
      document.addEventListener("mousemove", handleMouseMove);
    }
    return () => {
      document.removeEventListener("mousemove", handleMouseMove);
    };
  }, [resizable, handleMouseMove]);
  (0, react_exports.useLayoutEffect)(() => {
    if (resizable) {
      document.addEventListener("mouseup", handleMouseUp);
    }
    return () => {
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [resizable, handleMouseUp]);
  (0, react_exports.useLayoutEffect)(() => {
    if (resizable) {
      document.addEventListener("keyup", handleKeyUp);
    }
    return () => {
      document.removeEventListener("keyup", handleKeyUp);
    };
  }, [resizable, handleKeyUp]);
  const ResizeHandles = (0, react_exports.useMemo)(() => {
    if (!resizable) {
      return null;
    }
    return handleDirections.map((dir) => /* @__PURE__ */ react_default.createElement(
      ResizeHandle,
      {
        key: `handle-${dir}`,
        onMouseDown: handleResizeMouseDown,
        onKeyDown: handleResizeKeyDown,
        direction: dir
      }
    ));
  }, [
    resizable,
    handleDirections,
    handleResizeMouseDown,
    handleResizeKeyDown
  ]);
  const Ports = (0, react_exports.useMemo)(() => {
    if (!connectable) {
      return null;
    }
    return PORT_DIRECTIONS.map((port) => /* @__PURE__ */ react_default.createElement(
      Port,
      {
        key: `port-${port}`,
        port,
        onMouseEnter: handlePortEnter(port),
        onMouseLeave: handlePortLeave(port)
      }
    ));
  }, [connectable, handlePortEnter, handlePortLeave]);
  return /* @__PURE__ */ react_default.createElement(ResponsiveBox_default, { itemId, x, y, w, h }, ResizeHandles, Ports);
};
var ResponsiveBlockOutline_default = ResponsiveBlockOutline;

// src/components/ResponsiveLine.tsx
var LineBox = styled_components_default.div`
    position: absolute;
    pointer-events: none;
    z-index: ${(props) => props.zIndex};
`;
var AdjustHandle = styled_components_default.button.attrs(({ x, y }) => ({
  style: {
    transform: `translate(${x}px, ${y}px)`
  }
}))`
    width: 10px;
    height: 10px;
    left: -5px;
    top: -5px;
    background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    border: none;
    padding: 0;
    border-radius: 50%;
    position: absolute;
    z-index: 999;
    pointer-events: auto;
    cursor: move;
    user-select: none;
`;

// esm-externals:@splunk/dashboard-definition
var dashboard_definition_exports = {};
__export(dashboard_definition_exports, {
  default: () => dashboard_definition_default
});
var defaultImport17 = __toESM(require("@splunk/dashboard-definition"));
__reExport(dashboard_definition_exports, require("@splunk/dashboard-definition"));
var dashboard_definition_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// src/gridLayoutOptionsSchema.ts
var gridLayoutOptionsSchema_default = {
  gutterSize: {
    type: "number",
    default: 8,
    minimum: 8,
    maximum: 16,
    description: "A number that represents the size of the gutter between visualizations in pixels. The minimum value is 8 and maximum value is 16."
  },
  backgroundColor: {
    type: "string",
    description: `Specify the color of the layout background using a hex code, rgb/rgba value, an HTML color name, or a token`,
    anyOf: [
      { enum: dashboard_ui_exports.namedColors },
      { pattern: dashboard_definition_exports.COLOR_PATTERN_WITH_RGBA_AND_TOKEN }
    ]
  }
};

// src/utils/gridLayoutUtils.ts
var resetLayoutAction = (payload) => ({
  type: "structure/reset",
  payload
});
var updateItemAction = (payload) => ({
  type: "structure/update",
  payload
});
var getBlockItems = (state) => Object.values(state);
var filterSelectedItems = (state, selectedItems = []) => {
  const itemKeys = state.map(({ item }) => item);
  return selectedItems.filter(({ id }) => itemKeys.indexOf(id) >= 0);
};
var getStructureItem = (state, itemId) => state.find(({ item }) => item === itemId);
var getItem = (state, itemId) => state[itemId];
var hasPreviewItem = (state, itemId = "preview-old-item") => !!state[itemId];
var getFilteredStructure = (state, layoutStructure) => {
  const result = [];
  layoutStructure.forEach((item) => {
    result.push(state[item.item] || item);
  });
  if (hasPreviewItem(state)) {
    result.push(state["preview-old-item"]);
  }
  return result;
};
var initializeGridReducer = (layoutStructure = []) => {
  const gridLayout = {};
  layoutStructure.forEach((item) => {
    gridLayout[item.item] = item;
  });
  return gridLayout;
};
var gridReducer = (state, action) => {
  switch (action.type) {
    // TODO: handle more actions (above), to further reduce size of grid code
    // TODO: expand set of reduced state, to limit amount of non-layout data tracked in layout component
    case "structure/reset":
      return initializeGridReducer(action.payload);
    case "structure/update":
      return __spreadProps(__spreadValues({}, state), {
        [action.payload.item]: action.payload
      });
    default:
      return state;
  }
};

// src/utils/gridOrderUtils.ts
var trackItemsByCoordinate = (layout) => {
  const result = {};
  layout.forEach((item) => {
    var _a, _b;
    (_b = result[_a = item.position.y]) != null ? _b : result[_a] = {};
    result[item.position.y][item.position.x] = item;
  });
  return result;
};
var getItemsInCoordinateRange = ({
  itemCoordinateMap,
  range
}) => {
  if (!range) {
    return Object.values(itemCoordinateMap).flatMap(Object.values);
  }
  const { x: fromX = 0, y: fromY = 0 } = range.from || {};
  const {
    x: toX = Number.POSITIVE_INFINITY,
    y: toY = Number.POSITIVE_INFINITY
  } = range.to || {};
  return Object.keys(itemCoordinateMap).map((key) => parseInt(key, 10)).filter((yPos) => yPos >= fromY && yPos < toY).reduce((acc, yPos) => {
    Object.keys(itemCoordinateMap[yPos]).forEach((key) => {
      const xPos = parseInt(key, 10);
      if (xPos >= fromX && xPos < toX) {
        acc.push(itemCoordinateMap[yPos][xPos]);
      }
    });
    return acc;
  }, []);
};
var getVizAtCoord = ({
  x,
  y,
  nodes
}) => nodes[x][y].find((viz) => viz.position.x === x && viz.position.y === y);
var isFullEdge = ({
  x,
  y,
  nodes,
  gridWidth,
  gridHeight,
  type
}) => {
  if (x === gridWidth || y === gridHeight) {
    return true;
  }
  const originViz = getVizAtCoord({ x, y, nodes });
  if (!originViz) {
    return false;
  }
  return isFullEdge({
    x: type === "horizontal" ? x + originViz.position.w : x,
    y: type === "vertical" ? y + originViz.position.h : y,
    nodes,
    gridWidth,
    gridHeight,
    type
  });
};
var splitGridByRows = ({
  nodes,
  layout,
  gridWidth,
  gridHeight,
  originViz,
  alwaysIncludeLastRow = false
}) => {
  const { x, y, h } = originViz.position;
  const itemCoordinateMap = trackItemsByCoordinate(layout);
  const newGrids = [];
  let lastHorizontalEdgeY = y;
  let nextViz = getVizAtCoord({ x, y: y + h, nodes });
  while (nextViz && nextViz.position.y < gridHeight) {
    if (isFullEdge({
      x,
      y: nextViz.position.y,
      nodes,
      gridWidth,
      gridHeight,
      type: "horizontal"
    })) {
      const rowItems = getItemsInCoordinateRange({
        itemCoordinateMap,
        range: {
          from: { y: lastHorizontalEdgeY },
          to: { y: nextViz.position.y }
        }
      });
      newGrids.push({
        nodes,
        layout,
        gridWidth,
        gridHeight: nextViz.position.y,
        origin: { x, y: lastHorizontalEdgeY },
        content: {
          // the width of the split is the full grid width less the origin of the split
          width: gridWidth - x,
          // the height of the split is the top of the next split less the origin of the current split
          height: nextViz.position.y - lastHorizontalEdgeY,
          items: rowItems
        }
      });
      lastHorizontalEdgeY = nextViz.position.y;
    }
    nextViz = getVizAtCoord({
      x,
      y: nextViz.position.y + nextViz.position.h,
      nodes
    });
  }
  if (newGrids.length === 0 && !alwaysIncludeLastRow) {
    return [];
  }
  const lastRowItems = getItemsInCoordinateRange({
    itemCoordinateMap,
    range: {
      from: { y: lastHorizontalEdgeY }
    }
  });
  newGrids.push({
    nodes,
    layout,
    gridWidth,
    gridHeight,
    origin: { x, y: lastHorizontalEdgeY },
    content: {
      width: gridWidth - x,
      height: gridHeight - lastHorizontalEdgeY,
      items: lastRowItems
    }
  });
  return newGrids;
};
var splitGridByColumns = ({
  nodes,
  layout,
  gridWidth,
  gridHeight,
  originViz
}) => {
  const { x, y, w } = originViz.position;
  const itemCoordinateMap = trackItemsByCoordinate(layout);
  const newGrids = [];
  let lastVerticalEdgeX = x;
  let nextViz = getVizAtCoord({ x: x + w, y, nodes });
  while (nextViz && nextViz.position.x < gridWidth) {
    if (isFullEdge({
      x: nextViz.position.x,
      y,
      nodes,
      gridWidth,
      gridHeight,
      type: "vertical"
    })) {
      const colItems = getItemsInCoordinateRange({
        itemCoordinateMap,
        range: {
          from: { x: lastVerticalEdgeX },
          to: { x: nextViz.position.x }
        }
      });
      newGrids.push({
        nodes,
        layout,
        gridWidth: nextViz.position.x,
        gridHeight,
        origin: { x: lastVerticalEdgeX, y },
        content: {
          // the width of the split is the left-edge of the next column less the origin of the current column
          width: nextViz.position.x - lastVerticalEdgeX,
          // the height of the split is the height of the grid less the origin of the column
          height: gridHeight - y,
          items: colItems
        }
      });
      lastVerticalEdgeX = nextViz.position.x;
    }
    nextViz = getVizAtCoord({
      x: nextViz.position.x + nextViz.position.w,
      y,
      nodes
    });
  }
  if (newGrids.length === 0) {
    return [];
  }
  const lastColumnItems = getItemsInCoordinateRange({
    itemCoordinateMap,
    range: {
      from: { x: lastVerticalEdgeX }
    }
  });
  newGrids.push({
    nodes,
    layout,
    gridWidth,
    gridHeight,
    origin: { x: lastVerticalEdgeX, y },
    content: {
      width: gridWidth - lastVerticalEdgeX,
      height: gridHeight - y,
      items: lastColumnItems
    }
  });
  return newGrids;
};
var splitGridByRowsAndColumns = ({
  origin,
  nodes,
  layout,
  newLayout,
  gridWidth,
  gridHeight
}) => {
  const originViz = getVizAtCoord({ x: origin.x, y: origin.y, nodes });
  if (!originViz) {
    throw new Error("Getting grid layout order failed");
  }
  if (originViz.position.x + originViz.position.w === gridWidth && originViz.position.y + originViz.position.h === gridHeight) {
    newLayout.push(originViz);
    return;
  }
  let newGrids = splitGridByRows({
    nodes,
    layout,
    originViz,
    gridHeight,
    gridWidth
  });
  newGrids.forEach(
    (gridInfo) => splitGridByRowsAndColumns(__spreadProps(__spreadValues({}, gridInfo), { newLayout }))
  );
  if (newGrids.length > 0) {
    return;
  }
  newGrids = splitGridByColumns({
    nodes,
    layout,
    originViz,
    gridHeight,
    gridWidth
  });
  newGrids.forEach(
    (gridInfo) => splitGridByRowsAndColumns(__spreadProps(__spreadValues({}, gridInfo), { newLayout }))
  );
  if (newGrids.length === 0) {
    const vizInCurrentGrid = [];
    layout.forEach((viz) => {
      const { x, y, w, h } = viz.position;
      if (x >= origin.x && x + w <= gridWidth && y >= origin.y && y + h <= gridHeight) {
        vizInCurrentGrid.push(viz);
      }
    });
    const sortedViz = vizInCurrentGrid.sort((viz1, viz2) => {
      if (viz1.position.y < viz2.position.y) {
        return -1;
      }
      if (viz1.position.y > viz2.position.y) {
        return 1;
      }
      if (viz1.position.x < viz2.position.x) {
        return -1;
      }
      if (viz1.position.x > viz2.position.x) {
        return 1;
      }
      return 0;
    });
    newLayout.push(...sortedViz);
  }
};
var getGridLayoutOrder = ({
  layout,
  canvasWidth,
  canvasHeight
}) => {
  const nodes = getNodes(layout);
  if (nodes === null || nodes[0] === void 0 || nodes[0][0] === void 0) {
    return layout;
  }
  const newLayout = [];
  try {
    splitGridByRowsAndColumns({
      origin: { x: 0, y: 0 },
      nodes,
      layout,
      newLayout,
      gridWidth: canvasWidth,
      gridHeight: canvasHeight
    });
  } catch (e) {
    return layout;
  }
  if (newLayout.length !== layout.length) {
    return layout;
  }
  return newLayout;
};

// src/utils/gridUtils.ts
var formatEdgeWrapper = ({
  edge,
  padding = 0
}) => {
  const wrapperStart = __spreadValues({}, edge.edgeStart);
  const wrapperEnd = __spreadValues({}, edge.edgeEnd);
  if (edge.orientation === "horizontal") {
    wrapperStart.x += padding;
    wrapperEnd.x -= padding;
    wrapperStart.y -= padding;
    wrapperEnd.y -= padding;
  } else {
    wrapperStart.y += padding;
    wrapperEnd.y -= padding;
    wrapperStart.x -= padding;
    wrapperEnd.x -= padding;
  }
  return __spreadProps(__spreadValues({}, edge), { edgeStart: wrapperStart, edgeEnd: wrapperEnd });
};
var getDimensions = ({
  edge,
  thickness
}) => {
  return {
    width: edge.orientation === "horizontal" ? edge.edgeEnd.x - edge.edgeStart.x : thickness,
    height: edge.orientation === "vertical" ? edge.edgeEnd.y - edge.edgeStart.y : thickness
  };
};
var isMouseOnEdge = ({
  edge,
  mousePosition,
  padding = 0
}) => {
  const formattedEdge = formatEdgeWrapper({ edge, padding });
  const { width, height } = getDimensions({
    edge: formattedEdge,
    thickness: 2 * padding
  });
  return mousePosition.x <= formattedEdge.edgeStart.x + width && mousePosition.x >= formattedEdge.edgeStart.x && mousePosition.y <= formattedEdge.edgeStart.y + height && mousePosition.y >= formattedEdge.edgeStart.y;
};
var computeNewVizPositionsGutterCase = ({
  edge,
  itemToMove,
  items
}) => {
  const updatedVisualizations = [];
  items.forEach((item) => {
    if (item.position.y >= edge.edgeStart.y) {
      const viz = item.item === itemToMove.item ? __spreadProps(__spreadValues({}, item), { item: "itemToRemove" }) : item;
      updatedVisualizations.push(__spreadProps(__spreadValues({}, viz), {
        position: __spreadProps(__spreadValues({}, viz.position), {
          y: viz.position.y + itemToMove.position.h
        })
      }));
    }
  });
  updatedVisualizations.push(__spreadProps(__spreadValues({}, itemToMove), {
    position: __spreadProps(__spreadValues({}, itemToMove.position), {
      // height is preserved
      y: edge.edgeStart.y,
      x: edge.edgeStart.x,
      w: edge.edgeEnd.x - edge.edgeStart.x
    })
  }));
  return updatedVisualizations;
};
var sizeToTakeFromViz = ({
  amountToTake,
  edge,
  minWidth,
  minHeight
}) => {
  const reduction = edge.visualizations.reduce(
    (acc, viz) => {
      if (acc === null) {
        return null;
      }
      if (edge.orientation === "vertical") {
        const widthToTake = Math.ceil(viz.position.w * amountToTake);
        if (viz.position.w - widthToTake < minWidth) {
          return null;
        }
        if (viz.position.x < edge.edgeStart.x) {
          return __spreadProps(__spreadValues({}, acc), {
            firstHalf: [...acc.firstHalf, widthToTake]
          });
        }
        return __spreadProps(__spreadValues({}, acc), {
          secondHalf: [...acc.secondHalf, widthToTake]
        });
      }
      const heightToTake = Math.ceil(viz.position.h * amountToTake);
      if (viz.position.h - heightToTake < minHeight) {
        return null;
      }
      if (viz.position.y < edge.edgeStart.y) {
        return __spreadProps(__spreadValues({}, acc), {
          firstHalf: [...acc.firstHalf, heightToTake]
        });
      }
      return __spreadProps(__spreadValues({}, acc), {
        secondHalf: [...acc.secondHalf, heightToTake]
      });
    },
    { firstHalf: [], secondHalf: [] }
  );
  if (reduction === null) {
    return {
      firstHalf: null,
      secondHalf: null
    };
  }
  return {
    firstHalf: reduction.firstHalf.length === 0 ? 0 : Math.min(...reduction.firstHalf),
    secondHalf: reduction.secondHalf.length === 0 ? 0 : Math.min(...reduction.secondHalf)
  };
};
var computeNewVizPositions = ({
  edge,
  itemToMove,
  firstHalf,
  secondHalf
}) => {
  const updatedVisualizations = [];
  edge.visualizations.forEach((edgeViz) => {
    const viz = edgeViz.item === itemToMove.item ? __spreadProps(__spreadValues({}, edgeViz), { item: "itemToRemove" }) : edgeViz;
    if (edge.orientation === "horizontal") {
      if (viz.position.y < edge.edgeStart.y) {
        updatedVisualizations.push(
          updateBlockItemSize({
            item: __spreadValues({}, viz),
            offset: { offsetY: -1 * firstHalf, offsetX: 0 },
            dir: "s"
          })
        );
      }
      if (viz.position.y >= edge.edgeStart.y) {
        updatedVisualizations.push(
          updateBlockItemSize({
            item: __spreadValues({}, viz),
            offset: { offsetY: secondHalf, offsetX: 0 },
            dir: "n"
          })
        );
      }
    } else {
      if (viz.position.x < edge.edgeStart.x) {
        updatedVisualizations.push(
          updateBlockItemSize({
            item: __spreadValues({}, viz),
            offset: { offsetX: -1 * firstHalf, offsetY: 0 },
            dir: "e"
          })
        );
      }
      if (viz.position.x >= edge.edgeStart.x) {
        updatedVisualizations.push(
          updateBlockItemSize({
            item: __spreadValues({}, viz),
            offset: { offsetX: secondHalf, offsetY: 0 },
            dir: "w"
          })
        );
      }
    }
  });
  updatedVisualizations.push(__spreadProps(__spreadValues({}, itemToMove), {
    position: {
      x: edge.edgeStart.x - (edge.orientation === "vertical" ? firstHalf : 0),
      y: edge.edgeStart.y - (edge.orientation === "horizontal" ? firstHalf : 0),
      w: edge.orientation === "vertical" ? firstHalf + secondHalf : edge.edgeEnd.x - edge.edgeStart.x,
      h: edge.orientation === "horizontal" ? firstHalf + secondHalf : edge.edgeEnd.y - edge.edgeStart.y
    }
  }));
  return updatedVisualizations;
};
var isResultingVizSizeGreaterThanMin = ({
  size,
  edgeOrientation
}) => {
  if (edgeOrientation === "vertical") {
    return size >= MIN_WIDTH_PX;
  }
  return size >= MIN_HEIGHT_PX;
};
var updateItems = ({
  updatedVisualizations,
  itemToMove,
  items,
  canvasWidth
}) => {
  const updatedItems = [
    ...items.filter(
      (item) => updatedVisualizations.find((viz) => viz.item === item.item) === void 0
    ),
    ...updatedVisualizations
  ];
  const updatedNeighbors = (0, dashboard_utils_exports.updateRemovedVizNeighbors)({
    itemToRemove: itemToMove,
    items: updatedItems,
    width: canvasWidth
  });
  const filteredUpdatedVisualizations = updatedVisualizations.filter(
    (viz) => updatedNeighbors.find((neighbor) => neighbor.item === viz.item) === void 0 && viz.item !== "itemToRemove"
  );
  const filteredItems = items.filter(
    (viz) => updatedNeighbors.find((neighbor) => neighbor.item === viz.item) === void 0 && filteredUpdatedVisualizations.find(
      (updatedViz) => updatedViz.item === viz.item
    ) === void 0 && viz.item !== itemToMove.item
  );
  return [
    ...filteredItems,
    ...filteredUpdatedVisualizations,
    ...updatedNeighbors
  ];
};
var isDropOnOwnEdge = ({
  edge,
  itemToMove
}) => edge.visualizations.find((viz) => viz.item === itemToMove.item) != null && (edge.orientation === "horizontal" && itemToMove.position.w === edge.edgeEnd.x - edge.edgeStart.x || edge.orientation === "vertical" && itemToMove.position.h === edge.edgeEnd.y - edge.edgeStart.y);
var updateDropOnEdge = ({
  edge,
  itemToMove,
  items,
  canvasWidth
}) => {
  if (isDropOnOwnEdge({ edge, itemToMove })) {
    return null;
  }
  const amountToTake = 1 / 3;
  let updatedVisualizations = [];
  if (edge.orientation === "horizontal" && edge.edgeEnd.x - edge.edgeStart.x === canvasWidth) {
    updatedVisualizations = computeNewVizPositionsGutterCase({
      edge,
      itemToMove,
      items
    });
  } else {
    const { firstHalf, secondHalf } = sizeToTakeFromViz({
      amountToTake,
      edge,
      minWidth: MIN_WIDTH_PX,
      minHeight: MIN_HEIGHT_PX
    });
    if (firstHalf === null || secondHalf === null || // Check if the moved viz resulting size will be greater than the minimum width/height
    // This particular case occurs when adding to the top and bottom canvas edge
    !isResultingVizSizeGreaterThanMin({
      size: firstHalf + secondHalf,
      edgeOrientation: edge.orientation
    })) {
      return null;
    }
    updatedVisualizations = computeNewVizPositions({
      edge,
      itemToMove,
      firstHalf,
      secondHalf
    });
  }
  const updatedItemToMove = updatedVisualizations.find((viz) => viz.item === "itemToRemove") || itemToMove;
  return { updatedVisualizations, updatedItemToMove };
};
var positionInItemBoundary = ({
  item,
  position
}) => {
  return position.x >= item.position.x && position.x <= item.position.x + item.position.w && position.y >= item.position.y && position.y <= item.position.y + item.position.h;
};
var findQuadrant = ({
  item,
  position
}) => {
  if (positionInItemBoundary({ item, position })) {
    let { x, y } = position;
    x -= item.position.x;
    y -= item.position.y;
    const slope = item.position.h / item.position.w;
    let quadrant;
    if (y > slope * x) {
      quadrant = ["w", "s"];
    } else {
      quadrant = ["n", "e"];
    }
    return y < -slope * x + item.position.h ? quadrant[0] : quadrant[1];
  }
  return null;
};
var updateDropOnViz = ({
  itemToMove,
  itemToDropOn,
  direction
}) => {
  if ((direction === "e" || direction === "w") && itemToDropOn.position.w < MIN_WIDTH_PX * 2 || (direction === "n" || direction === "s") && itemToDropOn.position.h < MIN_WIDTH_PX * 2) {
    return null;
  }
  let vizToMove = __spreadProps(__spreadValues({}, itemToMove), {
    position: itemToDropOn.position
  });
  let vizTarget = __spreadValues({}, itemToDropOn);
  switch (direction) {
    case "n":
      vizToMove = updateBlockItemSize({
        item: vizToMove,
        offset: {
          offsetY: -Math.floor(vizToMove.position.h / 2),
          offsetX: 0
        },
        dir: "s"
      });
      vizTarget = updateBlockItemSize({
        item: vizTarget,
        offset: {
          offsetY: Math.ceil(vizTarget.position.h / 2),
          offsetX: 0
        },
        dir: "n"
      });
      break;
    case "s":
      vizToMove = updateBlockItemSize({
        item: vizToMove,
        offset: {
          offsetY: Math.floor(vizToMove.position.h / 2),
          offsetX: 0
        },
        dir: "n"
      });
      vizTarget = updateBlockItemSize({
        item: vizTarget,
        offset: {
          offsetY: -Math.ceil(vizTarget.position.h / 2),
          offsetX: 0
        },
        dir: "s"
      });
      break;
    case "w":
      vizToMove = updateBlockItemSize({
        item: vizToMove,
        offset: {
          offsetX: -Math.floor(vizToMove.position.w / 2),
          offsetY: 0
        },
        dir: "e"
      });
      vizTarget = updateBlockItemSize({
        item: vizTarget,
        offset: {
          offsetX: Math.ceil(vizTarget.position.w / 2),
          offsetY: 0
        },
        dir: "w"
      });
      break;
    case "e":
      vizToMove = updateBlockItemSize({
        item: vizToMove,
        offset: {
          offsetX: Math.floor(vizToMove.position.w / 2),
          offsetY: 0
        },
        dir: "w"
      });
      vizTarget = updateBlockItemSize({
        item: vizTarget,
        offset: {
          offsetX: -Math.ceil(vizTarget.position.w / 2),
          offsetY: 0
        },
        dir: "e"
      });
      break;
    default:
      vizToMove = itemToMove;
      break;
  }
  return [vizToMove, vizTarget];
};
var previewDropOnEdge = ({
  edge,
  itemToMove,
  items,
  canvasWidth
}) => {
  const updatedItems = updateDropOnEdge({
    edge,
    itemToMove,
    items,
    canvasWidth
  });
  if (!updatedItems) {
    return null;
  }
  let { updatedVisualizations } = updatedItems;
  const { updatedItemToMove } = updatedItems;
  updatedVisualizations = updatedVisualizations.filter(
    (viz) => !(0, lodash_exports.isEqual)(viz, updatedItemToMove)
  );
  return [
    ...items.filter(
      (item) => updatedVisualizations.find((viz) => viz.item === item.item) === void 0
    ),
    ...updatedVisualizations,
    __spreadProps(__spreadValues({}, updatedItemToMove), {
      item: "preview-old-item"
    })
  ];
};
var previewDropOnViz = ({
  itemToDropOn,
  itemToMove,
  items,
  direction
}) => {
  const updatedItems = updateDropOnViz({
    itemToMove,
    itemToDropOn,
    direction
  });
  if (!updatedItems) {
    return null;
  }
  return [
    ...items.filter(
      (item) => updatedItems.find((viz) => viz.item === item.item) === void 0
    ),
    ...updatedItems,
    __spreadProps(__spreadValues({}, itemToMove), {
      item: "preview-old-item"
    })
  ];
};
var findItemsOutsideBoundary = ({
  items,
  boundary
}) => {
  const invalidItems = [];
  const message = (0, i18n_exports._)("is outside of canvas bounds");
  items.forEach((item) => {
    if (item.position.x < boundary.x || item.position.x + item.position.w > boundary.x + boundary.w || item.position.y < boundary.y || item.position.y + item.position.h > boundary.y + boundary.h) {
      invalidItems.push({
        itemId: item.item,
        messages: [`"${item.item}" ${message}`]
      });
    }
  });
  return invalidItems;
};
var getItemEdges = ({
  item,
  belongsTo = {}
}) => {
  const topEdge = {
    start: { x: item.x, y: item.y },
    end: { x: item.x + item.w, y: item.y },
    orientation: "horizontal",
    type: "above",
    belongsTo
  };
  const bottomEdge = {
    start: { x: item.x, y: item.y + item.h },
    end: { x: item.x + item.w, y: item.y + item.h },
    orientation: "horizontal",
    type: "below",
    belongsTo
  };
  const leftEdge = {
    start: { x: item.x, y: item.y },
    end: { x: item.x, y: item.y + item.h },
    orientation: "vertical",
    type: "left",
    belongsTo
  };
  const rightEdge = {
    start: { x: item.x + item.w, y: item.y },
    end: { x: item.x + item.w, y: item.y + item.h },
    orientation: "vertical",
    type: "right",
    belongsTo
  };
  return [topEdge, bottomEdge, leftEdge, rightEdge];
};
var createEdges = ({
  items,
  canvasBounds
}) => {
  const edges = [];
  items.forEach((item) => {
    edges.push(
      ...getItemEdges({ item: item.position, belongsTo: item.position })
    );
  });
  edges.push(...getItemEdges({ item: canvasBounds }));
  return edges;
};
var findInvalidItemEdges = ({
  item,
  edges
}) => {
  const invalidEdges = [];
  const curEdges = getItemEdges({
    item: item.position,
    belongsTo: item.position
  });
  curEdges.forEach((curEdge) => {
    const overlappingEdge = edges.find((edge) => {
      if (curEdge.orientation !== edge.orientation || (0, lodash_exports.isEqual)(curEdge.belongsTo, edge.belongsTo)) {
        return false;
      }
      if (curEdge.orientation === "horizontal" && curEdge.start.y === edge.start.y) {
        if (curEdge.start.x >= edge.end.x || edge.start.x >= curEdge.end.x) {
          return false;
        }
        return true;
      }
      if (curEdge.orientation === "vertical" && curEdge.start.x === edge.start.x) {
        if (curEdge.start.y >= edge.end.y || edge.start.y >= curEdge.end.y) {
          return false;
        }
        return true;
      }
      return false;
    });
    if (overlappingEdge === void 0) {
      const positionString = curEdge.orientation === "horizontal" ? `y=${curEdge.start.y}` : `x=${curEdge.start.x}`;
      const positionType = curEdge.type === "below" || curEdge.type === "above" ? curEdge.type : `to its ${curEdge.type}`;
      invalidEdges.push(
        (0, i18n_exports._)(
          `"${item.item}" expected a viz or canvas edge directly ${positionType} at ${positionString}`
        )
      );
    }
  });
  return invalidEdges;
};
var findInvalidItems = ({
  items,
  canvasBounds
}) => {
  const invalidItems = [];
  const edges = createEdges({ items, canvasBounds });
  items.forEach((item) => {
    const invalidEdges = findInvalidItemEdges({ item, edges });
    if (invalidEdges.length > 0) {
      invalidItems.push({
        itemId: item.item,
        messages: invalidEdges
      });
    }
  });
  return invalidItems;
};
var validateLayoutStructure = ({
  layout,
  canvasBounds
}) => {
  if (!layout) {
    return [];
  }
  const res = findItemsOutsideBoundary({
    items: layout,
    boundary: canvasBounds
  });
  if (!(0, lodash_exports.isEmpty)(res)) {
    return res;
  }
  return findInvalidItems({ items: layout, canvasBounds });
};
var isVerticallyAligned = (viz, another) => viz.position.y === another.position.y && viz.position.h === another.position.h;
var isHorizontallyAligned = (viz, another) => viz.position.x === another.position.x && viz.position.w === another.position.w;
var isInvalidAdjacentVizDrop = ({
  itemToMove,
  itemToDropOn,
  direction,
  visualizations
}) => {
  if (direction === "e" && (0, dashboard_utils_exports.isLeftNeighbor)(itemToMove, itemToDropOn) && isVerticallyAligned(itemToMove, itemToDropOn)) {
    return true;
  }
  if (direction === "w" && (0, dashboard_utils_exports.isRightNeighbor)(itemToMove, itemToDropOn) && isVerticallyAligned(itemToMove, itemToDropOn)) {
    return true;
  }
  if (direction === "e" || direction === "w") {
    return false;
  }
  const { leftNeighbors, rightNeighbors } = (0, dashboard_utils_exports.findHorizontalNeighbors)({
    item: itemToMove,
    visualizations
  });
  if (leftNeighbors.length > 0 || rightNeighbors.length > 0) {
    return false;
  }
  if (direction === "n" && (0, dashboard_utils_exports.isBottomNeighbor)(itemToMove, itemToDropOn) && isHorizontallyAligned(itemToMove, itemToDropOn)) {
    return true;
  }
  if (direction === "s" && (0, dashboard_utils_exports.isTopNeighbor)(itemToMove, itemToDropOn) && isHorizontallyAligned(itemToMove, itemToDropOn)) {
    return true;
  }
  return false;
};

// src/utils/splitGridStructure.ts
var DEFAULT_BLOCK_ITEM = {
  item: "",
  position: { x: -1, y: -1, w: -1, h: -1 }
};
var translateBlockItem = (item, translation) => __spreadProps(__spreadValues({}, item), {
  position: __spreadProps(__spreadValues({}, item.position), {
    x: item.position.x + translation.x,
    y: item.position.y + translation.y
  })
});
var translateBlockItems = (items, translation) => items.map((item) => translateBlockItem(item, translation));
var translateGridSplit = (gridSplit, translation) => __spreadProps(__spreadValues({}, gridSplit), {
  layout: translateBlockItems(gridSplit.layout, translation),
  content: __spreadProps(__spreadValues({}, gridSplit.content), {
    items: translateBlockItems(gridSplit.content.items, translation)
  }),
  origin: {
    x: gridSplit.origin.x + translation.x,
    y: gridSplit.origin.y + translation.y
  }
});
var splitGrid = ({
  layoutStructure,
  idToRemove,
  splitConfig = "both",
  alwaysIncludeLastRow = false
}) => {
  const gridInfo = {
    width: 0,
    height: 0,
    originItem: DEFAULT_BLOCK_ITEM,
    nodes: {},
    splitByRows: [],
    splitByColumns: [],
    itemToRemove: DEFAULT_BLOCK_ITEM
  };
  if (layoutStructure.length === 0) {
    return gridInfo;
  }
  let originX = Number.MAX_SAFE_INTEGER;
  let originY = Number.MAX_SAFE_INTEGER;
  layoutStructure.forEach((item) => {
    const { x, y, w, h } = item.position;
    gridInfo.width = Math.max(gridInfo.width, x + w);
    gridInfo.height = Math.max(gridInfo.height, y + h);
    if (x <= originX && y <= originY) {
      originX = x;
      originY = y;
      gridInfo.originItem = item;
    }
    [
      [x, y],
      [x + w, y],
      [x, y + h],
      [x + w, y + h]
    ].forEach(([cornerX, cornerY]) => {
      var _a, _b, _c, _d;
      (_b = (_a = gridInfo.nodes)[cornerX]) != null ? _b : _a[cornerX] = {};
      (_d = (_c = gridInfo.nodes[cornerX])[cornerY]) != null ? _d : _c[cornerY] = [];
      gridInfo.nodes[cornerX][cornerY].push(item);
    });
    if (idToRemove === item.item) {
      gridInfo.itemToRemove = item;
    }
  });
  gridInfo.width = Math.max(0, gridInfo.width - originX);
  gridInfo.height = Math.max(0, gridInfo.height - originY);
  if (splitConfig === "both" || splitConfig === "rows") {
    gridInfo.splitByRows = splitGridByRows({
      nodes: gridInfo.nodes,
      layout: layoutStructure,
      gridWidth: gridInfo.width,
      gridHeight: gridInfo.height,
      originViz: gridInfo.originItem,
      alwaysIncludeLastRow
    });
  }
  if (splitConfig === "both" || splitConfig === "columns") {
    gridInfo.splitByColumns = splitGridByColumns({
      nodes: gridInfo.nodes,
      layout: layoutStructure,
      gridWidth: gridInfo.width,
      gridHeight: gridInfo.height,
      originViz: gridInfo.originItem
    });
  }
  return gridInfo;
};

// src/utils/getContainingRowColumn.ts
var findContainingRow = ({ splits, itemPosition }) => {
  const edgeTop = itemPosition.y;
  const edgeBottom = itemPosition.y + itemPosition.h;
  return splits.find(
    ({ origin, content }) => (
      // Find the first row split which starts above the item in question and ends below it
      origin.y <= edgeTop && origin.y + content.height >= edgeBottom
    )
  );
};
var findContainingColumn = ({ splits, itemPosition }) => {
  const edgeLeft = itemPosition.x;
  const edgeRight = itemPosition.x + itemPosition.w;
  return splits.find(
    ({ origin, content }) => (
      // Find the first column split which starts before the item in question and ends after it
      origin.x <= edgeLeft && origin.x + content.width >= edgeRight
    )
  );
};
var getContainingRowColumnRecursive = ({
  findContainerFn,
  itemToContain,
  previousResult,
  structure
}) => {
  const splittingByRows = findContainerFn === findContainingRow;
  const splitGridInfo = splitGrid({
    layoutStructure: structure,
    idToRemove: itemToContain.item,
    splitConfig: splittingByRows ? "rows" : "columns",
    alwaysIncludeLastRow: true
  });
  const container = findContainerFn({
    splits: splittingByRows ? splitGridInfo.splitByRows : splitGridInfo.splitByColumns,
    itemPosition: splitGridInfo.itemToRemove.position
  });
  if (!container || container.content.items.length <= 1) {
    return previousResult;
  }
  const containerTranslation = {
    x: -container.origin.x,
    y: -container.origin.y
  };
  const translatedContainer = translateGridSplit(
    container,
    containerTranslation
  );
  const nextFindContainerFn = splittingByRows ? findContainingColumn : findContainingRow;
  return translateGridSplit(
    getContainingRowColumnRecursive({
      structure: translatedContainer.content.items,
      itemToContain,
      findContainerFn: nextFindContainerFn,
      previousResult: translatedContainer
    }),
    // NOSONAR
    container.origin
  );
};
var getContainingRowColumn = ({
  structure,
  itemToContain
}) => getContainingRowColumnRecursive({
  structure,
  itemToContain,
  findContainerFn: findContainingRow
});

// src/utils/gridLayoutAutoResize.ts
var recursivelyApplyHorizontalResize = ({
  container: {
    content: { items, width: totalWidth },
    origin
  },
  newSize,
  position,
  translation
}) => {
  const changes = {};
  const { splitByRows, splitByColumns } = splitGrid({
    layoutStructure: translateBlockItems(items, {
      x: -origin.x,
      y: -origin.y
    })
  });
  splitByRows.forEach((container) => {
    Object.assign(
      changes,
      recursivelyApplyHorizontalResize({
        container,
        newSize,
        position,
        translation: {
          x: translation.x + origin.x,
          y: translation.y + origin.y
        }
      })
    );
  });
  let colPosition = position;
  splitByColumns.forEach((container, idx) => {
    let newColWidth = Math.floor(
      newSize * (container.content.width / totalWidth)
    );
    if (
      // If resizing the last column
      idx === splitByColumns.length - 1 && // and there's a fractional correction needed
      colPosition + newColWidth !== position + newSize
    ) {
      newColWidth = position + newSize - colPosition;
    }
    Object.assign(
      changes,
      recursivelyApplyHorizontalResize({
        container,
        newSize: newColWidth,
        position: colPosition,
        translation: {
          x: translation.x + origin.x,
          y: translation.y + origin.y
        }
      })
    );
    colPosition += newColWidth;
  });
  if (splitByColumns.length === 0 && splitByRows.length === 0) {
    items.forEach((item) => {
      const { position: itemPos } = translateBlockItem(item, translation);
      changes[item.item] = __spreadProps(__spreadValues({}, item), {
        position: __spreadProps(__spreadValues({}, itemPos), {
          x: position,
          w: newSize
        })
      });
    });
  }
  return changes;
};
var recursivelyApplyVerticalResize = ({
  container: {
    content: { items, height: totalHeight },
    origin
  },
  newSize,
  position,
  translation
}) => {
  const changes = {};
  const { splitByRows, splitByColumns } = splitGrid({
    layoutStructure: translateBlockItems(items, {
      x: -origin.x,
      y: -origin.y
    })
  });
  splitByColumns.forEach((container) => {
    Object.assign(
      changes,
      recursivelyApplyVerticalResize({
        container,
        newSize,
        position,
        translation: {
          x: translation.x + origin.x,
          y: translation.y + origin.y
        }
      })
    );
  });
  let rowPosition = position;
  splitByRows.forEach((container, idx) => {
    let newRowHeight = Math.floor(
      newSize * (container.content.height / totalHeight)
    );
    if (
      // If resizing the last row
      idx === splitByRows.length - 1 && // and there's a fractional correction needed
      rowPosition + newRowHeight !== position + newSize
    ) {
      newRowHeight = position + newSize - rowPosition;
    }
    Object.assign(
      changes,
      recursivelyApplyVerticalResize({
        container,
        newSize: newRowHeight,
        position: rowPosition,
        translation: {
          x: translation.x + origin.x,
          y: translation.y + origin.y
        }
      })
    );
    rowPosition += newRowHeight;
  });
  if (splitByColumns.length === 0 && splitByRows.length === 0) {
    items.forEach((item) => {
      const { position: itemPos } = translateBlockItem(item, translation);
      changes[item.item] = __spreadProps(__spreadValues({}, item), {
        position: __spreadProps(__spreadValues({}, itemPos), {
          y: position,
          h: newSize
        })
      });
    });
  }
  return changes;
};
var HorizontalResizeConfig = {
  dimension: "width",
  blockSizeDimension: "w",
  blockPosDimension: "x",
  splitGridConfig: "columns",
  splitGridKey: "splitByColumns",
  recursiveResizeFn: recursivelyApplyHorizontalResize
};
var VerticalResizeConfig = {
  dimension: "height",
  blockSizeDimension: "h",
  blockPosDimension: "y",
  splitGridConfig: "rows",
  splitGridKey: "splitByRows",
  recursiveResizeFn: recursivelyApplyVerticalResize
};
var handleResizing = ({
  container,
  itemToRemove,
  config: {
    dimension,
    blockSizeDimension,
    blockPosDimension,
    splitGridConfig,
    splitGridKey,
    recursiveResizeFn
  }
}) => {
  if (!container) {
    return {};
  }
  const {
    origin,
    content: {
      // Items in the container which are being resized
      items: impactedItems,
      // The important container dimension (width or height) being recalculated
      [dimension]: containerSize
    }
  } = container;
  const negatedOrigin = { x: -origin.x, y: -origin.y };
  if (impactedItems.length < 2) {
    return {};
  }
  if (impactedItems.length === 2) {
    const itemToUpdate = impactedItems[0].item !== itemToRemove.item ? impactedItems[0] : impactedItems[1];
    return {
      [itemToUpdate.item]: __spreadProps(__spreadValues({}, itemToUpdate), {
        position: __spreadProps(__spreadValues({}, itemToUpdate.position), {
          [blockPosDimension]: origin[blockPosDimension],
          [blockSizeDimension]: containerSize
        })
      })
    };
  }
  const pendingChanges = {};
  const {
    [splitGridKey]: splitByResizeDimension,
    itemToRemove: {
      position: { [blockSizeDimension]: itemToRemoveSize }
    }
  } = splitGrid({
    layoutStructure: translateBlockItems(impactedItems, negatedOrigin),
    splitConfig: splitGridConfig,
    idToRemove: itemToRemove.item
  });
  const pctToDistribute = itemToRemoveSize / (splitByResizeDimension.length - 1) / containerSize;
  let itemPosition = origin[blockPosDimension];
  const containerEdge = origin[blockPosDimension] + containerSize;
  let lastFRCIdx = splitByResizeDimension.length - 2;
  splitByResizeDimension.forEach((split, idx) => {
    if (split.content.items[0].item === itemToRemove.item) {
      lastFRCIdx += 1;
      return;
    }
    const splitSize = split.content[dimension] / containerSize;
    let newSize = Math.floor(containerSize * (pctToDistribute + splitSize));
    if (idx === lastFRCIdx && itemPosition + newSize !== containerEdge) {
      newSize = containerEdge - itemPosition;
    }
    Object.values(
      recursiveResizeFn({
        container: split,
        newSize,
        position: itemPosition,
        translation: origin
      })
    ).forEach((change) => {
      pendingChanges[change.item] = change;
    });
    itemPosition += newSize;
  });
  return pendingChanges;
};
var handleHorizontalResizing = (args) => handleResizing(__spreadProps(__spreadValues({}, args), { config: HorizontalResizeConfig }));
var handleVerticalResizing = (args) => handleResizing(__spreadProps(__spreadValues({}, args), { config: VerticalResizeConfig }));

// src/utils/gridLayoutShowHide.ts
var cloneLayoutStructure = (source) => {
  if (!source.length) {
    return [];
  }
  return (0, lodash_exports.cloneDeep)(source);
};
var createStructureMap = (structure) => Object.fromEntries(structure.map((item) => [item.item, item]));
var getWidthFromStructure = (structure) => {
  const [min, max] = structure.reduce(
    ([minX, maxX], { position: { x, w } }) => [
      // minX = either block item left or current minX (initial: MAX_SAFE_INTEGER)
      Math.min(minX, x),
      // maxX = either block item right or current maxX (initial: 0)
      Math.max(maxX, x + w)
    ],
    [Number.MAX_SAFE_INTEGER, 0]
  );
  return Math.max(max - min, 0);
};
var popTopLeftBlock = ({
  itemsToRemove,
  itemMap
}) => {
  let result = itemMap[itemsToRemove[0].item];
  let resultIdx = 0;
  itemsToRemove.forEach(({ item }, idx) => {
    const itemMapItem = itemMap[item];
    if (result.position.y > itemMapItem.position.y) {
      result = itemMapItem;
      resultIdx = idx;
      return;
    }
    if (result.position.y === itemMapItem.position.y && result.position.x > itemMapItem.position.x) {
      result = itemMapItem;
      resultIdx = idx;
    }
  });
  itemsToRemove.splice(resultIdx, 1);
  return result;
};
var applyUpdatesToStructure = ({
  structure,
  itemMap,
  itemToRemove,
  updatesMap
}) => {
  let idxToRemove = -1;
  structure.forEach((item, idx) => {
    if (item.item === itemToRemove.item) {
      idxToRemove = idx;
    } else if (item.item in updatesMap) {
      structure[idx] = updatesMap[item.item];
      itemMap[item.item] = updatesMap[item.item];
    }
  });
  if (idxToRemove >= 0) {
    structure.splice(idxToRemove, 1);
  }
  delete itemMap[itemToRemove.item];
};
var baseCaseRemoval = ({
  structure,
  itemMap,
  itemToRemove,
  width
}) => {
  const updates = (0, dashboard_utils_exports.updateRemovedVizNeighbors)({
    items: structure,
    itemToRemove,
    width
  });
  const updatesMap = createStructureMap(updates);
  applyUpdatesToStructure({
    structure,
    itemMap,
    itemToRemove,
    updatesMap
  });
};
var handleRecursiveItemRemoval = ({
  structure,
  itemsToRemove,
  itemMap
}) => {
  var _a, _b;
  if (itemsToRemove.length === 0) {
    return;
  }
  const itemToRemove = popTopLeftBlock({ itemsToRemove, itemMap });
  const container = getContainingRowColumn({
    structure,
    itemToContain: itemToRemove
  });
  if (!container || container.content.items.length <= 1) {
    baseCaseRemoval({
      structure,
      itemMap,
      width: (_a = container == null ? void 0 : container.gridWidth) != null ? _a : getWidthFromStructure(structure),
      itemToRemove
    });
  } else {
    const { width, height } = container.content;
    let updatesMap;
    if (itemToRemove.position.w === width) {
      updatesMap = handleVerticalResizing({ container, itemToRemove });
    } else if (itemToRemove.position.h === height) {
      updatesMap = handleHorizontalResizing({ container, itemToRemove });
    } else {
      baseCaseRemoval({
        structure,
        width: (_b = container == null ? void 0 : container.gridWidth) != null ? _b : getWidthFromStructure(structure),
        itemToRemove,
        itemMap
      });
    }
    if (updatesMap) {
      applyUpdatesToStructure({
        structure,
        itemMap,
        itemToRemove,
        updatesMap
      });
    }
  }
  handleRecursiveItemRemoval({ structure, itemsToRemove, itemMap });
};
var gridLayoutShowHideReflow = (initialStructure, itemsToRemove) => {
  if (!itemsToRemove.length) {
    return initialStructure;
  }
  const newStructure = cloneLayoutStructure(
    initialStructure
  );
  const clonedItemsToRemove = cloneLayoutStructure(
    itemsToRemove
  );
  const itemMap = createStructureMap(newStructure);
  handleRecursiveItemRemoval({
    structure: newStructure,
    itemsToRemove: clonedItemsToRemove,
    itemMap
  });
  return newStructure;
};

// src/enhancers/withLayoutShowHide.tsx
var EmptyStructure = [];
var withLayoutShowHide = (Layout, { schema, reflowFn }) => {
  const EnhancedLayout = (props) => {
    var _a;
    const layoutStructure = useLayoutShowHide(
      (_a = props.layoutStructure) != null ? _a : EmptyStructure,
      reflowFn
    );
    return /* @__PURE__ */ react_default.createElement(
      Layout,
      __spreadProps(__spreadValues({}, props), {
        layoutStructure,
        rawLayoutStructure: props.layoutStructure
      })
    );
  };
  EnhancedLayout.schema = schema;
  return EnhancedLayout;
};

// src/GridLayout.tsx
var HANDLE_DIRECTIONS = [];
var MemoizedBlockItem = react_default.memo(
  ResponsiveBlockItem_default,
  (prevProps, nextProps) => {
    if (nextProps.y + nextProps.h === nextProps.canvasHeight) {
      return (0, lodash_exports.isEqual)(prevProps, nextProps);
    }
    const prevPropsWithoutCanvasHeight = (0, lodash_exports.omit)(prevProps, "canvasHeight");
    const nextPropsWithoutCanvasHeight = (0, lodash_exports.omit)(nextProps, "canvasHeight");
    return (0, lodash_exports.isEqual)(
      prevPropsWithoutCanvasHeight,
      nextPropsWithoutCanvasHeight
    );
  }
);
var MemoizedBlockOutline = react_default.memo(ResponsiveBlockOutline_default);
var MemoizedEdge = react_default.memo(Edge);
var renderBlockItems = memoize_one_default(
  ({
    layoutStructure,
    renderLayoutItem,
    handleItemSelected,
    isBlockItemMoving,
    selectedItem,
    mode,
    errors,
    padding,
    canvasHeight
  }) => {
    return layoutStructure.map((item) => {
      const key = item.item;
      if (key === "preview-old-item") {
        return null;
      }
      const isSelected = (selectedItem == null ? void 0 : selectedItem.id) === key;
      let appearance = mode === "view" || !selectedItem || isSelected ? "highlighted" : "visible";
      if (isSelected && isBlockItemMoving) {
        appearance = "hidden";
      }
      let errorMessages;
      if (errors) {
        const vizErrors = errors.find(({ itemId }) => itemId === key);
        errorMessages = vizErrors == null ? void 0 : vizErrors.messages;
      }
      return /* @__PURE__ */ react_default.createElement(
        MemoizedBlockItem,
        {
          key,
          itemId: key,
          type: item.type,
          x: item.position.x,
          y: item.position.y,
          h: item.position.h,
          w: item.position.w,
          padding,
          canvasHeight,
          renderLayoutItem,
          onItemSelected: handleItemSelected,
          appearance,
          errorMessages
        }
      );
    });
  },
  lodash_exports.isEqual
);
var BOTTOM_EDGE_MIN_SPEED = 2;
var BOTTOM_EDGE_MAX_SPEED = 4;
var BOTTOM_RESIZING_SCROLL_SPEED = 50;
var CANVAS_BOTTOM_PADDING = 8;
var BaseGridLayout = ({
  layoutApiRef,
  onLayoutItemsSelect,
  selectedItems: selectedLayoutItems,
  layoutStructure,
  onLayoutStructureChange,
  options = {},
  renderLayoutItem,
  mode,
  showGrid,
  scale,
  setCanvasHeight,
  canvasWidth
}) => {
  var _a;
  const canvasRef = (0, react_exports.useRef)(null);
  const canvasContext = (0, dashboard_context_exports.useCanvas)();
  const keyboardListener = (0, dashboard_context_exports.useKeyboardListener)();
  const userMessage = (_a = (0, dashboard_context_exports.useUserMessageAPI)()) != null ? _a : dashboard_utils_exports.noop;
  const telemetryAPI = (0, dashboard_telemetry_exports.useTelemetryApi)();
  const { enableGridLayoutErrors, enableGridLayoutCssScaling } = (0, dashboard_context_exports.useFeatureFlags)();
  const { backgroundColor, gutterSize = gridLayoutOptions.gutterSize } = options;
  const panelPadding = gutterSize / 2;
  const [gridState, dispatch] = (0, react_exports.useReducer)(
    gridReducer,
    layoutStructure,
    initializeGridReducer
  );
  const maxHeight = computeMaxHeight(getBlockItems(gridState));
  (0, react_exports.useLayoutEffect)(() => {
    setCanvasHeight(maxHeight);
  }, [setCanvasHeight, maxHeight]);
  const [isBlockItemMoving, setIsBlockItemMoving] = (0, react_exports.useState)(false);
  const [edges, setEdges] = (0, react_exports.useState)(
    computeEdges({
      layout: layoutStructure,
      canvasWidth,
      canvasHeight: computeMaxHeight(layoutStructure)
      // need to recompute height on layout change
    })
  );
  const [snappableEdges, setSnappableEdges] = (0, react_exports.useState)([]);
  const [scrollToBottom, setScrollToBottom] = (0, react_exports.useState)(false);
  const [mousePosition, setMousePosition] = (0, react_exports.useState)(null);
  const [isItemAdded, setIsItemAdded] = (0, react_exports.useState)(false);
  const [edgesBeforeMove, setEdgesBeforeMove] = (0, react_exports.useState)(
    null
  );
  const [invalidEdgeId, setInvalidEdgeId] = (0, react_exports.useState)(null);
  const [hoveredEdge, setHoveredEdge] = (0, react_exports.useState)(null);
  const [initialItemToMove, setInitialItemToMove] = (0, react_exports.useState)(null);
  const [hoveredBlock, setHoveredBlock] = (0, react_exports.useState)(
    null
  );
  const [hoveredQuadrant, setHoveredQuadrant] = (0, react_exports.useState)(
    null
  );
  const [, setForceUpdate] = (0, react_exports.useState)(0);
  const [selectedItemsForEdge, setSelectedItemsForEdge] = (0, react_exports.useState)(
    []
  );
  const [isInvalidVizDrop, setIsInvalidVizDrop] = (0, react_exports.useState)(false);
  const [showPreviewPlaceholder, setShowPreviewPlaceholder] = (0, react_exports.useState)(true);
  const [layoutErrors, setLayoutErrors] = (0, react_exports.useState)([]);
  const isDraggingEdge = (0, react_exports.useRef)(false);
  const delayPreviewEdge = (0, react_exports.useRef)(null);
  const delayPreviewViz = (0, react_exports.useRef)(null);
  const mouseDownEdge = (0, react_exports.useRef)(null);
  const edgeMouseDownPosition = (0, react_exports.useRef)(null);
  const edgeBoundaries = (0, react_exports.useRef)(null);
  const edgesInBoundary = (0, react_exports.useRef)(null);
  const cumulativeScrollIncrease = (0, react_exports.useRef)(0);
  const edgeVelocity = (0, react_exports.useRef)(0);
  const containsPreviewItem = hasPreviewItem(gridState);
  const sendTelemetry = (0, react_exports.useCallback)(
    (eventData) => {
      telemetryAPI.collect(eventData);
    },
    [telemetryAPI]
  );
  const onItemAdded = (0, react_exports.useCallback)(() => {
    setIsItemAdded(true);
  }, [setIsItemAdded]);
  const layoutApi = (0, react_exports.useRef)(null);
  const layoutStructureRef = (0, react_exports.useRef)(layoutStructure);
  const firstSelectedItemStructure = (0, react_exports.useMemo)(
    () => (selectedLayoutItems == null ? void 0 : selectedLayoutItems.length) ? getItem(gridState, selectedLayoutItems[0].id) : null,
    [gridState, selectedLayoutItems]
  );
  const initializeLayoutApi = (0, react_exports.useCallback)(() => {
    const getCanvasDomElement = () => {
      return canvasRef.current;
    };
    if (layoutApi.current === null) {
      layoutApi.current = new GridLayoutApi_default({
        layoutStructureRef,
        options,
        userMessage,
        onItemAdded,
        getCanvasDomElement,
        telemetry: telemetryAPI
      });
    }
  }, [telemetryAPI, userMessage, onItemAdded, options]);
  const prevLayoutStructure = (0, dashboard_ui_exports.usePrevious)(layoutStructure);
  (0, react_exports.useEffect)(() => {
    if ((0, lodash_exports.isEqual)(prevLayoutStructure, layoutStructure)) {
      return;
    }
    dispatch(resetLayoutAction(layoutStructure));
    layoutStructureRef.current = enableGridLayoutCssScaling ? layoutStructure : scaleGridLayoutStructureByWidth({
      scale: 1 / scale,
      layout: layoutStructure
    });
  }, [
    enableGridLayoutCssScaling,
    layoutStructure,
    prevLayoutStructure,
    scale
  ]);
  initializeLayoutApi();
  (0, react_exports.useEffect)(() => {
    if (mode === "edit" && enableGridLayoutErrors) {
      const errors = validateLayoutStructure({
        layout: layoutStructure,
        canvasBounds: { x: 0, y: 0, w: canvasWidth, h: maxHeight }
      });
      setLayoutErrors(errors);
    } else if (mode === "view") {
      setLayoutErrors([]);
    }
  }, [layoutStructure, mode, enableGridLayoutErrors]);
  (0, react_exports.useLayoutEffect)(() => {
    layoutApiRef(layoutApi.current);
    return () => {
      layoutApiRef(null);
    };
  }, [layoutApiRef]);
  (0, react_exports.useEffect)(() => {
    if ((0, lodash_exports.isEqual)(prevLayoutStructure, layoutStructure)) {
      return;
    }
    dispatch(resetLayoutAction(layoutStructure));
    const canvasHeight = computeMaxHeight(layoutStructure);
    const prevCanvasHeight = computeMaxHeight(prevLayoutStructure || []);
    setEdges(
      computeEdges({
        layout: layoutStructure,
        canvasWidth,
        canvasHeight
        // need to recompute height on layout change
      })
    );
    if (prevLayoutStructure && canvasHeight > prevCanvasHeight && isItemAdded) {
      setScrollToBottom(true);
      setIsItemAdded(false);
    }
  }, [isItemAdded, layoutStructure, canvasWidth, prevLayoutStructure]);
  (0, react_exports.useEffect)(() => {
    if (scrollToBottom) {
      const layoutContainer = canvasContext.current;
      if (layoutContainer) {
        layoutContainer.scrollTop = layoutContainer.scrollHeight;
      }
      setScrollToBottom(false);
    }
  }, [canvasContext, layoutStructure, scrollToBottom]);
  const handleLayoutStructureChange = (0, react_exports.useCallback)(() => {
    const layout = getBlockItems(gridState);
    onLayoutStructureChange(layout);
  }, [onLayoutStructureChange, gridState]);
  const getSelectedItems = (0, react_exports.useMemo)(() => {
    let itemsCache;
    return () => {
      const filteredItems = filterSelectedItems(
        layoutStructure,
        selectedLayoutItems
      );
      if (!(0, lodash_exports.isEqual)(itemsCache, filteredItems)) {
        itemsCache = filteredItems;
      }
      return itemsCache;
    };
  }, [layoutStructure, selectedLayoutItems]);
  const handleItemSelected = (0, react_exports.useCallback)(
    (_e, selectedItems = []) => {
      const selectedItem = selectedItems.length > 0 ? [selectedItems[selectedItems.length - 1]] : [];
      onLayoutItemsSelect(selectedItem);
    },
    [onLayoutItemsSelect]
  );
  const mouseScale = enableGridLayoutCssScaling ? scale : 1;
  (0, react_exports.useEffect)(() => {
    let delayed;
    const layoutContainer = canvasContext.current;
    if (!isBlockItemMoving || !mousePosition || !layoutContainer) {
      return () => void 0;
    }
    const visibleCanvasHeight = layoutContainer.clientHeight / mouseScale;
    const hasScrolledToBottom = layoutContainer.scrollTop / mouseScale + visibleCanvasHeight >= maxHeight;
    const isInBottomScrollArea = layoutContainer.scrollTop / mouseScale + visibleCanvasHeight - mousePosition.y < MIN_HEIGHT_PX;
    const hasScrolledToTop = layoutContainer.scrollTop <= 0;
    const isInTopScrollArea = mousePosition.y - layoutContainer.scrollTop / mouseScale < MIN_HEIGHT_PX;
    if (!hasScrolledToBottom && isInBottomScrollArea) {
      const increment = Math.min(
        Math.abs(
          maxHeight - (layoutContainer.scrollTop / mouseScale + visibleCanvasHeight)
        ),
        10
      );
      delayed = setTimeout(() => {
        layoutContainer.scrollTop += increment;
        setMousePosition(
          (pos) => pos ? __spreadProps(__spreadValues({}, pos), {
            y: pos.y + increment / mouseScale
          }) : null
        );
      }, 32);
    } else if (!hasScrolledToTop && isInTopScrollArea) {
      const decrement = Math.min(layoutContainer.scrollTop, 10);
      delayed = setTimeout(() => {
        layoutContainer.scrollTop -= decrement;
        setMousePosition(
          (pos) => pos ? __spreadProps(__spreadValues({}, pos), {
            y: pos.y - decrement / mouseScale
          }) : null
        );
      }, 32);
    }
    return () => {
      clearTimeout(delayed);
    };
  }, [
    isBlockItemMoving,
    mousePosition,
    canvasContext,
    mouseScale,
    maxHeight
  ]);
  const resetEdgePreviewState = (0, react_exports.useCallback)(() => {
    if (edgesBeforeMove) {
      if (delayPreviewEdge.current) {
        clearTimeout(delayPreviewEdge.current);
      }
      setEdges(edgesBeforeMove);
      dispatch(resetLayoutAction(layoutStructure));
    }
  }, [edgesBeforeMove, layoutStructure]);
  const showEdgeDropPreview = (0, react_exports.useCallback)(
    ({ mousePos }) => {
      if (edgesBeforeMove === null) {
        setEdgesBeforeMove(edges);
      }
      const validEdges = edgesBeforeMove || edges;
      const edge = validEdges.find((edgeToFind) => {
        return isMouseOnEdge({
          edge: edgeToFind,
          mousePosition: mousePos,
          padding: panelPadding
        });
      });
      if (!edge) {
        if (hoveredEdge) {
          setHoveredEdge(null);
          setInvalidEdgeId(null);
          resetEdgePreviewState();
        }
        return;
      }
      if (!hoveredEdge || hoveredEdge.item !== edge.item) {
        let itemToMove = firstSelectedItemStructure;
        if (!initialItemToMove) {
          setInitialItemToMove(itemToMove);
        } else {
          itemToMove = initialItemToMove;
        }
        if (isDropOnOwnEdge({
          edge,
          itemToMove
        })) {
          return;
        }
        const updatedItems = previewDropOnEdge({
          edge,
          itemToMove,
          items: layoutStructure,
          canvasWidth
        });
        if (updatedItems) {
          setInvalidEdgeId(null);
          if (delayPreviewEdge.current) {
            clearTimeout(delayPreviewEdge.current);
          }
          setShowPreviewPlaceholder(false);
          delayPreviewEdge.current = setTimeout(() => {
            dispatch(resetLayoutAction(updatedItems));
            setEdges(
              computeEdges({
                layout: updatedItems,
                canvasWidth,
                canvasHeight: computeMaxHeight(updatedItems)
              })
            );
            setShowPreviewPlaceholder(true);
          }, EDGE_PREVIEW_DELAY_MS);
        } else {
          setShowPreviewPlaceholder(true);
          setInvalidEdgeId(edge.item);
          resetEdgePreviewState();
        }
      }
      setHoveredEdge(edge);
    },
    [
      firstSelectedItemStructure,
      edgesBeforeMove,
      edges,
      hoveredEdge,
      panelPadding,
      resetEdgePreviewState,
      initialItemToMove,
      layoutStructure,
      canvasWidth
    ]
  );
  const showVizDropPreview = (0, react_exports.useCallback)(
    ({ mousePos }) => {
      const block = findTopBlockItemByPosition(
        layoutStructure,
        mousePos,
        panelPadding
      );
      let itemToMove = firstSelectedItemStructure;
      if (!initialItemToMove) {
        setInitialItemToMove(itemToMove);
      } else {
        itemToMove = initialItemToMove;
      }
      if (block === void 0 || block.item === (itemToMove == null ? void 0 : itemToMove.item)) {
        if (delayPreviewViz.current) {
          clearTimeout(delayPreviewViz.current);
        }
        setHoveredQuadrant(null);
        setHoveredBlock(null);
        setIsInvalidVizDrop(false);
        if (hoveredBlock) {
          dispatch(resetLayoutAction(layoutStructure));
        }
        return;
      }
      const currentQuadrant = findQuadrant({
        item: applyVizPadding({ item: block, padding: panelPadding }),
        position: mousePos
      });
      if (!hoveredBlock && !hoveredQuadrant || hoveredQuadrant !== currentQuadrant || (hoveredBlock == null ? void 0 : hoveredBlock.item) !== block.item) {
        if (isInvalidAdjacentVizDrop({
          itemToMove,
          itemToDropOn: block,
          visualizations: layoutStructure,
          direction: currentQuadrant
        })) {
          return;
        }
        const updatedItems = previewDropOnViz({
          itemToDropOn: block,
          itemToMove,
          items: layoutStructure,
          direction: currentQuadrant
        });
        if (delayPreviewViz.current) {
          clearTimeout(delayPreviewViz.current);
        }
        if (updatedItems) {
          setIsInvalidVizDrop(false);
          setHoveredQuadrant(currentQuadrant);
          setHoveredBlock(block);
          setShowPreviewPlaceholder(false);
          delayPreviewViz.current = setTimeout(() => {
            dispatch(resetLayoutAction(updatedItems));
            setForceUpdate(
              (prevForceUpdate) => prevForceUpdate + 1
            );
            setShowPreviewPlaceholder(true);
          }, VIZ_PREVIEW_DELAY_MS);
        } else {
          setHoveredQuadrant(null);
          setHoveredBlock(null);
          setIsInvalidVizDrop(true);
          if (hoveredBlock) {
            dispatch(resetLayoutAction(layoutStructure));
          }
        }
      }
    },
    [
      firstSelectedItemStructure,
      panelPadding,
      hoveredBlock,
      hoveredQuadrant,
      initialItemToMove,
      layoutStructure
    ]
  );
  const renderItemDropTarget = memoize_one_default(
    ({
      position,
      direction
    }) => {
      return /* @__PURE__ */ react_default.createElement(ItemDropTarget, { position, direction });
    }
  );
  const handleRenderItemDropTarget = (0, react_exports.useCallback)(() => {
    let block = findTopBlockItemByPosition(
      layoutStructure,
      mousePosition,
      panelPadding
    );
    const selectedItems = getSelectedItems();
    if (block !== void 0 && selectedItems.length > 0 && block.item !== selectedItems[0].id && // disables drop targets when showing preview
    !hoveredQuadrant) {
      block = applyVizPadding({ item: block, padding: panelPadding });
      return renderItemDropTarget({
        position: block.position,
        direction: findQuadrant({
          item: block,
          position: mousePosition
        })
      });
    }
    return null;
  }, [
    layoutStructure,
    panelPadding,
    getSelectedItems,
    hoveredQuadrant,
    mousePosition,
    renderItemDropTarget
  ]);
  const handleShowPreviewPlaceholder = (0, react_exports.useCallback)(
    ({ mousePos }) => {
      const selectedItem = getSelectedItems()[0];
      if (!selectedItem) {
        setShowPreviewPlaceholder(false);
        return;
      }
      const hoveredViz = findTopBlockItemByPosition(
        layoutStructure,
        mousePos,
        panelPadding
      );
      if (hoveredViz && hoveredViz.item === selectedItem.id) {
        setShowPreviewPlaceholder(true);
        return;
      }
      if (invalidEdgeId !== null || isInvalidVizDrop) {
        setShowPreviewPlaceholder(true);
        return;
      }
      if (containsPreviewItem) {
        setShowPreviewPlaceholder(true);
        return;
      }
      setShowPreviewPlaceholder(false);
    },
    [
      containsPreviewItem,
      panelPadding,
      getSelectedItems,
      invalidEdgeId,
      isInvalidVizDrop,
      layoutStructure
    ]
  );
  const handleBlockItemMove = (0, react_exports.useCallback)(
    (_e, { currentPosition }) => {
      if (getSelectedItems().length > 0) {
        handleShowPreviewPlaceholder({ mousePos: currentPosition });
        setIsBlockItemMoving(true);
        setMousePosition(currentPosition);
        showEdgeDropPreview({ mousePos: currentPosition });
        showVizDropPreview({ mousePos: currentPosition });
      }
    },
    [
      getSelectedItems,
      showEdgeDropPreview,
      showVizDropPreview,
      handleShowPreviewPlaceholder
    ]
  );
  const handleVizDrop = (0, react_exports.useCallback)(() => {
    const validEdges = edgesBeforeMove || edges;
    const selectedItems = getSelectedItems();
    if (selectedItems.length === 0) {
      return;
    }
    const edge = validEdges.find((e) => {
      return isMouseOnEdge({
        edge: e,
        mousePosition,
        padding: panelPadding
      });
    });
    const block = findTopBlockItemByPosition(
      layoutStructure,
      mousePosition,
      panelPadding
    );
    const itemToMove = layoutStructure.find(
      ({ item }) => item === selectedItems[0].id
    );
    if (block === itemToMove) {
      sendTelemetry({
        source: "canvas",
        event: "viz_drop_on_self_successful"
      });
      return;
    }
    const itemsSelected = layoutStructure;
    let updatedItems = null;
    if (edge !== void 0) {
      updatedItems = updateDropOnEdge({
        edge,
        itemToMove,
        items: itemsSelected,
        canvasWidth
      });
      if (updatedItems === null) {
        sendTelemetry({
          source: "canvas",
          event: "viz_drop_on_edge_unsuccessful"
        });
        return;
      }
      updatedItems = updateItems({
        updatedVisualizations: updatedItems.updatedVisualizations,
        itemToMove: updatedItems.updatedItemToMove,
        items: itemsSelected,
        canvasWidth
      });
      sendTelemetry({
        source: "canvas",
        event: "viz_drop_on_edge_successful"
      });
    } else if (block !== void 0 && block.item !== selectedItems[0].id) {
      const direction = findQuadrant({
        item: applyVizPadding({ item: block, padding: panelPadding }),
        position: mousePosition
      });
      if (isInvalidAdjacentVizDrop({
        itemToMove,
        itemToDropOn: block,
        direction,
        visualizations: layoutStructure
      })) {
        return;
      }
      const updatedVisualizations = updateDropOnViz({
        itemToMove,
        itemToDropOn: block,
        direction
      });
      if (updatedVisualizations === null) {
        sendTelemetry({
          source: "canvas",
          event: "viz_drop_on_viz_unsuccessful"
        });
        return;
      }
      updatedItems = updateItems({
        updatedVisualizations,
        itemToMove,
        items: itemsSelected,
        canvasWidth
      });
      sendTelemetry({
        source: "canvas",
        event: "viz_drop_on_viz_successful"
      });
    }
    if (updatedItems != null) {
      onLayoutStructureChange(updatedItems);
    }
  }, [
    layoutStructure,
    edgesBeforeMove,
    edges,
    getSelectedItems,
    mousePosition,
    panelPadding,
    sendTelemetry,
    canvasWidth,
    onLayoutStructureChange
  ]);
  const cleanupAfterPreview = (0, react_exports.useCallback)(() => {
    if (delayPreviewViz.current) {
      clearTimeout(delayPreviewViz.current);
    }
    if (delayPreviewEdge.current) {
      clearTimeout(delayPreviewEdge.current);
    }
    setInvalidEdgeId(null);
    setIsInvalidVizDrop(false);
    setInitialItemToMove(null);
    setHoveredBlock(null);
    setHoveredQuadrant(null);
    if (edgesBeforeMove) {
      setEdges(edgesBeforeMove);
      setEdgesBeforeMove(null);
      dispatch(resetLayoutAction(layoutStructure));
    }
    if (hoveredBlock) {
      dispatch(resetLayoutAction(layoutStructure));
    }
  }, [edgesBeforeMove, hoveredBlock, layoutStructure]);
  const handleBlockItemMoved = (0, react_exports.useCallback)(() => {
    cleanupAfterPreview();
    if (mousePosition !== null) {
      handleVizDrop();
    }
    setIsBlockItemMoving(false);
    setMousePosition(null);
  }, [cleanupAfterPreview, mousePosition, handleVizDrop]);
  const handleBlockItemPositionUpdate = (0, react_exports.useCallback)(
    ({ item, offset }) => {
      const newItem = updateBlockItemPosition(item, offset);
      dispatch(updateItemAction(newItem));
    },
    []
  );
  const handleBlockItemResize = (0, react_exports.useCallback)(
    (_e, {
      itemId,
      offset,
      dir
    }) => {
      const item = getStructureItem(layoutStructure, itemId);
      const newItem = updateBlockItemSize({
        item,
        offset,
        dir,
        options: {
          minHeight: MIN_HEIGHT_PX,
          minWidth: MIN_WIDTH_PX
        }
      });
      dispatch(updateItemAction(newItem));
    },
    [layoutStructure]
  );
  const handleBlockItemResized = (0, react_exports.useCallback)(() => {
    handleLayoutStructureChange();
    sendTelemetry({
      source: "canvas",
      event: "edge_resize"
    });
  }, [handleLayoutStructureChange, sendTelemetry]);
  const handleMouseDownOnEdge = (0, react_exports.useCallback)(
    (e, { id }) => {
      isDraggingEdge.current = true;
      const edge = edges.find(({ item }) => item === id);
      if (!edge) {
        return;
      }
      const visualizationIds = edge.visualizations.map((viz) => viz.item);
      const newEdgeBoundaries = edge.orientation === "horizontal" ? getVerticalBoundaries({
        visualizations: edge.visualizations,
        y: edge.edgeStart.y,
        minHeight: MIN_HEIGHT_PX,
        isFullWidthEdge: edge.edgeEnd.x - edge.edgeStart.x === canvasWidth
      }) : getHorizontalBoundaries({
        visualizations: edge.visualizations,
        x: edge.edgeStart.x,
        minWidth: MIN_WIDTH_PX
      });
      edgeBoundaries.current = newEdgeBoundaries;
      edgesInBoundary.current = findEdgesInBoundary({
        edge,
        edges,
        edgeBoundaries: newEdgeBoundaries
      });
      edgeMouseDownPosition.current = getClientPosition(e, mouseScale);
      mouseDownEdge.current = __spreadValues({}, edge);
      setSelectedItemsForEdge(visualizationIds);
    },
    [edges, mouseScale, canvasWidth]
  );
  const handleEdgeMove = (0, dashboard_ui_exports.useEventCallback)((e) => {
    var _a2, _b, _c, _d;
    e.preventDefault();
    e.stopPropagation();
    if (!isDraggingEdge.current || !mouseDownEdge.current) {
      return;
    }
    const currentPosition = getClientPosition(e, mouseScale);
    const offset = getOffset(
      currentPosition,
      edgeMouseDownPosition.current
    );
    offset.offsetY += cumulativeScrollIncrease.current;
    let updatedEdge = ((_a2 = mouseDownEdge == null ? void 0 : mouseDownEdge.current) == null ? void 0 : _a2.orientation) === "vertical" ? moveVerticalEdge({
      edge: mouseDownEdge.current,
      offset: offset.offsetX,
      edgeBoundaries: edgeBoundaries.current
    }) : moveHorizontalEdge({
      edge: mouseDownEdge.current,
      offset: offset.offsetY,
      edgeBoundaries: edgeBoundaries.current
    });
    let updatedSnappableEdges = [];
    if (!e.shiftKey) {
      const { updatedEdge: ue, snappableEdges: se } = findSnappableEdges({
        edge: updatedEdge,
        edges: (_b = edgesInBoundary.current) != null ? _b : [],
        snapRange: SNAP_RANGE_PX
      });
      updatedEdge = ue;
      updatedSnappableEdges = se;
    }
    setEdges(
      (prevEdges) => prevEdges.map((anEdge) => {
        if (anEdge.item === updatedEdge.item) {
          return updatedEdge;
        }
        return anEdge;
      })
    );
    const vizOffset = {
      offsetX: updatedEdge.edgeStart.x - mouseDownEdge.current.edgeStart.x,
      offsetY: updatedEdge.edgeStart.y - mouseDownEdge.current.edgeStart.y
    };
    const isFullWidthEdge = mouseDownEdge.current.edgeEnd.x - mouseDownEdge.current.edgeStart.x === canvasWidth;
    if (isFullWidthEdge) {
      layoutStructure.forEach((item) => {
        if (mouseDownEdge.current && item.position.y >= mouseDownEdge.current.edgeStart.y) {
          handleBlockItemPositionUpdate({
            item,
            offset: vizOffset
          });
        }
      });
    }
    if (selectedItemsForEdge.length > 0) {
      selectedItemsForEdge.forEach((itemId) => {
        var _a3;
        const item = getStructureItem(layoutStructure, itemId);
        if (!mouseDownEdge.current || isFullWidthEdge && item.position.y >= mouseDownEdge.current.edgeStart.y) {
          return;
        }
        let resizeDir;
        if (((_a3 = mouseDownEdge.current) == null ? void 0 : _a3.orientation) === "horizontal") {
          resizeDir = item.position.y >= mouseDownEdge.current.edgeStart.y ? "n" : "s";
        } else {
          resizeDir = item.position.x >= mouseDownEdge.current.edgeStart.x ? "w" : "e";
        }
        handleBlockItemResize(e, {
          itemId,
          offset: vizOffset,
          dir: resizeDir
        });
      });
    }
    setSnappableEdges(updatedSnappableEdges);
    if (((_c = mouseDownEdge == null ? void 0 : mouseDownEdge.current) == null ? void 0 : _c.orientation) === "horizontal" && ((_d = mouseDownEdge == null ? void 0 : mouseDownEdge.current) == null ? void 0 : _d.isCanvasEdge)) {
      const scrollVelocity = e.clientY - window.innerHeight + CANVAS_BOTTOM_PADDING * 2;
      edgeVelocity.current = scrollVelocity;
      setMousePosition(getClientPosition(e, mouseScale));
    }
  });
  (0, dashboard_ui_exports.useMouseMoveHandler)({
    onMouseMove: handleEdgeMove,
    isEnabled: mode === "edit",
    throttledMs: 32
  });
  (0, react_exports.useEffect)(() => {
    if (mode !== "edit" || edgeVelocity.current <= 0 || !mouseDownEdge.current || !edgeMouseDownPosition.current || !mousePosition) {
      return void 0;
    }
    const currEdge = mouseDownEdge.current;
    const isFullWidthEdge = currEdge.edgeEnd.x - currEdge.edgeStart.x === canvasWidth;
    if (!isFullWidthEdge) {
      return void 0;
    }
    const offset = edgeVelocity.current > 8 ? BOTTOM_EDGE_MAX_SPEED : BOTTOM_EDGE_MIN_SPEED;
    const edgeMousePos = edgeMouseDownPosition.current;
    const interval = setInterval(() => {
      cumulativeScrollIncrease.current += offset;
      const mouseOffset = getOffset(mousePosition, edgeMousePos);
      const updatedEdge = moveHorizontalEdge({
        edge: currEdge,
        offset: mouseOffset.offsetY + cumulativeScrollIncrease.current,
        edgeBoundaries: edgeBoundaries.current
      });
      setEdges(
        (prevEdges) => prevEdges.map((anEdge) => {
          if (anEdge.item === currEdge.item) {
            return __spreadProps(__spreadValues({}, anEdge), {
              edgeStart: {
                x: anEdge.edgeStart.x,
                y: updatedEdge.edgeStart.y
              },
              edgeEnd: {
                x: anEdge.edgeEnd.x,
                y: updatedEdge.edgeStart.y
              }
            });
          }
          return anEdge;
        })
      );
      const vizOffset = {
        offsetX: 0,
        offsetY: updatedEdge.edgeStart.y - currEdge.edgeStart.y
      };
      if (selectedItemsForEdge.length > 0) {
        selectedItemsForEdge.forEach((itemId) => {
          const resizeDir = "s";
          handleBlockItemResize(mousePosition, {
            itemId,
            offset: vizOffset,
            dir: resizeDir
          });
        });
      }
      if (canvasContext.current) {
        canvasContext.current.scrollTop += BOTTOM_RESIZING_SCROLL_SPEED;
      }
    }, 32);
    return () => {
      clearInterval(interval);
    };
  }, [
    mode,
    edgeVelocity,
    mousePosition,
    cumulativeScrollIncrease,
    canvasContext,
    canvasWidth,
    handleBlockItemResize,
    layoutStructure,
    selectedItemsForEdge
  ]);
  const handleEdgeMoved = (0, dashboard_ui_exports.useEventCallback)((e) => {
    e.preventDefault();
    mouseDownEdge.current = null;
    edgeMouseDownPosition.current = null;
    edgeBoundaries.current = null;
    edgesInBoundary.current = null;
    cumulativeScrollIncrease.current = 0;
    edgeVelocity.current = 0;
    if (isDraggingEdge.current) {
      isDraggingEdge.current = false;
      setSelectedItemsForEdge([]);
      handleBlockItemResized();
    }
    if (snappableEdges.length > 0) {
      setSnappableEdges([]);
    }
  });
  (0, react_exports.useEffect)(() => {
    if (mode !== "edit") {
      return void 0;
    }
    document.addEventListener("mouseup", handleEdgeMoved);
    return () => {
      document.removeEventListener("mouseup", handleEdgeMoved);
    };
  }, [handleEdgeMoved, mode]);
  (0, react_exports.useEffect)(() => {
    if (!keyboardListener) {
      return () => void 0;
    }
    const unsubscribeKeyboardListener = keyboardListener.subscribe(
      "cancel",
      () => {
        if (isBlockItemMoving) {
          cleanupAfterPreview();
          setIsBlockItemMoving(false);
          setMousePosition(null);
        } else {
          onLayoutItemsSelect([]);
        }
      }
    );
    return () => {
      unsubscribeKeyboardListener();
    };
  }, [
    cleanupAfterPreview,
    isBlockItemMoving,
    onLayoutItemsSelect,
    keyboardListener
  ]);
  const renderOutline = () => {
    const selectedItems = selectedItemsForEdge.length > 0 ? selectedItemsForEdge : getSelectedItems().map(({ id }) => id);
    const blockItems = getBlockItems(gridState);
    return blockItems.map((item) => {
      const displayOutline = selectedItems.includes(item.item) && (!isBlockItemMoving || showPreviewPlaceholder);
      if (displayOutline) {
        const paddedItem = applyVizPadding({
          item,
          padding: panelPadding
        });
        return /* @__PURE__ */ react_default.createElement(
          MemoizedBlockOutline,
          {
            handleDirections: HANDLE_DIRECTIONS,
            key: item.item,
            itemId: item.item,
            scale: mouseScale,
            x: paddedItem.position.x,
            y: paddedItem.position.y,
            w: paddedItem.position.w,
            h: paddedItem.position.h
          }
        );
      }
      return null;
    });
  };
  const getEdgeAppearance = (0, react_exports.useCallback)(
    ({ edge }) => {
      var _a2;
      const renderAllEdges = !mouseDownEdge.current;
      let appearance = renderAllEdges || edge.item === ((_a2 = mouseDownEdge.current) == null ? void 0 : _a2.item) || snappableEdges.find((e) => e.item === edge.item) ? "normal" : "hidden";
      if (isBlockItemMoving) {
        const itemToMove = layoutStructure.find(
          ({ item }) => {
            var _a3;
            return item === ((_a3 = getSelectedItems()[0]) == null ? void 0 : _a3.id);
          }
        );
        if (itemToMove && isDropOnOwnEdge({ edge, itemToMove })) {
          appearance = "hidden";
        } else {
          appearance = "dropTarget";
        }
      }
      if (invalidEdgeId === edge.item) {
        appearance = "invalid";
      }
      return appearance;
    },
    [
      invalidEdgeId,
      isBlockItemMoving,
      mouseDownEdge,
      snappableEdges,
      getSelectedItems,
      layoutStructure
    ]
  );
  const edgeItems = (0, react_exports.useMemo)(() => {
    if (mode !== "edit") {
      return null;
    }
    return edges.map((edge) => {
      const formattedEdge = formatEdgeWrapper({
        edge,
        padding: panelPadding
      });
      const { width, height } = getDimensions({
        edge: formattedEdge,
        thickness: 2 * panelPadding
      });
      const { x, y } = formattedEdge.edgeStart;
      return /* @__PURE__ */ react_default.createElement(
        MemoizedEdge,
        {
          key: edge.item,
          itemId: edge.item,
          x,
          y,
          w: width,
          h: height,
          padding: panelPadding,
          orientation: edge.orientation,
          isCanvasEdge: edge.isCanvasEdge,
          appearance: getEdgeAppearance({ edge }),
          onMouseDown: handleMouseDownOnEdge,
          "data-test-edge-position": `${edge.edgeStart.x},${edge.edgeStart.y}-${edge.edgeEnd.x},${edge.edgeEnd.y}`
        }
      );
    });
  }, [mode, edges, getEdgeAppearance, panelPadding, handleMouseDownOnEdge]);
  const handleRenderPreviewPlaceholderItem = (0, react_exports.useCallback)(() => {
    if (!firstSelectedItemStructure || !showPreviewPlaceholder) {
      return null;
    }
    const item = applyVizPadding({
      item: firstSelectedItemStructure,
      padding: panelPadding
    });
    return /* @__PURE__ */ react_default.createElement(
      PreviewPlaceholderItem,
      {
        key: `${firstSelectedItemStructure.item}-preview`,
        position: item.position
      }
    );
  }, [firstSelectedItemStructure, panelPadding, showPreviewPlaceholder]);
  const filteredState = (0, react_exports.useMemo)(
    () => getFilteredStructure(gridState, layoutStructure),
    [gridState, layoutStructure]
  );
  const items = getSelectedItems();
  const commonProps = {
    width: canvasWidth,
    height: maxHeight,
    scale,
    selectable: true,
    selectedLayoutItems: items,
    onItemSelected: handleItemSelected,
    panelPadding,
    ref: canvasRef
  };
  const modeSpecificProps = mode === "edit" ? {
    movable: true,
    showOverflowContent: false,
    showGrid,
    showBorder: true,
    gridWidth: GRID_SIZE_PX - 1,
    gridHeight: GRID_SIZE_PX - 1,
    gridLineWidth: 1,
    gridPadding: GRID_PADDING_PX,
    onItemMove: handleBlockItemMove,
    onItemMoved: handleBlockItemMoved,
    userSelect: false
  } : {
    movable: false,
    showOverflowContent: false,
    showGrid: false,
    showBorder: false,
    userSelect: true
  };
  return /* @__PURE__ */ react_default.createElement(
    GridCanvas_default,
    __spreadValues(__spreadValues({
      "data-test": "grid-layout",
      blockItems: filteredState,
      "data-test-scale": scale,
      backgroundColor
    }, commonProps), modeSpecificProps),
    /* @__PURE__ */ react_default.createElement(Layer_default, { key: "block-item-layer", "data-test": "block-item-layer" }, renderBlockItems({
      layoutStructure: filteredState,
      renderLayoutItem,
      handleItemSelected,
      isBlockItemMoving,
      selectedItem: getSelectedItems()[0],
      mode,
      errors: layoutErrors,
      padding: panelPadding,
      canvasHeight: maxHeight
    })),
    edgeItems,
    /* @__PURE__ */ react_default.createElement(Layer_default, { key: "outline-layer", "data-test": "outline-layer" }, renderOutline()),
    mousePosition && isBlockItemMoving && handleRenderItemDropTarget(),
    mousePosition && isBlockItemMoving && handleRenderPreviewPlaceholderItem(),
    mousePosition && isBlockItemMoving && /* @__PURE__ */ react_default.createElement(
      ItemDragPlaceholder,
      {
        position: mousePosition,
        size: PLACEHOLDER_SIZE_PX
      }
    )
  );
};
var GridLayout = (props) => {
  const {
    containerWidth,
    containerHeight,
    options: { width: canvasWidth = gridLayoutOptions.width } = {},
    onLayoutStructureChange,
    layoutStructure
  } = props;
  const { enableGridLayoutCssScaling } = (0, dashboard_context_exports.useFeatureFlags)();
  const scrollbarWidth = (0, dashboard_utils_exports.getScrollbarWidth)();
  const [canvasHeight, setCanvasHeight] = (0, react_exports.useState)(
    () => computeMaxHeight(layoutStructure)
  );
  const scale = (0, react_exports.useMemo)(
    () => computeScaleToFit({
      canvasWidth,
      canvasHeight,
      containerWidth,
      containerHeight,
      scrollbarWidth,
      enableGridLayoutCssScaling
    }),
    [
      enableGridLayoutCssScaling,
      canvasWidth,
      canvasHeight,
      containerWidth,
      containerHeight,
      scrollbarWidth
    ]
  );
  const handleLayoutStructureChange = (0, react_exports.useCallback)(
    (layout) => {
      onLayoutStructureChange(
        scaleGridLayoutStructureByWidth({
          layout,
          scale: 1 / scale
        })
      );
    },
    [scale, onLayoutStructureChange]
  );
  const scaledLayoutStructure = (0, react_exports.useMemo)(
    () => !enableGridLayoutCssScaling ? scaleGridLayoutStructureByWidth({
      layout: layoutStructure,
      scale
    }) : layoutStructure,
    [enableGridLayoutCssScaling, layoutStructure, scale]
  );
  const sortedLayoutStructure = (0, react_exports.useMemo)(
    () => getGridLayoutOrder({
      layout: scaledLayoutStructure,
      canvasWidth,
      canvasHeight: computeMaxHeight(scaledLayoutStructure)
    }),
    [canvasWidth, scaledLayoutStructure]
  );
  return /* @__PURE__ */ react_default.createElement(
    BaseGridLayout,
    __spreadValues(__spreadProps(__spreadValues({}, props), {
      scale,
      canvasWidth,
      layoutStructure: sortedLayoutStructure,
      setCanvasHeight
    }), !enableGridLayoutCssScaling ? {
      canvasWidth: containerWidth - scrollbarWidth,
      onLayoutStructureChange: handleLayoutStructureChange
    } : null)
  );
};
var GridLayout_default = withLayoutShowHide(GridLayout, {
  schema: gridLayoutOptionsSchema_default,
  reflowFn: gridLayoutShowHideReflow
});
//# sourceMappingURL=GridLayout.js.map
