/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/GridLayoutConstants.ts
var GridLayoutConstants_exports = {};
__export(GridLayoutConstants_exports, {
  CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL: () => CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL,
  EDGE_PREVIEW_DELAY_MS: () => EDGE_PREVIEW_DELAY_MS,
  EDGE_THICKNESS_PX: () => EDGE_THICKNESS_PX,
  GRID_PADDING_PX: () => GRID_PADDING_PX,
  GRID_SIZE_PX: () => GRID_SIZE_PX,
  ITEM_DROP_TARGET_PX: () => ITEM_DROP_TARGET_PX,
  MIN_HEIGHT_PX: () => MIN_HEIGHT_PX,
  MIN_WIDTH_PX: () => MIN_WIDTH_PX,
  PLACEHOLDER_SIZE_PX: () => PLACEHOLDER_SIZE_PX,
  SNAP_RANGE_PX: () => SNAP_RANGE_PX,
  VIZ_DEFAULT_HEIGHT_PX: () => VIZ_DEFAULT_HEIGHT_PX,
  VIZ_PREVIEW_DELAY_MS: () => VIZ_PREVIEW_DELAY_MS
});
module.exports = __toCommonJS(GridLayoutConstants_exports);

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// src/GridLayoutConstants.ts
var CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL = (0, i18n_exports._)(
  "This panel is too small to be split into duplicates. Stretch or move the panel to make it bigger first."
);
var EDGE_THICKNESS_PX = 4;
var GRID_PADDING_PX = 1;
var GRID_SIZE_PX = 10;
var MIN_HEIGHT_PX = 64;
var MIN_WIDTH_PX = 64;
var SNAP_RANGE_PX = 8;
var PLACEHOLDER_SIZE_PX = 128;
var ITEM_DROP_TARGET_PX = 12;
var VIZ_DEFAULT_HEIGHT_PX = 400;
var VIZ_PREVIEW_DELAY_MS = 50;
var EDGE_PREVIEW_DELAY_MS = 500;
//# sourceMappingURL=GridLayoutConstants.js.map
