/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/GridLayoutViewer.tsx
var GridLayoutViewer_exports = {};
__export(GridLayoutViewer_exports, {
  default: () => GridLayoutViewer_default
});
module.exports = __toCommonJS(GridLayoutViewer_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport2 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport3 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/dashboard-ui
var dashboard_ui_exports = {};
__export(dashboard_ui_exports, {
  default: () => dashboard_ui_default
});
var defaultImport4 = __toESM(require("@splunk/dashboard-ui"));
__reExport(dashboard_ui_exports, require("@splunk/dashboard-ui"));
var dashboard_ui_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport5 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/dashboard-utils
var dashboard_utils_exports = {};
__export(dashboard_utils_exports, {
  default: () => dashboard_utils_default
});
var defaultImport6 = __toESM(require("@splunk/dashboard-utils"));
__reExport(dashboard_utils_exports, require("@splunk/dashboard-utils"));
var dashboard_utils_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// src/BaseLayout.jsx
var BaseLayout = class extends react_exports.Component {
  render() {
    return null;
  }
};
__publicField(BaseLayout, "propTypes", {
  /**
   * dashboard mode
   */
  mode: prop_types_default.string,
  /**
   * whether gridlines should be displayed in edit mode
   */
  showGrid: prop_types_default.bool,
  /**
   * layout formatting options
   */
  options: prop_types_default.object,
  /**
   * layout structure
   */
  layoutStructure: prop_types_default.arrayOf(prop_types_default.any),
  /**
   * container width in pixel
   */
  containerWidth: prop_types_default.number,
  /**
   * container height in pixel
   */
  containerHeight: prop_types_default.number,
  /**
   * list of selected items
   */
  selectedItems: prop_types_default.arrayOf(
    prop_types_default.shape({ id: prop_types_default.string, type: prop_types_default.oneOf(["block", "line", "input"]) })
  ),
  /**
   * layout item render prop
   */
  renderLayoutItem: prop_types_default.func,
  /**
   * callback when items are selected
   */
  onLayoutItemsSelect: prop_types_default.func,
  /**
   * callback to trigger event
   */
  onEventTrigger: prop_types_default.func,
  /**
   * callback when layout structure changed
   */
  onLayoutStructureChange: prop_types_default.func,
  /**
   * layoutApi ref
   */
  layoutApiRef: prop_types_default.func
});
__publicField(BaseLayout, "defaultProps", {
  mode: "view",
  options: {},
  showGrid: true,
  layoutStructure: [],
  selectedItems: [],
  renderLayoutItem: dashboard_utils_exports.noop,
  onEventTrigger: dashboard_utils_exports.noop,
  onLayoutStructureChange: dashboard_utils_exports.noop,
  onLayoutItemsSelect: dashboard_utils_exports.noop,
  layoutApiRef: dashboard_utils_exports.noop
});
var BaseLayout_default = BaseLayout;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport7 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/dashboard-context
var dashboard_context_exports = {};
__export(dashboard_context_exports, {
  default: () => dashboard_context_default
});
var defaultImport8 = __toESM(require("@splunk/dashboard-context"));
__reExport(dashboard_context_exports, require("@splunk/dashboard-context"));
var dashboard_context_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/dashboard-telemetry
var dashboard_telemetry_exports = {};
__export(dashboard_telemetry_exports, {
  default: () => dashboard_telemetry_default
});
var defaultImport9 = __toESM(require("@splunk/dashboard-telemetry"));
__reExport(dashboard_telemetry_exports, require("@splunk/dashboard-telemetry"));
var dashboard_telemetry_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// src/utils/imageUtils.ts
var getImageDimension = (0, lodash_exports.memoize)(
  (imgSrc) => {
    const img = new Image();
    try {
      img.src = imgSrc;
      img.style.position = "absolute";
      img.style.left = "-9999";
      img.style.visibility = "hidden";
      document.body.appendChild(img);
      const height = img.naturalHeight;
      const width = img.naturalWidth;
      return { width, height };
    } catch (e) {
      return { width: 0, height: 0 };
    } finally {
      if (document.body.contains(img)) {
        document.body.removeChild(img);
      }
    }
  }
);
var validateOpacity = (opacity) => {
  if (typeof opacity !== "number" || opacity > 1) {
    return 1;
  }
  if (opacity < 0) {
    return 0;
  }
  return opacity;
};

// src/hooks/useBackgroundImage.ts
var useBackgroundImage = (backgroundImageSrc) => {
  const [imageSrc, setImageSrc] = (0, react_exports.useState)("");
  const imageRegistry = (0, dashboard_context_exports.useImageRegistry)();
  const fetchBackgroundImage = (registry, bgImageSrc) => __async(void 0, null, function* () {
    try {
      if (registry) {
        if (registry.isResourceURL(bgImageSrc)) {
          const imageObject = yield registry.getByURL(bgImageSrc);
          setImageSrc(imageObject.dataURI);
        } else {
          setImageSrc(bgImageSrc);
        }
      } else {
        setImageSrc(bgImageSrc);
      }
    } catch (error) {
      if (error instanceof Error) {
        dashboard_utils_exports.console.error(error.message);
      } else {
        dashboard_utils_exports.console.error("An unknown error occurred");
      }
    }
  });
  (0, react_exports.useEffect)(() => {
    if (backgroundImageSrc) {
      fetchBackgroundImage(
        imageRegistry,
        backgroundImageSrc
      );
    } else {
      setImageSrc("");
    }
  }, [imageRegistry, backgroundImageSrc]);
  return imageSrc;
};

// esm-externals:@splunk/dashboard-state
var dashboard_state_exports = {};
__export(dashboard_state_exports, {
  default: () => dashboard_state_default
});
var defaultImport10 = __toESM(require("@splunk/dashboard-state"));
__reExport(dashboard_state_exports, require("@splunk/dashboard-state"));
var dashboard_state_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/datasource-utils
var datasource_utils_exports = {};
__export(datasource_utils_exports, {
  default: () => datasource_utils_default
});
var defaultImport11 = __toESM(require("@splunk/datasource-utils"));
__reExport(datasource_utils_exports, require("@splunk/datasource-utils"));
var datasource_utils_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// src/utils/edgeUtils.ts
var applyVizPadding = ({
  item,
  padding = 0
}) => {
  const { x, y, w, h } = item.position;
  return __spreadProps(__spreadValues({}, item), {
    position: {
      x: x + padding,
      y: y + padding,
      w: w - 2 * padding,
      h: h - 2 * padding
    }
  });
};

// src/utils/layoutUtils.ts
var computeMaxHeight = dashboard_utils_exports.computeMaxHeight;
var isBlockPositionValid = (position) => !!(position && Number.isInteger(position.x) && Number.isInteger(position.y) && Number.isInteger(position.w) && Number.isInteger(position.h));
var isValidConnection = (connection) => {
  if ("x" in connection && "y" in connection && Number.isInteger(connection.x) && Number.isInteger(connection.y)) {
    return true;
  }
  if ("item" in connection && "port" in connection && connection.item != null && connection.port != null) {
    return true;
  }
  return false;
};
var isLinePositionValid = (position) => {
  if (position.from != null && position.to != null) {
    return isValidConnection(position.from) && isValidConnection(position.to);
  }
  return false;
};
var removeInvalidItems = (layoutStructure = []) => layoutStructure.filter((structure) => {
  if (structure.type === "line") {
    return isLinePositionValid(structure.position);
  }
  return isBlockPositionValid(structure.position);
});
var positionToStyle = (pos) => ({
  width: `${pos.w}px`,
  height: `${pos.h}px`,
  transform: `translate(${pos.x}px, ${pos.y}px)`
});
var getClientPosition = (e, scaleFactor = 1) => ({
  x: Math.round(e.clientX / scaleFactor),
  y: Math.round(e.clientY / scaleFactor)
});
var getOffset = (currentPosition, startPosition) => ({
  offsetX: currentPosition.x - startPosition.x,
  offsetY: currentPosition.y - startPosition.y
});
var considerMoved = ({
  offsetX,
  offsetY
}) => offsetX !== 0 || offsetY !== 0;
var positionsToBoundary = (startPos, endPos) => ({
  x: Math.min(startPos.x, endPos.x),
  y: Math.min(startPos.y, endPos.y),
  w: Math.abs(startPos.x - endPos.x),
  h: Math.abs(startPos.y - endPos.y)
});
var filterBlockItemsByBoundary = (items, boundary) => items.filter((item) => {
  const itemPosition = item.position;
  return !(boundary.x > itemPosition.x + itemPosition.w || boundary.x + boundary.w < itemPosition.x || boundary.y > itemPosition.y + itemPosition.h || boundary.y + boundary.h < itemPosition.y);
});
var findTopBlockItemByPosition = (items, pos, padding = 0) => (0, lodash_exports.findLast)(items, (item) => {
  const itemPosition = padding ? applyVizPadding({ item, padding }).position : item.position;
  return itemPosition.x <= pos.x && itemPosition.x + itemPosition.w >= pos.x && itemPosition.y <= pos.y && itemPosition.y + itemPosition.h >= pos.y;
});
var computeRelativePosition = (e, canvasRef, scale = 1) => {
  var _a;
  const pos = getClientPosition(e, scale);
  const canvasDomNode = canvasRef == null ? void 0 : canvasRef.current;
  const rect = (_a = canvasDomNode == null ? void 0 : canvasDomNode.getBoundingClientRect) == null ? void 0 : _a.call(canvasDomNode);
  if (pos && rect) {
    return {
      x: pos.x - rect.left / scale,
      y: pos.y - rect.top / scale
    };
  }
  return pos;
};

// src/hooks/useMouseDownWithHandleEventListeners.ts
var useMouseDownWithHandleEventListeners = ({
  handleMouseDownOnItem,
  canvasRef,
  scale,
  setStartPosition,
  movable,
  setIsMoving,
  isMovingRef
}) => {
  const handleMouseDownOnVizWithHandle = (0, dashboard_ui_exports.useEventCallback)(
    (e) => {
      const { vizId, initialEvent, type } = e.detail;
      const pos = computeRelativePosition(initialEvent, canvasRef, scale);
      setStartPosition(pos);
      const block = {
        id: vizId,
        type
      };
      handleMouseDownOnItem(initialEvent, block);
    }
  );
  const handleMouseDownOnHandle = (0, dashboard_ui_exports.useEventCallback)((e) => {
    const { vizId, initialEvent, type } = e.detail;
    const pos = computeRelativePosition(initialEvent, canvasRef, scale);
    setStartPosition(pos);
    const block = {
      id: vizId,
      type
    };
    handleMouseDownOnItem(initialEvent, block);
    if (movable) {
      setIsMoving(true);
      if (isMovingRef) {
        isMovingRef.current = true;
      }
    }
  });
  (0, dashboard_ui_exports.useEventListener)({
    eventName: dashboard_ui_exports.EVENT_MOUSE_DOWN_ON_VIZ_WITH_HANDLE,
    target: document,
    listener: handleMouseDownOnVizWithHandle
  });
  (0, dashboard_ui_exports.useEventListener)({
    eventName: dashboard_ui_exports.EVENT_MOUSE_DOWN_ON_HANDLE,
    target: document,
    listener: handleMouseDownOnHandle
  });
};

// esm-externals:rxjs
var rxjs_exports = {};
__export(rxjs_exports, {
  default: () => rxjs_default
});
var defaultImport12 = __toESM(require("rxjs"));
__reExport(rxjs_exports, require("rxjs"));
var rxjs_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// src/AbsoluteLayoutConstants.ts
var GRID_SIZE = 10;
var MIN_WIDTH = GRID_SIZE * 2;
var MIN_HEIGHT = GRID_SIZE * 2;

// src/components/Canvas/BackgroundImage.tsx
var toBackgroundImageSize = ({
  src,
  imageHeight,
  imageWidth,
  sizeType
}) => {
  const { width: w, height: h } = getImageDimension(src != null ? src : "");
  if (imageWidth && imageHeight) {
    return `${(0, dashboard_utils_exports.toPx)(imageWidth)} ${(0, dashboard_utils_exports.toPx)(imageHeight)}`;
  }
  if (imageWidth || imageHeight) {
    return `${(0, dashboard_utils_exports.toPx)(imageWidth != null ? imageWidth : w)} ${(0, dashboard_utils_exports.toPx)(imageHeight != null ? imageHeight : h)}`;
  }
  return sizeType != null ? sizeType : "contain";
};
var BackgroundImageDiv = styled_components_default.div.attrs(() => ({
  "data-test": "background-image"
}))`
    ${themes_exports.mixins.reset("inline-block")};
    width: 100%;
    height: 100%;
    position: relative;
    background-repeat: no-repeat;
    background-image: ${(props) => `url("${props.src}")`};
    background-size: ${(props) => toBackgroundImageSize(props)};
    background-position: ${(props) => `${(0, dashboard_utils_exports.toPx)(props.imageX)} ${(0, dashboard_utils_exports.toPx)(props.imageY)}`};
    opacity: ${(prop) => validateOpacity(prop.opacity)};
`;
var BackgroundImage = (_a) => {
  var _b = _a, { src } = _b, rest = __objRest(_b, ["src"]);
  const imageSrc = useBackgroundImage(src);
  if (!imageSrc) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(BackgroundImageDiv, __spreadProps(__spreadValues({}, rest), { src: imageSrc }));
};

// src/components/Canvas/CanvasBorder.tsx
var Border = styled_components_default.div.attrs(() => ({
  "data-test": "canvas-border"
}))`
    position: absolute;
    box-sizing: border-box;
    border: 2px dashed
        ${(0, themes_exports.pick)({
  enterprise: {
    light: themes_exports.variables.gray80,
    dark: themes_exports.variables.gray30
  },
  prisma: themes_exports.variables.interactiveColorBorder
})};
    left: 0px;
    top: 0px;
    right: 0px;
    bottom: 0px;
    width: 100%;
    height: 100%;
`;
var CanvasBorder = ({
  showBorder = false
}) => {
  if (!showBorder) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(Border, null);
};

// src/components/Canvas/CanvasGridlines.tsx
var GRID_LINE_OPACITY = 0.1;
var getGridLineColor = (props) => {
  var _a;
  return (_a = props.gridLineColor) != null ? _a : (0, themes_exports.pick)({
    light: "#D8D8D8",
    dark: "#9B9B9B"
  });
};
var GridLines = styled_components_default.div`
    position: absolute;
    box-sizing: border-box;
    left: 0px;
    top: 0px;
    right: 0px;
    bottom: 0px;
    width: 100%;
    height: 100%;
    opacity: ${(prop) => {
  var _a;
  return (_a = prop.gridLineOpacity) != null ? _a : GRID_LINE_OPACITY;
}};
    background-size: ${(prop) => prop.gridWidth + prop.gridLineWidth}px
        ${(prop) => prop.gridHeight + prop.gridLineWidth}px;
    background-image: repeating-linear-gradient(
            0deg,
            ${getGridLineColor},
            ${getGridLineColor} ${(prop) => (0, dashboard_utils_exports.toPx)(prop.gridLineWidth)},
            transparent ${(prop) => prop.gridLineWidth}px,
            transparent ${(prop) => prop.gridHeight + prop.gridLineWidth}px
        ),
        repeating-linear-gradient(
            -90deg,
            ${getGridLineColor},
            ${getGridLineColor} ${(prop) => (0, dashboard_utils_exports.toPx)(prop.gridLineWidth)},
            transparent ${(prop) => prop.gridLineWidth}px,
            transparent ${(prop) => prop.gridWidth + prop.gridLineWidth}px
        );
`;
var CanvasGridlines = (_a) => {
  var _b = _a, { showGrid } = _b, rest = __objRest(_b, ["showGrid"]);
  if (!showGrid) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(GridLines, __spreadProps(__spreadValues({}, rest), { "data-test": "gridlines" }));
};

// src/components/Canvas/Background.tsx
var toScale = (scale) => scale ? {
  transform: `scale(${scale})`,
  transformOrigin: "0 0",
  width: `${100 / scale}%`
} : {
  width: "100%"
};
var Background = styled_components_default.div.attrs((props) => ({
  style: __spreadValues({
    height: props.height
  }, toScale(props.scale))
}))`
    ${themes_exports.mixins.reset("inline-block")};
    position: relative;
    background: ${(prop) => prop.bgColor || // NOTE: this needs to match packages/dashboard-editors/src/layouts/AbsoluteLayoutEditor.jsx
dashboard_ui_exports.customThemeVariables.dashboardBackgroundColor};
`;

// src/components/Canvas/Canvas.tsx
var CanvasContainer = styled_components_default.div.attrs((props) => ({
  style: { width: props.width, height: props.height }
}))`
    ${themes_exports.mixins.reset("block")};
    overflow: ${(prop) => prop.showOverflowContent ? "visible" : "hidden"};
    user-select: ${(prop) => prop.userSelect ? "text" : "none"};
    position: relative;
`;
var Canvas = (_a, canvasRef) => {
  var _b = _a, {
    width,
    height,
    scale,
    backgroundColor: unsanitizedBgColor = "",
    backgroundImageSrc,
    backgroundImageSizeType,
    backgroundImageWidth,
    backgroundImageHeight,
    backgroundImagePositionX,
    backgroundImagePositionY,
    backgroundImageOpacity,
    gridLineOpacity,
    children,
    showOverflowContent = false,
    userSelect = false,
    showGrid = false,
    gridPadding = 0,
    gridLineWidth = 1,
    gridLineColor,
    gridWidth = 9,
    gridHeight = 9,
    showBorder = false,
    cssScaling = true
  } = _b, others = __objRest(_b, [
    "width",
    "height",
    "scale",
    "backgroundColor",
    "backgroundImageSrc",
    "backgroundImageSizeType",
    "backgroundImageWidth",
    "backgroundImageHeight",
    "backgroundImagePositionX",
    "backgroundImagePositionY",
    "backgroundImageOpacity",
    "gridLineOpacity",
    "children",
    "showOverflowContent",
    "userSelect",
    "showGrid",
    "gridPadding",
    "gridLineWidth",
    "gridLineColor",
    "gridWidth",
    "gridHeight",
    "showBorder",
    "cssScaling"
  ]);
  const containerWidth = scale != null ? width * scale : width;
  const containerHeight = scale != null && cssScaling ? height * scale : height;
  const backgroundColor = (0, dashboard_ui_exports.sanitizeColor)(unsanitizedBgColor);
  return /* @__PURE__ */ react_default.createElement(
    CanvasContainer,
    __spreadValues({
      "data-test": "canvas-container",
      "data-width": containerWidth,
      "data-height": containerHeight,
      width: cssScaling ? containerWidth : width,
      height: containerHeight,
      showOverflowContent,
      userSelect,
      ref: canvasRef
    }, others),
    /* @__PURE__ */ react_default.createElement(
      Background,
      {
        "data-test": "canvas",
        "data-width": width,
        "data-height": height,
        "data-scale": scale,
        height,
        scale: cssScaling ? scale : void 0,
        bgColor: backgroundColor
      },
      /* @__PURE__ */ react_default.createElement(
        BackgroundImage,
        {
          src: backgroundImageSrc,
          sizeType: backgroundImageSizeType,
          imageWidth: backgroundImageWidth,
          imageHeight: backgroundImageHeight,
          imageX: backgroundImagePositionX,
          imageY: backgroundImagePositionY,
          opacity: backgroundImageOpacity
        }
      ),
      /* @__PURE__ */ react_default.createElement(CanvasBorder, { showBorder }),
      /* @__PURE__ */ react_default.createElement(
        CanvasGridlines,
        {
          showGrid,
          gridLineOpacity,
          gridPadding,
          gridLineWidth,
          gridLineColor,
          gridWidth,
          gridHeight
        }
      ),
      children
    )
  );
};
var Canvas_default = (0, react_exports.forwardRef)(Canvas);

// src/components/SelectBox.jsx
var SelectDiv = styled_components_default.div.attrs(({ x, y, w, h }) => ({
  style: {
    width: w,
    height: h,
    transform: `translate(${x}px, ${y}px)`
  }
}))`
    ${themes_exports.mixins.reset("block")};
    position: absolute;
    background: transparent;
    // the next line is important to avoid blocking the drilldowns, and it allows to select text from visualizations
    pointer-events: none;
    border: 1px solid
        ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    z-index: 1000;
`;
var Wrapper = styled_components_default.div`
    ${themes_exports.mixins.reset("block")};
    background: transparent;
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
`;
var SelectBox = ({ start, end }) => /* @__PURE__ */ react_default.createElement(Wrapper, null, /* @__PURE__ */ react_default.createElement(
  SelectDiv,
  {
    w: Math.abs(start.x - end.x),
    h: Math.abs(start.y - end.y),
    x: Math.min(start.x, end.x),
    y: Math.min(start.y, end.y)
  }
));
SelectBox.propTypes = {
  /**
   * starting position
   */
  start: prop_types_default.shape({
    x: prop_types_default.number,
    y: prop_types_default.number
  }),
  /**
   * end position
   */
  end: prop_types_default.shape({
    x: prop_types_default.number,
    y: prop_types_default.number
  })
};
var SelectBox_default = SelectBox;

// src/utils/findStatusIcon.ts
var findStatusIcon = ({
  canvasRef,
  id
}) => {
  const canvas = canvasRef == null ? void 0 : canvasRef.current;
  if (!canvas) {
    return null;
  }
  return canvas.querySelector(
    `[data-id="${id}"] [data-test="simple-status-icon-container"]`
  );
};

// src/components/AbsoluteCanvas.tsx
var defaultState = {
  startPosition: null,
  currentPosition: null,
  isMoving: false,
  isSelecting: false
};
var DEFAULT_SELECTED_LAYOUT_ITEMS = [];
var AbsoluteCanvas = (props) => {
  const _a = props, {
    scale,
    children,
    canvasRef,
    blockItems,
    onItemMove = dashboard_utils_exports.noop,
    onItemMoved = dashboard_utils_exports.noop,
    onItemSelected,
    movable = false,
    allowMultiselect,
    selectedLayoutItems = DEFAULT_SELECTED_LAYOUT_ITEMS,
    initialState = defaultState,
    onMouseDownCapture,
    onMouseUpCapture
  } = _a, canvasProps = __objRest(_a, [
    "scale",
    "children",
    "canvasRef",
    "blockItems",
    "onItemMove",
    "onItemMoved",
    "onItemSelected",
    "movable",
    "allowMultiselect",
    "selectedLayoutItems",
    "initialState",
    "onMouseDownCapture",
    "onMouseUpCapture"
  ]);
  const [startPosition, setStartPosition] = (0, react_exports.useState)(
    initialState.startPosition
  );
  const [currentPosition, setCurrentPosition] = (0, react_exports.useState)(
    initialState.currentPosition
  );
  const [isMoving, setIsMoving] = (0, react_exports.useState)(initialState.isMoving);
  const [isSelecting, setIsSelecting] = (0, react_exports.useState)(initialState.isSelecting);
  const isMovingRef = (0, react_exports.useRef)(false);
  const { isMouseDownOnItemWithHandle, setIsMouseDownOnItemWithHandle } = (0, dashboard_context_exports.useMouseEventsContext)();
  const isMetaKeyUsed = (0, react_exports.useRef)(false);
  const isSelectedWithMetaKey = (0, react_exports.useRef)(false);
  const isMacOS = (0, dashboard_utils_exports.isMac)();
  const profiler = (0, dashboard_telemetry_exports.useDashboardProfiler)();
  const resetState = (0, react_exports.useCallback)(() => {
    setStartPosition(defaultState.startPosition);
    setCurrentPosition(defaultState.currentPosition);
    setIsMoving(defaultState.isMoving);
    setIsSelecting(defaultState.isSelecting);
    isMovingRef.current = false;
    isMetaKeyUsed.current = false;
    isSelectedWithMetaKey.current = false;
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isMovingRef.current && blockItems && (profiler == null ? void 0 : profiler.hasPartialMeasurement(dashboard_telemetry_exports.VIZ_MOVE_EVENT))) {
      profiler == null ? void 0 : profiler.endMeasurement(dashboard_telemetry_exports.VIZ_MOVE_EVENT);
    }
  }, [blockItems, profiler]);
  (0, react_exports.useEffect)(() => {
    if (selectedLayoutItems.length) {
      profiler == null ? void 0 : profiler.emitAndClearTimer({
        timerName: dashboard_telemetry_exports.VIZ_SELECT_EVENT,
        metadata: {
          numOfSelectedItems: selectedLayoutItems.length
        }
      });
    }
  }, [profiler, selectedLayoutItems]);
  const handleItemSelected = (0, react_exports.useCallback)(
    (e, items = []) => {
      if (items.some(
        ({ id, type }) => {
          var _a2;
          return type === "input" && ((_a2 = findStatusIcon({ canvasRef, id })) == null ? void 0 : _a2.contains(
            e.target
          ));
        }
      )) {
        return;
      }
      profiler == null ? void 0 : profiler.startTimer({
        timerName: dashboard_telemetry_exports.VIZ_SELECT_EVENT
      });
      if (isMacOS && e.metaKey || !isMacOS && e.ctrlKey) {
        const selectedItems = selectedLayoutItems.filter(
          ({ type }) => type === "block" || type === "input"
        );
        isSelectedWithMetaKey.current = true;
        onItemSelected(e, (0, lodash_exports.uniqBy)([...selectedItems, ...items], "id"));
      } else {
        onItemSelected(e, items);
      }
    },
    [canvasRef, profiler, selectedLayoutItems, onItemSelected, isMacOS]
  );
  const handleMouseDownOnItem = (0, react_exports.useCallback)(
    (event, blockItem) => {
      if (isMacOS && event.metaKey || !isMacOS && event.ctrlKey) {
        isMetaKeyUsed.current = true;
      }
      const { id, type = "block" } = blockItem;
      if (selectedLayoutItems.find(
        ({ id: selectedId }) => selectedId === id
      )) {
        return;
      }
      handleItemSelected(event, [{ id, type }]);
    },
    [handleItemSelected, selectedLayoutItems, isMacOS]
  );
  const handleMouseMove = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (!startPosition) {
      return;
    }
    const newPosition = computeRelativePosition(e, canvasRef, scale);
    const offset = getOffset(newPosition, startPosition);
    if (isMoving && considerMoved(offset)) {
      e.stopImmediatePropagation();
      e.preventDefault();
      onItemMove(e, offset);
    }
    setCurrentPosition(newPosition);
  });
  const handleMouseUpWithMetaKey = (event, item) => {
    var _a2;
    if (!item) {
      return;
    }
    const { item: itemId } = item;
    if (itemId && isMetaKeyUsed.current && !isSelectedWithMetaKey.current) {
      const selectedItems = selectedLayoutItems.filter(
        ({ type }) => type === "block" || type === "input"
      );
      const alreadySelected = selectedItems.filter(
        (element) => element.id === itemId
      );
      if (alreadySelected.length) {
        const removedAlreadySelected = selectedItems.filter(
          (element) => element.id !== itemId
        );
        onItemSelected(
          event,
          (0, lodash_exports.uniqBy)([...removedAlreadySelected], "id")
        );
      } else {
        handleItemSelected(event, [
          { id: itemId, type: (_a2 = item == null ? void 0 : item.type) != null ? _a2 : "block" }
        ]);
      }
    }
  };
  const handleMouseUp = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (!startPosition) {
      return;
    }
    e.preventDefault();
    const curPosition = computeRelativePosition(e, canvasRef, scale);
    const offset = getOffset(curPosition, startPosition);
    const isMoved = considerMoved(offset);
    if (isMoving && isMoved) {
      isMovingRef.current = false;
      onItemMoved(e, offset);
    } else if (isSelecting) {
      const boundary = positionsToBoundary(startPosition, curPosition);
      const selectedBlocks = filterBlockItemsByBoundary(
        blockItems,
        boundary
      ).map(
        ({ item, type = "block" }) => ({
          id: item,
          type
        })
      );
      let selectedBlockItems = [];
      if (!isMoved && selectedBlocks.length) {
        selectedBlockItems.push((0, lodash_exports.last)(selectedBlocks));
      } else {
        selectedBlockItems = selectedBlocks;
      }
      handleItemSelected(e, selectedBlockItems);
    } else {
      const item = findTopBlockItemByPosition(blockItems, curPosition);
      const { item: itemId, type = "block" } = item != null ? item : {};
      if (isMetaKeyUsed.current) {
        handleMouseUpWithMetaKey(e, item);
      } else if (itemId && !(selectedLayoutItems.length === 1 && selectedLayoutItems[0].id === itemId) && !isMoved && !isMetaKeyUsed.current) {
        handleItemSelected(e, [{ id: itemId, type }]);
      } else if (!itemId && !findTopBlockItemByPosition(blockItems, startPosition)) {
        handleItemSelected(e, []);
      }
    }
    resetState();
  });
  const handleMouseDown = (0, dashboard_ui_exports.useEventCallback)(
    (e, selectedBlockItem) => {
      if (isMouseDownOnItemWithHandle == null ? void 0 : isMouseDownOnItemWithHandle.current) {
        setIsMouseDownOnItemWithHandle(false);
        return;
      }
      const pos = computeRelativePosition(e, canvasRef, scale);
      setStartPosition(pos);
      const block = selectedBlockItem != null ? selectedBlockItem : findTopBlockItemByPosition(blockItems, pos);
      if (!block) {
        if (allowMultiselect) {
          setIsSelecting(true);
        }
        return;
      }
      const { item, type } = block;
      handleMouseDownOnItem(e, {
        id: item,
        type
      });
      if (movable) {
        setIsMoving(true);
        isMovingRef.current = true;
      }
    }
  );
  const handleMouseDownCapture = (0, dashboard_ui_exports.useEventCallback)((e) => {
    onMouseDownCapture == null ? void 0 : onMouseDownCapture(e);
    const pos = computeRelativePosition(e, canvasRef, scale);
    const selectedBlockItems = blockItems.filter(
      (item) => selectedLayoutItems.some(
        (selectedItem) => selectedItem.id === item.item
      )
    );
    const topSelectedBlock = findTopBlockItemByPosition(
      selectedBlockItems,
      pos
    );
    const topBlock = findTopBlockItemByPosition(blockItems, pos);
    if (topSelectedBlock && topSelectedBlock !== topBlock) {
      handleMouseDown(e, topSelectedBlock);
      e.stopPropagation();
      e.preventDefault();
    }
  });
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mousemove", handleMouseMove, true);
    return () => {
      document.removeEventListener("mousemove", handleMouseMove, true);
    };
  }, [handleMouseMove]);
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mouseup", handleMouseUp);
    return () => {
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [handleMouseUp]);
  useMouseDownWithHandleEventListeners({
    handleMouseDownOnItem,
    canvasRef,
    scale,
    setStartPosition,
    movable,
    setIsMoving,
    isMovingRef
  });
  const selectBox = (0, react_exports.useMemo)(() => {
    if (allowMultiselect && isSelecting && !isMoving && startPosition && currentPosition) {
      return /* @__PURE__ */ react_default.createElement(SelectBox_default, { start: startPosition, end: currentPosition });
    }
    return null;
  }, [
    allowMultiselect,
    isSelecting,
    isMoving,
    startPosition,
    currentPosition
  ]);
  return /* @__PURE__ */ react_default.createElement(
    Canvas_default,
    __spreadProps(__spreadValues({
      ref: canvasRef
    }, canvasProps), {
      scale,
      onMouseDown: handleMouseDown,
      onContextMenu: resetState,
      onMouseDownCapture: handleMouseDownCapture,
      onMouseUpCapture
    }),
    selectBox,
    children
  );
};
var AbsoluteCanvas_default = (0, react_exports.forwardRef)((props, ref) => {
  return /* @__PURE__ */ react_default.createElement(AbsoluteCanvas, __spreadValues({ canvasRef: ref }, props));
});

// src/components/AbsoluteItem.jsx
var AbsoluteDiv = styled_components_default.div.attrs(({ x, y, w, h }) => ({
  style: {
    width: w,
    height: h,
    top: `${y}px`,
    left: `${x}px`
  }
}))`
    display: block;
    position: absolute;
    background: transparent;
`;
var AbsoluteItem = ({
  itemId,
  type = "block",
  x,
  y,
  w,
  h,
  renderLayoutItem
}) => /* @__PURE__ */ react_default.createElement(
  AbsoluteDiv,
  {
    x,
    y,
    w,
    h,
    "data-test": "absolute-item",
    "data-x": x,
    "data-y": y,
    "data-w": w,
    "data-h": h
  },
  renderLayoutItem(
    itemId,
    {
      width: w,
      height: h
    },
    type
  )
);
AbsoluteItem.propTypes = {
  itemId: prop_types_default.string.isRequired,
  type: prop_types_default.string,
  x: prop_types_default.number.isRequired,
  y: prop_types_default.number.isRequired,
  w: prop_types_default.number.isRequired,
  h: prop_types_default.number.isRequired,
  renderLayoutItem: prop_types_default.func.isRequired
};

// src/components/ActionMenuPortal.ts
var ActionMenuPortal = styled_components_default.div.attrs((props) => ({
  "data-test": "action-menu-portal",
  style: {
    width: props.w,
    top: props.y + props.h,
    left: props.x
  }
}))`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: all;
    box-sizing: border-box;
    height: 0px;
    z-index: ${(props) => props.zIndex};
`;
var ActionMenuPortal_default = ActionMenuPortal;

// src/components/Edge.tsx
var EdgeWrapper = styled_components_default.div.attrs(
  ({ x, y, w, h }) => {
    return {
      style: {
        width: w,
        height: h,
        transform: `translate(${x}px, ${y}px)`
      }
    };
  }
)`
    display: block;
    position: absolute;
    background: transparent;
    box-sizing: border-box;

    &:hover {
        cursor: ${(props) => props.orientation === "vertical" ? "col-resize" : "row-resize"};
        background: ${(0, themes_exports.pickVariant)("appearance", {
  invalid: dashboard_ui_exports.customThemeVariables.invalidDropTargetBackgroundColor,
  dropTarget: dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor,
  normal: "transparent",
  hidden: "transparent"
})};
        border: ${(0, themes_exports.pickVariant)("appearance", {
  invalid: `1px solid ${dashboard_ui_exports.customThemeVariables.invalidDropTargetBorderColor}`,
  dropTarget: `1px solid ${dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor}`,
  normal: "none",
  hidden: "none"
})};
        transition: background 0.2s ease-out;
    }
`;
var EdgeComponent = styled_components_default.div.attrs(
  ({ x, y, w, h }) => {
    return {
      style: {
        width: w,
        height: h,
        transform: `translate(${x}px, ${y}px)`
      }
    };
  }
)`
    display: block;
    position: absolute;
    opacity: 0.35;
    pointer-events: none;
    background-color: ${(props) => props.appearance === "dropTarget" ? dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor : (0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    ${EdgeWrapper}:hover + & {
        opacity: 0.7;
    }
`;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport13 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// src/components/ErrorMessageOverlay.tsx
var ErrorOverlay = styled_components_default.div`
    position: absolute;
    box-sizing: border-box;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    pointer-events: none;
    background-color: ${(0, themes_exports.pick)({
  light: "#a81916cc",
  dark: "#a81916b3"
})};
    color: white;
    overflow: hidden;
    padding: 8px;
    z-index: 2;
`;
var MessageContainer = styled_components_default.div`
    padding-top: 8px;
`;
var OverlayTitle = styled_components_default.div`
    font-weight: bold;
`;
var ErrorMessageOverlay = ({ messages }) => {
  if (!Array.isArray(messages) || messages.length === 0) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(ErrorOverlay, { "data-test": "error-overlay" }, /* @__PURE__ */ react_default.createElement(OverlayTitle, null, (0, i18n_exports._)("Layout Errors:")), messages.map((message) => /* @__PURE__ */ react_default.createElement(
    MessageContainer,
    {
      "data-test": "error-overlay-message",
      key: message
    },
    message
  )));
};

// src/components/GridCanvas.tsx
var defaultState2 = {
  startPosition: null,
  isMoving: false
};
var DEFAULT_SELECTED_LAYOUT_ITEMS2 = [];
var noop4 = () => void 0;
var GridCanvas = (props) => {
  const _a = props, {
    movable = false,
    selectable = false,
    selectedLayoutItems = DEFAULT_SELECTED_LAYOUT_ITEMS2,
    panelPadding = 0,
    scale = 1,
    onItemMove = noop4,
    onItemMoved = noop4,
    onItemSelected,
    children,
    canvasRef,
    blockItems
  } = _a, canvasProps = __objRest(_a, [
    "movable",
    "selectable",
    "selectedLayoutItems",
    "panelPadding",
    "scale",
    "onItemMove",
    "onItemMoved",
    "onItemSelected",
    "children",
    "canvasRef",
    "blockItems"
  ]);
  const { enableGridLayoutCssScaling } = (0, dashboard_context_exports.useFeatureFlags)();
  const [startPosition, setStartPosition] = (0, react_exports.useState)(
    defaultState2.startPosition
  );
  const [isMoving, setIsMoving] = (0, react_exports.useState)(defaultState2.isMoving);
  const { isMouseDownOnItemWithHandle, setIsMouseDownOnItemWithHandle } = (0, dashboard_context_exports.useMouseEventsContext)();
  const resetState = (0, react_exports.useCallback)(() => {
    setIsMoving(defaultState2.isMoving);
    setStartPosition(defaultState2.startPosition);
  }, []);
  const mouseScale = enableGridLayoutCssScaling ? scale : 1;
  const handleItemSelected = (0, react_exports.useCallback)(
    (e, itemIds = []) => {
      if (itemIds.some(
        ({ id, type }) => {
          var _a2;
          return type === "input" && ((_a2 = findStatusIcon({ canvasRef, id })) == null ? void 0 : _a2.contains(
            e.target
          ));
        }
      )) {
        return;
      }
      if (e.metaKey) {
        const selectedItems = selectedLayoutItems.filter(
          ({ type }) => type === "block"
        );
        onItemSelected(e, (0, lodash_exports.uniqBy)([...selectedItems, ...itemIds], "id"));
      } else {
        onItemSelected(e, itemIds);
      }
    },
    [canvasRef, selectedLayoutItems, onItemSelected]
  );
  const handleMouseDownOnItem = (0, react_exports.useCallback)(
    (event, blockItem) => {
      const { id, type = "block" } = blockItem;
      if (!selectedLayoutItems.find(
        ({ id: selectedId }) => selectedId === id
      )) {
        handleItemSelected(event, [{ id, type }]);
      }
    },
    [handleItemSelected, selectedLayoutItems]
  );
  const handleMouseDown = (0, react_exports.useCallback)(
    (e) => {
      if (isMouseDownOnItemWithHandle == null ? void 0 : isMouseDownOnItemWithHandle.current) {
        setIsMouseDownOnItemWithHandle(false);
        return;
      }
      const pos = computeRelativePosition(e, canvasRef, mouseScale);
      const block = findTopBlockItemByPosition(
        blockItems,
        pos,
        panelPadding
      );
      if (selectable) {
        setStartPosition(pos);
      }
      if (block) {
        handleMouseDownOnItem(e, {
          id: block.item,
          type: block.type
        });
        if (movable) {
          setIsMoving(true);
        }
      }
    },
    [
      isMouseDownOnItemWithHandle,
      canvasRef,
      mouseScale,
      blockItems,
      panelPadding,
      selectable,
      setIsMouseDownOnItemWithHandle,
      handleMouseDownOnItem,
      movable
    ]
  );
  const handleMouseMove = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (startPosition) {
      const currentPosition = computeRelativePosition(
        e,
        canvasRef,
        mouseScale
      );
      if (currentPosition) {
        const offset = getOffset(currentPosition, startPosition);
        if (isMoving && considerMoved(offset)) {
          e.preventDefault();
          onItemMove(e, { currentPosition });
        }
      }
    }
  });
  const handleMouseUp = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (startPosition) {
      const currentPosition = computeRelativePosition(
        e,
        canvasRef,
        mouseScale
      );
      if (currentPosition) {
        const offset = getOffset(currentPosition, startPosition);
        if (isMoving && considerMoved(offset)) {
          onItemMoved(e, offset);
        } else {
          let blocks = blockItems;
          if (panelPadding) {
            blocks = blocks.map(
              (block) => applyVizPadding({
                item: block,
                padding: panelPadding
              })
            );
          }
          const boundary = positionsToBoundary(
            startPosition,
            currentPosition
          );
          const selectedBlocks = filterBlockItemsByBoundary(
            blocks,
            boundary
          ).map(({ item, type = "block" }) => ({
            id: item,
            type
          }));
          const topItem = selectedBlocks[selectedBlocks.length - 1];
          handleItemSelected(e, topItem ? [topItem] : []);
        }
        resetState();
      }
    }
  });
  useMouseDownWithHandleEventListeners({
    handleMouseDownOnItem,
    canvasRef,
    scale: mouseScale,
    setStartPosition,
    movable,
    setIsMoving
  });
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mouseup", handleMouseUp);
    return () => {
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [handleMouseUp]);
  (0, dashboard_ui_exports.useMouseMoveHandler)({ onMouseMove: handleMouseMove, isEnabled: movable });
  return /* @__PURE__ */ react_default.createElement(
    Canvas_default,
    __spreadProps(__spreadValues({
      ref: canvasRef
    }, canvasProps), {
      scale,
      onMouseDown: handleMouseDown,
      onContextMenu: resetState,
      cssScaling: enableGridLayoutCssScaling,
      showGrid: false
    }),
    children
  );
};
var GridCanvas_default = (0, react_exports.forwardRef)(
  (props, ref) => /* @__PURE__ */ react_default.createElement(GridCanvas, __spreadValues({ canvasRef: ref }, props))
);

// src/components/GridItem.tsx
var GridDiv = styled_components_default.div`
    height: 100%;
    width: 100%;
    grid-row: ${(props) => props.id}-start / ${(props) => props.id}-end;
    grid-column: ${(props) => props.id}-start / ${(props) => props.id}-end;
    background: transparent;
`;
var GridItem = ({
  itemId,
  type = "block",
  renderLayoutItem
}) => /* @__PURE__ */ react_default.createElement(GridDiv, { id: itemId, "data-test": "grid-item" }, renderLayoutItem(itemId, { width: "100%", height: "100%" }, type));
GridItem.propTypes = {
  itemId: prop_types_default.string.isRequired,
  type: prop_types_default.string,
  renderLayoutItem: prop_types_default.func.isRequired
};
var GridItem_default = GridItem;

// src/components/ItemDragPlaceholder.tsx
var Placeholder = styled_components_default.div.attrs(
  ({ position }) => ({
    style: positionToStyle(position)
  })
)`
    background-color: ${(0, themes_exports.pick)({
  enterprise: {
    light: themes_exports.variables.backgroundColorHover,
    dark: themes_exports.variables.neutral300
  },
  prisma: themes_exports.variables.interactiveColorOverlayDrag
})};
    opacity: 0.75;
    user-select: none;
    position: absolute;
    flex-direction: column;
    top: 0;
    left: 0;
    cursor: move;
`;

// src/GridLayoutConstants.ts
var CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL = (0, i18n_exports._)(
  "This panel is too small to be split into duplicates. Stretch or move the panel to make it bigger first."
);
var ITEM_DROP_TARGET_PX = 12;

// src/components/ItemDropTarget.jsx
var DropTarget = styled_components_default.div.attrs(({ position }) => ({
  style: positionToStyle(position)
}))`
    background-color: ${(0, themes_exports.pickVariant)("validDropTarget", {
  true: dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor,
  false: dashboard_ui_exports.customThemeVariables.invalidDropTargetBackgroundColor
})};
    border-width: '1px';
    border-style: 'solid';
    border-color: ${(0, themes_exports.pickVariant)("validDropTarget", {
  true: dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor,
  false: dashboard_ui_exports.customThemeVariables.invalidDropTargetBorderColor
})};
    user-select: none;
    position: absolute;
    pointer-events: none;
`;
var ItemDropTarget = ({ position, direction }) => {
  const validDropTarget = (direction === "e" || direction === "w") && position.w >= 128 || (direction === "n" || direction === "s") && position.h >= 128;
  const dropTargetPosition = (0, react_exports.useMemo)(() => {
    let updatedPosition = null;
    switch (direction) {
      case "n":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          h: ITEM_DROP_TARGET_PX
        });
        break;
      case "s":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          y: position.y + position.h - ITEM_DROP_TARGET_PX,
          h: ITEM_DROP_TARGET_PX
        });
        break;
      case "w":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          w: ITEM_DROP_TARGET_PX
        });
        break;
      case "e":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          x: position.x + position.w - ITEM_DROP_TARGET_PX,
          w: ITEM_DROP_TARGET_PX
        });
        break;
      default:
        updatedPosition = position;
        break;
    }
    return updatedPosition;
  }, [position, direction]);
  if (validDropTarget) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(
    DropTarget,
    {
      "data-test": "item-drop-target",
      position: dropTargetPosition,
      validDropTarget
    }
  );
};
ItemDropTarget.propTypes = {
  position: prop_types_default.shape({
    x: prop_types_default.number.isRequired,
    y: prop_types_default.number.isRequired,
    w: prop_types_default.number.isRequired,
    h: prop_types_default.number.isRequired
  }).isRequired,
  direction: prop_types_default.oneOf(["n", "s", "w", "e"]).isRequired
};

// src/components/Layer.tsx
var Layer = styled_components_default.div`
    position: absolute;
    top: 0px;
    left: 0px;
    right: 0px;
    bottom: 0px;
    pointer-events: none;
    z-index: ${(props) => props.zIndex};
`;

// esm-externals:@splunk/react-icons/enterprise/Plus
var Plus_exports = {};
__export(Plus_exports, {
  default: () => Plus_default
});
var defaultImport14 = __toESM(require("@splunk/react-icons/enterprise/Plus"));
__reExport(Plus_exports, require("@splunk/react-icons/enterprise/Plus"));
var Plus_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// src/utils/outlineUtils.ts
var getVerticalPosition = (dir, offset) => {
  if (dir[0] === "n") {
    return `top: -${offset}px`;
  }
  if (dir[0] === "s") {
    return `bottom: -${offset}px`;
  }
  return `top: calc(50% - ${offset}px)`;
};
var getHorizontalPosition = (dir, offset) => {
  if (dir.slice(-1) === "w") {
    return `left: -${offset}px`;
  }
  if (dir.slice(-1) === "e") {
    return `right: -${offset}px`;
  }
  return `left: calc(50% - ${offset}px)`;
};

// src/components/Port.tsx
var portOffset = 8;
var PortContainer = styled_components_default.div.attrs(({ port }) => ({
  "data-test": "port",
  "data-test-port": port
}))`
    text-align: center;
    width: 16px;
    height: 16px;
    line-height: 16px;
    box-sizing: border-box;
    border-radius: 50%;
    position: absolute;
    color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    ${({ port }) => getVerticalPosition(port, portOffset)};
    ${({ port }) => getHorizontalPosition(port, portOffset)};
    z-index: 999;
    pointer-events: auto;
    user-select: none;
    &:hover {
        background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    }
`;

// src/components/PreviewPlaceholderItem.jsx
var PlaceholderComponent = styled_components_default.div.attrs(({ position }) => ({
  style: {
    width: position.w,
    height: position.h,
    transform: `translate(${position.x}px, ${position.y}px)`
  }
}))`
    display: block;
    position: absolute;
    pointer-events: none;
    box-sizing: border-box;
    border: 1px solid ${dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor};
    background-color: ${dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor};
`;
var PreviewPlaceholderItem = ({ position }) => {
  return /* @__PURE__ */ react_default.createElement(
    PlaceholderComponent,
    {
      position,
      "data-test": "preview-placeholder",
      "data-test-preview-position": `${position.x},${position.y}-${position.w},${position.h}`
    }
  );
};
PreviewPlaceholderItem.propTypes = {
  position: prop_types_default.shape({
    x: prop_types_default.number.isRequired,
    y: prop_types_default.number.isRequired,
    w: prop_types_default.number.isRequired,
    h: prop_types_default.number.isRequired
  }).isRequired
};

// esm-externals:@splunk/ui-utils/format
var format_exports = {};
__export(format_exports, {
  default: () => format_default
});
var defaultImport15 = __toESM(require("@splunk/ui-utils/format"));
__reExport(format_exports, require("@splunk/ui-utils/format"));
var format_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// src/components/ResizeHandle.tsx
var resizeHandleOffset = 7;
var computeCursor = (dir) => {
  switch (dir) {
    case "n":
    case "s":
      return "ns-resize";
    case "e":
    case "w":
      return "ew-resize";
    case "ne":
    case "sw":
      return "nesw-resize";
    case "se":
    case "nw":
    default:
      return "nwse-resize";
  }
};
var Handle = styled_components_default.button.attrs(({ direction }) => ({
  "data-test": "handle",
  "data-test-direction": direction
}))`
    width: 10px;
    height: 10px;
    background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    border: none;
    border-radius: 20%;
    padding: 0;
    position: absolute;
    ${({ direction }) => getVerticalPosition(direction, resizeHandleOffset)};
    ${({ direction }) => getHorizontalPosition(direction, resizeHandleOffset)};
    cursor: ${({ direction }) => computeCursor(direction)};
    z-index: 999;
    pointer-events: auto;
    user-select: none;
`;

// src/components/ResponsiveBox.tsx
var ResponsiveBox = styled_components_default.div.attrs(
  ({ itemId, x, y, w, h, "data-test": dataTest, zIndex }) => {
    const attributes = {
      "data-test": dataTest != null ? dataTest : "responsive-box",
      "data-id": itemId,
      "data-test-viz-item-position": `${x},${y},${w},${h}`,
      style: {
        width: `${w}px`,
        height: `${h}px`,
        top: `${y}px`,
        left: `${x}px`,
        zIndex
      }
    };
    if (!zIndex) {
      delete attributes.style.zIndex;
    }
    return attributes;
  }
)`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: none;
    box-sizing: border-box;
    visibility: ${(props) => {
  return props.appearance === "hidden" ? "hidden" : "visible";
}};
    opacity: ${(props) => props.appearance === "highlighted" ? 1 : 0.5};
`;
ResponsiveBox.defaultProps = {
  appearance: "highlighted"
};
var ResponsiveBox_default = ResponsiveBox;

// src/components/DragHandlePortal.tsx
var DragHandlePortal = styled_components_default.div.attrs(
  (props) => ({
    "data-test": "drag-handle-portal",
    style: {
      width: props.w,
      top: props.y,
      left: props.x
    }
  })
)`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: all;
    box-sizing: border-box;
    height: 0px;
    z-index: ${(props) => props.zIndex};
    visibility: ${({ isHidden }) => isHidden ? "hidden" : "visible"};
`;

// src/components/ResponsiveBlockItem.tsx
var defaultPortalState = Object.freeze({
  current: null
});
var ResponsiveBlockItem = ({
  x: originalX,
  y: originalY,
  w: originalW,
  h: originalH,
  canvasHeight,
  padding,
  itemId,
  type = "block",
  errorMessages,
  onItemSelected,
  renderLayoutItem,
  appearance = "highlighted",
  isMouseDownEventRef
}) => {
  var _a;
  const selectIsSelected = (0, react_exports.useMemo)(dashboard_state_exports.makeSelectIsSelected, []);
  const mode = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectMode);
  const isSelected = (0, dashboard_state_exports.useSelector)((state) => selectIsSelected(state, itemId));
  const [isClicked, setIsClicked] = (0, react_exports.useState)(false);
  const [actionMenuPortal, setActionMenuPortal] = (0, react_exports.useState)(defaultPortalState);
  const [dragHandlePortal, setDragHandlePortal] = (0, react_exports.useState)(defaultPortalState);
  const layerData = (0, dashboard_context_exports.useLayoutLayers)();
  const {
    layer: itemLayer,
    actionMenu: actionMenuLayer,
    dragHandle: dragHandleLayer
  } = (_a = layerData == null ? void 0 : layerData[itemId]) != null ? _a : {};
  const renderActionMenuInPortal = typeof itemLayer === "number";
  const {
    position: { x, y, w, h }
  } = applyVizPadding({
    item: {
      position: {
        x: originalX,
        y: originalY,
        w: originalW,
        h: originalH
      }
    },
    padding
  });
  const layoutItem = (0, react_exports.useMemo)(
    () => renderLayoutItem(
      itemId,
      {
        width: w,
        height: h,
        y,
        canvasHeight,
        renderActionMenuInPortal,
        actionMenuPortal,
        dragHandlePortal
      },
      type,
      onItemSelected
    ),
    [
      renderLayoutItem,
      itemId,
      type,
      w,
      h,
      y,
      canvasHeight,
      onItemSelected,
      renderActionMenuInPortal,
      actionMenuPortal,
      dragHandlePortal
    ]
  );
  const handleFocus = (0, react_exports.useCallback)(
    (event) => {
      if (isMouseDownEventRef == null ? void 0 : isMouseDownEventRef.current) {
        setIsClicked(true);
        return;
      }
      if (!event.relatedTarget) {
        return;
      }
      setIsClicked(false);
      if (
        // The tabindex was moved to the SelectableContainer (in renderLayoutItem), so we'll check that thats the target
        event.target.getAttribute("data-test") === "select-outline" && event.target.getAttribute("data-id") === itemId
      ) {
        onItemSelected(event, [{ id: itemId, type }]);
      }
    },
    [isMouseDownEventRef, itemId, onItemSelected, type]
  );
  const trackActionMenuPortal = (0, react_exports.useCallback)((element) => {
    setActionMenuPortal({ current: element });
  }, []);
  const trackDragHandlePortal = (0, react_exports.useCallback)((element) => {
    setDragHandlePortal({ current: element });
  }, []);
  const isHidden = appearance === "hidden";
  return /* @__PURE__ */ react_default.createElement(
    dashboard_ui_exports.AbsoluteItemContainer,
    {
      "data-id": itemId,
      "data-selected": `${isSelected}`,
      "data-click-focus": `${isClicked && isSelected && mode === "view"}`
    },
    /* @__PURE__ */ react_default.createElement(
      ResponsiveBox_default,
      {
        "data-test": "absolute-item",
        itemId,
        appearance,
        x,
        y,
        w,
        h,
        onFocusCapture: handleFocus
      },
      layoutItem,
      /* @__PURE__ */ react_default.createElement(ErrorMessageOverlay, { messages: errorMessages })
    ),
    renderActionMenuInPortal && /* @__PURE__ */ react_default.createElement(
      ActionMenuPortal_default,
      {
        x,
        y,
        w,
        h,
        ref: trackActionMenuPortal,
        zIndex: actionMenuLayer
      }
    ),
    /* @__PURE__ */ react_default.createElement(
      DragHandlePortal,
      {
        x,
        y,
        w,
        ref: trackDragHandlePortal,
        zIndex: dragHandleLayer,
        isHidden
      }
    )
  );
};
var ResponsiveBlockItem_default = react_default.memo(ResponsiveBlockItem);

// src/components/ResponsiveLine.tsx
var LineBox = styled_components_default.div`
    position: absolute;
    pointer-events: none;
    z-index: ${(props) => props.zIndex};
`;
var AdjustHandle = styled_components_default.button.attrs(({ x, y }) => ({
  style: {
    transform: `translate(${x}px, ${y}px)`
  }
}))`
    width: 10px;
    height: 10px;
    left: -5px;
    top: -5px;
    background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    border: none;
    padding: 0;
    border-radius: 50%;
    position: absolute;
    z-index: 999;
    pointer-events: auto;
    cursor: move;
    user-select: none;
`;

// src/DefaultOptions.ts
var gridLayoutOptions = {
  width: dashboard_utils_exports.DEFAULT_CANVAS_WIDTH,
  gutterSize: 8
};

// src/utils/gridLayoutViewerUtils.ts
var getTemplateItems = ([currGridLine, nextGridLine, ...rest], axisLength, templateItems = []) => {
  templateItems.push(`[${currGridLine.names.join(" ")}]`);
  if (!nextGridLine) {
    return templateItems.join(" ");
  }
  const gridTrackWidth = Math.round(
    (nextGridLine.pos - currGridLine.pos) / axisLength * 100
  );
  templateItems.push(`minmax(0, ${gridTrackWidth}fr)`);
  return getTemplateItems([nextGridLine, ...rest], axisLength, templateItems);
};
var getTemplateItemsFromGridLines = (gridLines, axisLength) => {
  if (gridLines.length === 0) {
    return "";
  }
  return getTemplateItems(gridLines, axisLength);
};
var getCSSGridTemplate = ({
  layoutStructure,
  width,
  height
}) => {
  const xCoords = [];
  const yCoords = [];
  layoutStructure.forEach(({ position: { x, y, w, h }, item }) => {
    var _a, _b, _c, _d;
    xCoords[x] = (_a = xCoords[x]) != null ? _a : [];
    xCoords[x + w] = (_b = xCoords[x + w]) != null ? _b : [];
    yCoords[y] = (_c = yCoords[y]) != null ? _c : [];
    yCoords[y + h] = (_d = yCoords[y + h]) != null ? _d : [];
    xCoords[x].push(`${item}-start`);
    xCoords[x + w].push(`${item}-end`);
    yCoords[y].push(`${item}-start`);
    yCoords[y + h].push(`${item}-end`);
  });
  const xGridLines = Object.entries(xCoords).map(([pos, names]) => ({
    pos: Number(pos),
    names
  }));
  const yGridLines = Object.entries(yCoords).map(([pos, names]) => ({
    pos: Number(pos),
    names
  }));
  const gridRowTemplate = getTemplateItemsFromGridLines(yGridLines, height);
  const gridColTemplate = getTemplateItemsFromGridLines(xGridLines, width);
  return { gridRowTemplate, gridColTemplate };
};

// src/GridLayoutViewer.tsx
var GridCanvas2 = styled_components_default.div`
    ${themes_exports.mixins.reset("grid")};
    height: ${(props) => props.height}px;
    width: 100%;
    padding: ${(props) => props.gutterSize / 2}px;
    box-sizing: border-box;
    grid-template-columns: ${(props) => props.colTemplate};
    grid-template-rows: ${(props) => props.rowTemplate};
    gap: ${(props) => props.gutterSize}px;
    background: ${dashboard_ui_exports.customThemeVariables.dashboardBackgroundColor};
`;
GridCanvas2.displayName = "GridCanvas";
var GridLayoutViewer = ({
  layoutStructure,
  renderLayoutItem,
  options
}) => {
  const { width, gutterSize } = __spreadValues(__spreadValues({}, gridLayoutOptions), options);
  const { height, gridItems, rowTemplate, colTemplate } = (0, react_exports.useMemo)(() => {
    const filteredStructure = removeInvalidItems(
      layoutStructure
    );
    const structureHeight = computeMaxHeight(filteredStructure);
    const { gridRowTemplate, gridColTemplate } = getCSSGridTemplate({
      layoutStructure: filteredStructure,
      width,
      height: structureHeight
    });
    const items = filteredStructure.map(({ item: itemId, type }) => /* @__PURE__ */ react_default.createElement(
      GridItem_default,
      {
        itemId,
        type,
        key: itemId,
        renderLayoutItem
      }
    ));
    return {
      height: structureHeight,
      gridItems: items,
      rowTemplate: gridRowTemplate,
      colTemplate: gridColTemplate
    };
  }, [layoutStructure, width, renderLayoutItem]);
  return /* @__PURE__ */ react_default.createElement(
    GridCanvas2,
    {
      "data-test": "grid-layout-canvas",
      "data-layout-type": "grid",
      height,
      gutterSize,
      rowTemplate,
      colTemplate
    },
    gridItems
  );
};
GridLayoutViewer.propTypes = __spreadValues({}, BaseLayout_default.propTypes);
GridLayoutViewer.defaultProps = __spreadValues({}, BaseLayout_default.defaultProps);
var GridLayoutViewer_default = GridLayoutViewer;
//# sourceMappingURL=GridLayoutViewer.js.map
