import type { SelectedItem, GridLayoutStructure, GridLayoutOptions, Mode } from '@splunk/dashboard-types';
import { GridLayoutApi } from './apis';
export interface GridLayoutProps {
    layoutApiRef: (api: GridLayoutApi | null) => void;
    onLayoutItemsSelect: (selectedItems: SelectedItem[]) => void;
    selectedItems?: SelectedItem[];
    layoutStructure: GridLayoutStructure;
    onLayoutStructureChange: (layoutStructure: GridLayoutStructure) => void;
    options?: GridLayoutOptions;
    renderLayoutItem: (...args: unknown[]) => JSX.Element;
    mode: Mode;
    containerHeight: number;
    containerWidth: number;
    showGrid: boolean;
}
declare const _default: import("./enhancers").EnhancedLayout<GridLayoutProps>;
export default _default;
//# sourceMappingURL=GridLayout.d.ts.map