declare const _default: {
    backgroundColor: {
        anyOf: ({
            pattern: string;
            type: string;
            description: string;
            enum?: undefined;
        } | {
            type: string;
            enum: string[];
            description: string;
            pattern?: undefined;
        })[];
    };
    display: {
        type: string;
        default: string;
        enum: string[];
        description: string;
    };
    backgroundImage: {
        type: string;
        properties: {
            w: {
                type: string;
                description: string;
            };
            h: {
                type: string;
                description: string;
            };
            x: {
                type: string;
                description: string;
            };
            y: {
                type: string;
                description: string;
            };
            src: {
                type: string;
                description: string;
            };
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
                description: string;
            };
            sizeType: {
                type: string;
                enum: string[];
                default: string;
                description: string;
            };
        };
        description: string;
        additionalProperties: boolean;
    };
    width: {
        type: string;
        default: number;
        description: string;
    };
    height: {
        type: string;
        default: number;
        description: string;
    };
};
export default _default;
//# sourceMappingURL=absoluteLayoutOptionsSchema.d.ts.map