import React from 'react';
export declare const PORT_DIRECTIONS: readonly ["n", "e", "s", "w"];
export type PortDirection = (typeof PORT_DIRECTIONS)[number];
export interface PortProps {
    port: PortDirection;
    onMouseEnter: React.MouseEventHandler<HTMLDivElement>;
    onMouseLeave: React.MouseEventHandler<HTMLDivElement>;
}
export declare const Port: ({ port, onMouseEnter, onMouseLeave, }: PortProps) => JSX.Element;
//# sourceMappingURL=Port.d.ts.map