import type { ReactNode } from 'react';
export type BorderType = 'hover' | 'select' | 'move' | 'none';
export interface ResponsiveBoxProps {
    itemId: string;
    appearance?: 'hidden' | 'visible' | 'highlighted';
    x: number;
    y: number;
    w: number;
    h: number;
    'data-test'?: string;
    children: ReactNode;
    zIndex?: number;
}
declare const ResponsiveBox: import("styled-components").StyledComponent<"div", any, ResponsiveBoxProps, never>;
export default ResponsiveBox;
//# sourceMappingURL=ResponsiveBox.d.ts.map