import { BehaviorSubject } from 'rxjs';
export declare const useZoom: ({ canvasRef, width, height, containerWidth, containerHeight, }: {
    canvasRef: React.RefObject<HTMLDivElement | null>;
    width: number;
    height: number;
    containerWidth: number;
    containerHeight: number;
}) => {
    scale: number;
    fitToWidth: number | false;
    getZoomObserver: () => BehaviorSubject<number>;
    setScale: (s: number) => void;
    zoomIn: () => void;
    zoomOut: () => void;
    setFitToWidthAndScrollToTopLeft: (maxScale?: any) => void;
};
//# sourceMappingURL=useZoom.d.ts.map