import type { ConnectedLineProps } from './types';
export declare const presets: ({
    label: any;
    name: string;
    value: {
        context: {
            strokeColorEditorConfig: undefined;
        };
        options: {
            strokeColor: undefined;
        };
    };
} | {
    label: any;
    name: string;
    value: {
        context: {
            strokeColorEditorConfig: ({
                to: number;
                value: string;
                from?: undefined;
            } | {
                from: number;
                to: number;
                value: string;
            } | {
                from: number;
                value: string;
                to?: undefined;
            })[];
        };
        options: {
            strokeColor: string;
        };
    };
})[];
export interface Editor {
    label: string;
    option?: string;
    editor: string;
    context?: string;
    key?: string;
    editorProps?: Record<string, unknown>;
    showEditor?: (args: ConnectedLineProps) => boolean;
}
export interface EditorSection {
    label: string;
    layout: Editor[][];
}
declare const editorConfig: EditorSection[];
export default editorConfig;
//# sourceMappingURL=ConnectedLineEditorConfig.d.ts.map