/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject2) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject2(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject2(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/AbsoluteLayout.tsx
var AbsoluteLayout_exports = {};
__export(AbsoluteLayout_exports, {
  default: () => AbsoluteLayout_default
});
module.exports = __toCommonJS(AbsoluteLayout_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport2 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/dashboard-context
var dashboard_context_exports = {};
__export(dashboard_context_exports, {
  default: () => dashboard_context_default
});
var defaultImport3 = __toESM(require("@splunk/dashboard-context"));
__reExport(dashboard_context_exports, require("@splunk/dashboard-context"));
var dashboard_context_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/dashboard-definition
var dashboard_definition_exports = {};
__export(dashboard_definition_exports, {
  default: () => dashboard_definition_default
});
var defaultImport4 = __toESM(require("@splunk/dashboard-definition"));
__reExport(dashboard_definition_exports, require("@splunk/dashboard-definition"));
var dashboard_definition_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/dashboard-telemetry
var dashboard_telemetry_exports = {};
__export(dashboard_telemetry_exports, {
  default: () => dashboard_telemetry_default
});
var defaultImport5 = __toESM(require("@splunk/dashboard-telemetry"));
__reExport(dashboard_telemetry_exports, require("@splunk/dashboard-telemetry"));
var dashboard_telemetry_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/dashboard-ui
var dashboard_ui_exports = {};
__export(dashboard_ui_exports, {
  default: () => dashboard_ui_default
});
var defaultImport6 = __toESM(require("@splunk/dashboard-ui"));
__reExport(dashboard_ui_exports, require("@splunk/dashboard-ui"));
var dashboard_ui_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/dashboard-utils
var dashboard_utils_exports = {};
__export(dashboard_utils_exports, {
  default: () => dashboard_utils_default
});
var defaultImport7 = __toESM(require("@splunk/dashboard-utils"));
__reExport(dashboard_utils_exports, require("@splunk/dashboard-utils"));
var dashboard_utils_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// src/BaseLayoutApi.ts
var BaseLayoutApi = class {
  constructor() {
    this.emitTelemetry = (payload) => {
      if (!this.telemetry) {
        return false;
      }
      this.telemetry.emit(__spreadValues({
        source: "layoutApi"
      }, payload));
      return true;
    };
  }
  /**
   * add new layout item synchronously
   */
  addLayoutItemSync(...args) {
    return this.addLayoutItem(...args);
  }
  /**
   * add one or more new layout items
   */
  addLayoutItems(items, metadata) {
    return this.addLayoutItemSync(
      items,
      metadata
    );
  }
  /**
   * copies item w/h and position with an offset synchronously
   */
  cloneLayoutItemsSync({ from, to }) {
    return this.cloneLayoutItems({ from, to });
  }
  /**
   * remove an item from layout synchronously
   */
  removeLayoutItemsSync(itemIds) {
    return this.removeLayoutItems(itemIds);
  }
};
var BaseLayoutApi_default = BaseLayoutApi;

// src/utils/edgeUtils.ts
var applyVizPadding = ({
  item,
  padding = 0
}) => {
  const { x, y, w, h } = item.position;
  return __spreadProps(__spreadValues({}, item), {
    position: {
      x: x + padding,
      y: y + padding,
      w: w - 2 * padding,
      h: h - 2 * padding
    }
  });
};

// src/utils/layoutUtils.ts
var positionToStyle = (pos) => ({
  width: `${pos.w}px`,
  height: `${pos.h}px`,
  transform: `translate(${pos.x}px, ${pos.y}px)`
});
var getClientPosition = (e, scaleFactor = 1) => ({
  x: Math.round(e.clientX / scaleFactor),
  y: Math.round(e.clientY / scaleFactor)
});
var getOffset = (currentPosition, startPosition) => ({
  offsetX: currentPosition.x - startPosition.x,
  offsetY: currentPosition.y - startPosition.y
});
var considerMoved = ({
  offsetX,
  offsetY
}) => offsetX !== 0 || offsetY !== 0;
var positionsToBoundary = (startPos, endPos) => ({
  x: Math.min(startPos.x, endPos.x),
  y: Math.min(startPos.y, endPos.y),
  w: Math.abs(startPos.x - endPos.x),
  h: Math.abs(startPos.y - endPos.y)
});
var filterBlockItemsByBoundary = (items, boundary) => items.filter((item) => {
  const itemPosition = item.position;
  return !(boundary.x > itemPosition.x + itemPosition.w || boundary.x + boundary.w < itemPosition.x || boundary.y > itemPosition.y + itemPosition.h || boundary.y + boundary.h < itemPosition.y);
});
var findTopBlockItemByPosition = (items, pos, padding = 0) => (0, lodash_exports.findLast)(items, (item) => {
  const itemPosition = padding ? applyVizPadding({ item, padding }).position : item.position;
  return itemPosition.x <= pos.x && itemPosition.x + itemPosition.w >= pos.x && itemPosition.y <= pos.y && itemPosition.y + itemPosition.h >= pos.y;
});
var snapOffset = (current, offset, snapTo) => {
  const remainder = (current + offset) % snapTo;
  const newOffset = remainder > snapTo / 2 ? offset + (snapTo - remainder) : offset - remainder;
  return newOffset;
};
var snapOffsetToXY = ({
  position,
  offset,
  gridWidth,
  gridHeight,
  spacing = 0,
  padding = 0
}) => {
  let { offsetX, offsetY } = offset;
  offsetX = snapOffset(position.x, offsetX, gridWidth + spacing) + padding;
  offsetY = snapOffset(position.y, offsetY, gridHeight + spacing) + padding;
  return {
    offsetX,
    offsetY
  };
};
var snapOffsetToWH = ({
  position,
  offset,
  gridWidth,
  gridHeight,
  spacing = 0,
  padding = 0
}) => {
  let { offsetX, offsetY } = offset;
  offsetX = snapOffset(position.x + position.w, offsetX, gridWidth + spacing) + (padding - spacing);
  offsetY = snapOffset(position.y + position.h, offsetY, gridHeight + spacing) + (padding - spacing);
  return {
    offsetX,
    offsetY
  };
};
var updateBlockItemSize = ({
  item,
  offset,
  dir,
  options: { minWidth = 0, minHeight = 0 } = {}
}) => {
  const { w, h } = item.position;
  const { offsetX, offsetY } = offset;
  const updatedPosition = __spreadValues({}, item.position);
  if (["n", "ne", "nw"].includes(dir)) {
    updatedPosition.y += Math.min(h - minHeight, offsetY);
    updatedPosition.h -= offsetY;
  }
  if (["s", "se", "sw"].includes(dir)) {
    updatedPosition.h += offsetY;
  }
  if (["e", "ne", "se"].includes(dir)) {
    updatedPosition.w += offsetX;
  }
  if (["w", "nw", "sw"].includes(dir)) {
    updatedPosition.x += Math.min(w - minWidth, offsetX);
    updatedPosition.w -= offsetX;
  }
  updatedPosition.w = Math.max(minWidth, updatedPosition.w);
  updatedPosition.h = Math.max(minHeight, updatedPosition.h);
  return __spreadProps(__spreadValues({}, item), {
    position: updatedPosition
  });
};
var updateBlockItemPosition = (item, offset) => {
  const { offsetX, offsetY } = offset;
  return __spreadProps(__spreadValues({}, item), {
    position: __spreadProps(__spreadValues({}, item.position), {
      x: item.position.x + offsetX,
      y: item.position.y + offsetY
    })
  });
};
var createOffset = (dir, x, y) => {
  switch (dir) {
    case "n":
      return {
        offsetX: 0,
        offsetY: -y
      };
    case "s":
      return {
        offsetX: 0,
        offsetY: y
      };
    case "w":
      return {
        offsetX: -x,
        offsetY: 0
      };
    case "e":
      return {
        offsetX: x,
        offsetY: 0
      };
    default:
      return {
        offsetX: 0,
        offsetY: 0
      };
  }
};
var computeScaleToFit = ({
  canvasWidth,
  canvasHeight,
  containerWidth,
  containerHeight,
  scrollbarWidth,
  max = Infinity,
  enableGridLayoutCssScaling = true
}) => {
  if (!((0, lodash_exports.isNumber)(containerWidth) && containerWidth > 0 && (0, lodash_exports.isNumber)(canvasWidth) && canvasWidth > 0)) {
    dashboard_utils_exports.console.warn(
      `Failed to calculate layout scale: canvasWidth=${canvasWidth}, containerWidth=${containerWidth}; falling back to scale=1`
    );
    return 1;
  }
  const scale = Math.min(containerWidth / canvasWidth, max);
  const scrollbarScale = Math.min(
    (containerWidth - scrollbarWidth) / canvasWidth,
    max
  );
  if (!enableGridLayoutCssScaling) {
    return scrollbarScale;
  }
  if (canvasHeight * scale > containerHeight) {
    return scrollbarScale;
  }
  return scale;
};
var moveLayoutItem = (items, from, to) => {
  const structure = [...items];
  const removed = (0, lodash_exports.pullAt)(structure, [from]);
  structure.splice(to, 0, removed[0]);
  return structure;
};
var isLineConnected = ({ line, dir }) => "item" in line.position[dir];
var disconnectLine = ({
  line,
  dir,
  absPos
}) => {
  const updatePosition = __spreadProps(__spreadValues({}, line.position), {
    [dir]: __spreadValues({}, absPos)
  });
  return __spreadProps(__spreadValues({}, line), {
    position: updatePosition
  });
};
var connectLine = ({
  line,
  dir,
  itemId,
  port
}) => {
  const { position } = line;
  const updatedPosition = __spreadProps(__spreadValues({}, position), {
    [dir]: {
      item: itemId,
      port
    }
  });
  return __spreadProps(__spreadValues({}, line), {
    position: updatedPosition
  });
};
var updateLineAbsPosition = ({
  line,
  dir,
  offset
}) => {
  const { offsetX, offsetY } = offset;
  const { position } = line;
  if (!("x" in position[dir])) {
    throw Error(
      `line item ${line.item} does not have x value for its direction ${dir}`
    );
  }
  if (!("y" in position[dir])) {
    throw Error(
      `line item ${line.item} does not have y value for its direction ${dir}`
    );
  }
  const { x, y } = position[dir];
  return __spreadProps(__spreadValues({}, line), {
    position: __spreadProps(__spreadValues({}, position), {
      [dir]: {
        x: x + offsetX,
        y: y + offsetY
      }
    })
  });
};
var computeLineBoxPosition = (from, to) => ({
  x: Math.min(from.x, to.x),
  y: Math.min(from.y, to.y)
});
var computeLineRelativePosition = (from, to, box) => ({
  from: {
    x: from.x - box.x,
    y: from.y - box.y
  },
  to: {
    x: to.x - box.x,
    y: to.y - box.y
  }
});
var cloneBlockItem = ({
  id,
  item,
  offsetMultiplier
}) => {
  const copiedPosition = item.position;
  return __spreadProps(__spreadValues({}, item), {
    item: id,
    position: {
      x: copiedPosition.x + 20 * offsetMultiplier,
      y: copiedPosition.y + 20 * offsetMultiplier,
      w: copiedPosition.w,
      h: copiedPosition.h
    }
  });
};
var cloneLine = ({
  id,
  item,
  offsetMultiplier
}) => {
  const copiedPosition = item.position;
  return __spreadProps(__spreadValues({}, item), {
    item: id,
    position: {
      from: {
        x: copiedPosition.from.x + 20 * offsetMultiplier,
        y: copiedPosition.from.y + 20 * offsetMultiplier
      },
      to: {
        x: copiedPosition.to.x + 20 * offsetMultiplier,
        y: copiedPosition.to.y + 20 * offsetMultiplier
      }
    }
  });
};
var shiftViewportOnZoom = ({
  scrollLeft,
  scrollTop,
  offsetWidth,
  offsetHeight,
  scaleRatio
}) => {
  const middleOffsetWidth = offsetWidth / 2;
  const middleOffsetHeight = offsetHeight / 2;
  return {
    scrollLeft: (scrollLeft + middleOffsetWidth) * scaleRatio - middleOffsetWidth,
    scrollTop: (scrollTop + middleOffsetHeight) * scaleRatio - middleOffsetHeight
  };
};
var computeRelativePosition = (e, canvasRef, scale = 1) => {
  var _a;
  const pos = getClientPosition(e, scale);
  const canvasDomNode = canvasRef == null ? void 0 : canvasRef.current;
  const rect = (_a = canvasDomNode == null ? void 0 : canvasDomNode.getBoundingClientRect) == null ? void 0 : _a.call(canvasDomNode);
  if (pos && rect) {
    return {
      x: pos.x - rect.left / scale,
      y: pos.y - rect.top / scale
    };
  }
  return pos;
};

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport8 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// src/utils/blockUtils.ts
var findSelectedBlockItems = ({
  layoutStructure,
  selectedItems
}) => layoutStructure.filter(
  (item) => selectedItems.findIndex(
    ({ id }) => item.item === id && (0, dashboard_utils_exports.isBlockItem)(item)
  ) >= 0
);
var getAllBlockItems = ({
  layoutStructure,
  layoutStructureState = {}
}) => {
  return layoutStructure.map((item) => {
    var _a;
    return (_a = layoutStructureState[item.item]) != null ? _a : item;
  }).filter((item) => (0, dashboard_utils_exports.isBlockItem)(item));
};
var computePortPosition = (blockItem, port) => {
  const blockPosition = blockItem.position;
  switch (port) {
    case "n":
      return {
        x: Math.round(blockPosition.x + blockPosition.w / 2),
        y: blockPosition.y
      };
    case "w":
      return {
        x: blockPosition.x,
        y: Math.round(blockPosition.y + blockPosition.h / 2)
      };
    case "e":
      return {
        x: blockPosition.x + blockPosition.w,
        y: Math.round(blockPosition.y + blockPosition.h / 2)
      };
    case "s":
    default:
      return {
        x: Math.round(blockPosition.x + blockPosition.w / 2),
        y: blockPosition.y + blockPosition.h
      };
  }
};
var InvalidBlockItemError = "refers to an invalid block item";
var InvalidBlockItemErrorMessage = (0, i18n_exports._)(`%s ${InvalidBlockItemError}`);
var getBlockItem = ({
  layoutStructure,
  id
}) => {
  const blockItem = layoutStructure.find(({ item }) => item === id);
  if (!blockItem || blockItem.type === "line") {
    throw Error(InvalidBlockItemErrorMessage.replace("%s", id));
  }
  return blockItem;
};

// src/utils/lineUtils.ts
var computeLineAbsPosition = ({
  layoutStructure,
  position
}) => {
  let { from, to } = position;
  if ("item" in from && "port" in from) {
    const blockItem = getBlockItem({ layoutStructure, id: from.item });
    from = computePortPosition(blockItem, from.port);
  }
  if ("item" in to && "port" in to) {
    const blockItem = getBlockItem({ layoutStructure, id: to.item });
    to = computePortPosition(blockItem, to.port);
  }
  return {
    from,
    to
  };
};
var findSelectedLineItems = ({
  layoutStructure,
  selectedItems
}) => layoutStructure.filter(
  ({ item, type }) => selectedItems.findIndex(
    ({ id }) => item === id && type === "line"
  ) >= 0
);
var handleSingleLineMove = ({
  lineId,
  offset,
  layoutStructure
}) => {
  let line = layoutStructure.find(
    (item) => item.item === lineId
  );
  const linePosition = computeLineAbsPosition({
    layoutStructure,
    position: line.position
  });
  if (isLineConnected({ line, dir: "from" })) {
    line = disconnectLine({
      line,
      dir: "from",
      absPos: linePosition.from
    });
  }
  if (isLineConnected({ line, dir: "to" })) {
    line = disconnectLine({
      line,
      dir: "to",
      absPos: linePosition.to
    });
  }
  line = updateLineAbsPosition({
    line,
    dir: "from",
    offset
  });
  line = updateLineAbsPosition({
    line,
    dir: "to",
    offset
  });
  return line;
};
var handleSingleLineDragStart = ({
  lineId,
  layoutStructure,
  lineDir
}) => {
  let line = layoutStructure.find(
    (item) => item.item === lineId
  );
  const linePosition = computeLineAbsPosition({
    layoutStructure,
    position: line.position
  });
  if (isLineConnected({
    line,
    dir: lineDir
  })) {
    line = disconnectLine({
      line,
      dir: lineDir,
      absPos: linePosition[lineDir]
    });
  }
  return line;
};
var getAllLineItems = ({
  layoutStructure,
  layoutStructureState = {}
}) => {
  return layoutStructure.map((item) => {
    var _a;
    return (_a = layoutStructureState[item.item]) != null ? _a : item;
  }).filter(({ type }) => type === "line");
};

// src/utils/imageUtils.ts
var isFromImageRegistry = (src = "") => {
  const [type] = src.split("://");
  return src.indexOf("://") > -1 && type !== "http" && type !== "https" && type !== "ftp" && type !== "file";
};
var validImagePos = ({
  x,
  y,
  canvasWidth,
  canvasHeight
}) => !!(x != null && Number.isInteger(x) && y != null && Number.isInteger(y) && x <= canvasWidth && y <= canvasHeight && x >= 0 && y >= 0);
var validImageWidthHeight = (imageWidth = 1, imageHeight = 1) => !!(Number.isInteger(imageWidth) && Number.isInteger(imageHeight) && imageWidth > 0 && imageHeight > 0);
var sizeTypes = ["cover", "contain", "auto", void 0];
var invalidImageSizeType = (sizeType) => !sizeTypes.includes(sizeType);
var getImageDimension = (0, lodash_exports.memoize)(
  (imgSrc) => {
    const img = new Image();
    try {
      img.src = imgSrc;
      img.style.position = "absolute";
      img.style.left = "-9999";
      img.style.visibility = "hidden";
      document.body.appendChild(img);
      const height = img.naturalHeight;
      const width = img.naturalWidth;
      return { width, height };
    } catch (e) {
      return { width: 0, height: 0 };
    } finally {
      if (document.body.contains(img)) {
        document.body.removeChild(img);
      }
    }
  }
);
var validateOpacity = (opacity) => {
  if (typeof opacity !== "number" || opacity > 1) {
    return 1;
  }
  if (opacity < 0) {
    return 0;
  }
  return opacity;
};
var validateImageXY = ({
  canvasWidth,
  canvasHeight,
  x,
  y
}) => {
  if (!validImagePos({ x, y, canvasWidth, canvasHeight })) {
    dashboard_utils_exports.console.warn(
      `Invalid background image position, x: ${x} y: ${y}. Defaulting to x: 0, y: 0`
    );
    return [0, 0];
  }
  return [x, y];
};
var validateSizeType = ({
  w,
  h,
  sizeType
}) => {
  if (typeof w !== "number" && typeof h !== "number" && (typeof sizeType !== "string" || invalidImageSizeType(sizeType))) {
    dashboard_utils_exports.console.warn(
      `Invalid background image sizeType, ${sizeType}. Defaulting to contain`
    );
    return "contain";
  }
  return sizeType;
};
var validateImageWH = ({ w, h }) => {
  if (validImageWidthHeight(w, h)) {
    return [w, h];
  }
  dashboard_utils_exports.console.warn(
    `Invalid background image width and height, w: ${w} h: ${h}. Defaulting to image original size`
  );
  return [w != null ? w : 0, h != null ? h : 0];
};
var validateBackgroundImage = ({
  backgroundImage = {},
  canvasWidth,
  canvasHeight
}) => {
  var _a;
  if ((0, lodash_exports.isEmpty)(backgroundImage) || !backgroundImage.src) {
    return {
      src: backgroundImage.src,
      x: backgroundImage.x,
      y: backgroundImage.y,
      w: backgroundImage.w,
      h: backgroundImage.h,
      sizeType: backgroundImage.sizeType,
      opacity: (_a = backgroundImage.opacity) != null ? _a : 1
    };
  }
  const opacity = validateOpacity(backgroundImage.opacity);
  const [x, y] = validateImageXY({
    canvasWidth,
    canvasHeight,
    x: backgroundImage.x,
    y: backgroundImage.y
  });
  const sizeType = validateSizeType({
    w: backgroundImage.w,
    h: backgroundImage.h,
    sizeType: backgroundImage.sizeType
  });
  const [w, h] = validateImageWH({
    w: backgroundImage.w,
    h: backgroundImage.h
  });
  return { src: backgroundImage.src, x, y, w, h, sizeType, opacity };
};

// src/DefaultOptions.ts
var absoluteLayoutOptions = {
  width: dashboard_utils_exports.DEFAULT_CANVAS_WIDTH,
  height: dashboard_utils_exports.DEFAULT_CANVAS_HEIGHT,
  display: "auto"
};

// src/apis/AbsoluteLayoutApi.ts
var AbsoluteLayoutApi = class extends BaseLayoutApi_default {
  constructor(_a) {
    var _b = _a, { telemetry } = _b, layout = __objRest(_b, ["telemetry"]);
    super();
    /**
     * Get layout items in order
     * @method
     * @returns {String} ordered item ids
     * @public
     */
    this.getLayoutItemOrder = () => {
      return getAllBlockItems({
        layoutStructure: this.layout.layoutStructureRef.current
      }).map(({ item }) => item);
    };
    /**
     * Adjust layout item order synchronously
     * @method
     * @param {Number} currentOrder
     * @param {Number} newOrder
     * @returns {AbsoluteLayoutStructure} updated layout structure
     * @public
     */
    this.adjustLayoutItemOrderSync = (currentOrder, newOrder, metadata) => {
      this.emitTelemetry({
        pageAction: "adjustLayoutItemOrder",
        metadata
      });
      const blockItems = getAllBlockItems({
        layoutStructure: this.layout.layoutStructureRef.current
      });
      const lineItems = getAllLineItems({
        layoutStructure: this.layout.layoutStructureRef.current
      });
      const updatedBlockItems = moveLayoutItem(
        blockItems,
        currentOrder,
        Math.min(newOrder, blockItems.length)
      );
      return [...lineItems, ...updatedBlockItems];
    };
    /**
     * Adjust layout item order
     * @method
     * @param {Number} currentOrder
     * @param {Number} newOrder
     * @returns {Promise<AbsoluteLayoutStructure>} updated layout structure
     * @public
     */
    this.adjustLayoutItemOrder = (currentOrder, newOrder, metadata) => __async(this, null, function* () {
      return this.adjustLayoutItemOrderSync(currentOrder, newOrder, metadata);
    });
    /**
     * Add a new layout item to the structure synchronously
     * @method
     * @param {Object} options
     * @param {String} options.itemId
     * @param {Object} options.vizContract
     * @param {String} [options.type='block']
     * @param {Object} options.config
     * @returns {AbsoluteLayoutStructure} updated layout structure
     * @public
     */
    this.addLayoutItemSync = ({
      itemId,
      vizContract,
      type = "block",
      config,
      metadata
    }) => {
      this.emitTelemetry({
        pageAction: "addLayoutItem",
        metadata
      });
      return this.addLayoutItemsInternal({
        items: [{ itemId, vizContract, type, config }]
      });
    };
    /**
     * Add a new layout item to the structure
     * @method
     * @param {Object} options
     * @param {String} options.itemId
     * @param {Object} options.vizContract
     * @param {String} [options.type='block']
     * @param {Object} options.config
     * @returns {Promise<AbsoluteLayoutStructure>} updated layout structure
     * @public
     */
    this.addLayoutItem = (_0) => __async(this, [_0], function* ({
      itemId,
      vizContract,
      type = "block",
      config,
      metadata
    }) {
      return this.addLayoutItemSync({ itemId, vizContract, type, config, metadata });
    });
    /**
     * Synchronously generate a new layout structure with one one or more items added
     * @method addLayoutItemsSync
     * @param {Object[]} items
     * @param {Object} [metadata]
     * @returns {AbsoluteLayoutStructure} New layout structure
     * @public
     */
    this.addLayoutItemsSync = (items, metadata) => {
      this.emitTelemetry({
        pageAction: "addLayoutItems",
        metadata
      });
      return this.addLayoutItemsInternal({ items });
    };
    /**
     * Generate a new layout structure with one one or more items added
     * @method addLayoutItems
     * @param {Object[]} items
     * @param {Object} [metadata]
     * @returns {AbsoluteLayoutStructure} New layout structure
     * @public
     */
    this.addLayoutItems = (items, metadata) => __async(this, null, function* () {
      return this.addLayoutItemsSync(items, metadata);
    });
    /**
     * Add multiple new layout items to the structure synchronously
     * @method
     * @param {Object} options
     * @param {Object[]}} options.items
     * @returns {AbsoluteLayoutStructure} updated layout structure
     * @private
     */
    this.addLayoutItemsInternal = ({
      items
    }) => {
      var _a, _b, _c, _d;
      const width = (_b = (_a = this.options) == null ? void 0 : _a.width) != null ? _b : absoluteLayoutOptions.width;
      const height = (_d = (_c = this.options) == null ? void 0 : _c.height) != null ? _d : absoluteLayoutOptions.height;
      return items.reduce(
        (proposedStructure, item) => {
          var _a2;
          const newStructureItem = (0, dashboard_utils_exports.computeNewAbsoluteStructureItem)(__spreadProps(__spreadValues({}, item), {
            config: item.config,
            type: (_a2 = item.type) != null ? _a2 : "block",
            canvasWidth: width,
            canvasHeight: height,
            layoutItems: proposedStructure
          }));
          proposedStructure.push(newStructureItem);
          return proposedStructure;
        },
        [...this.layout.layoutStructureRef.current]
      );
    };
    /**
     * Remove items from layout structure synchronously
     * @method
     * @param {String[]} [itemIds = []] IDs of items to be removed
     * @param {Object} [metadata] Optional telemetry metadata
     * @returns {AbsoluteLayoutStructure} Updated layout structure
     * @public
     */
    this.removeLayoutItemsSync = (itemIds = [], metadata = void 0) => {
      this.emitTelemetry({
        pageAction: "removeLayoutItems",
        metadata
      });
      const updatedItems = [];
      this.layout.layoutStructureRef.current.forEach((item) => {
        let iterItem = item;
        if (item.type === "line") {
          let updatedLine = item;
          const absPos = computeLineAbsPosition({
            layoutStructure: this.layout.layoutStructureRef.current,
            position: updatedLine.position
          });
          if ("item" in updatedLine.position.from && itemIds.indexOf(updatedLine.position.from.item) >= 0) {
            updatedLine = disconnectLine({
              line: updatedLine,
              dir: "from",
              absPos: absPos.from
            });
          }
          if ("item" in updatedLine.position.to && itemIds.indexOf(updatedLine.position.to.item) >= 0) {
            updatedLine = disconnectLine({
              line: updatedLine,
              dir: "to",
              absPos: absPos.to
            });
          }
          iterItem = updatedLine;
        }
        if (itemIds.indexOf(iterItem.item) < 0) {
          updatedItems.push(iterItem);
        }
      });
      return updatedItems;
    };
    /**
     * Remove items from layout structure
     * @method
     * @param {String[]} [itemIds = []] IDs of items to be removed
     * @param {Object} [metadata] Optional telemetry metadata
     * @returns {Promise<AbsoluteLayoutStructure>} Updated layout structure
     * @public
     */
    this.removeLayoutItems = (..._0) => __async(this, [..._0], function* (itemIds = [], metadata = void 0) {
      return this.removeLayoutItemsSync(itemIds, metadata);
    });
    /**
     * Copies a layout item position and size and offsets by `2 * GRID_SIZE` synchronously
     * @method
     * @param {Object} config
     * @param {Array} config.from List of original viz ids
     * @param {Array} config.to List of new viz ids
     * @param {Number} [config.offsetMultiplier=1] Number of grids to offset
     * @returns {AbsoluteLayoutStructure} Layout structure of all known items
     * @public
     * @throws {Error} Will error if `from` or `to` is not an array, or `from.length` != `to.length`
     */
    this.cloneLayoutItemsSync = ({
      from,
      to,
      offsetMultiplier = 1,
      metadata
    }) => {
      if (!Array.isArray(from) || !Array.isArray(to) || from.length !== to.length) {
        throw new Error(
          `Cannot clone item, incorrect inputs from ${from}, to: ${to}`
        );
      }
      this.emitTelemetry({
        pageAction: "cloneLayoutItems",
        metadata
      });
      const currentStructure = Object.fromEntries(
        Object.values(this.layout.layoutStructureRef.current).map(
          (item) => [item.item, item]
        )
      );
      const newLayoutItems = [];
      from.forEach((copyItemId, idx) => {
        const item = currentStructure[copyItemId];
        if (!item) {
          return;
        }
        if ((0, dashboard_utils_exports.isBlockItem)(item)) {
          const clonedBlockItem = cloneBlockItem({
            id: to[idx],
            item,
            offsetMultiplier
          });
          newLayoutItems.push(clonedBlockItem);
        } else if (item.type === "line") {
          const linePosition = computeLineAbsPosition({
            layoutStructure: this.layout.layoutStructureRef.current,
            position: item.position
          });
          const clonedLine = cloneLine({
            id: to[idx],
            item: {
              item: copyItemId,
              type: "line",
              position: linePosition
            },
            offsetMultiplier
          });
          newLayoutItems.push(clonedLine);
        }
      });
      return [...this.layout.layoutStructureRef.current, ...newLayoutItems];
    };
    /**
     * Copies a layout item position and size and offsets by 2 * GRID_SIZE
     * @method
     * @param {Object} config
     * @param {Array} config.from List of original viz ids
     * @param {Array} config.to List of new viz ids
     * @param {Number} [config.offsetMultiplier=1] Number of grids to offset
     * @returns {AbsoluteLayoutStructure} Layout structure of all known items
     * @public
     */
    this.cloneLayoutItems = (_0) => __async(this, [_0], function* ({
      from,
      to,
      offsetMultiplier = 1,
      metadata
    }) {
      return this.cloneLayoutItemsSync({ from, to, offsetMultiplier, metadata });
    });
    /**
     * get dashboard canvas dom element
     */
    this.getCanvasDomElement = () => {
      return this.layout.getCanvasDomElement();
    };
    /**
     * return snapshot of that includes inlined background image
     * @method
     * @returns {Object} Updated Layout options with encoded background image
     * @public
     */
    this.snapshot = () => {
      var _a, _c;
      const _b = (_a = this.options) != null ? _a : {}, { backgroundImage: imgFromOpts } = _b, opts = __objRest(_b, ["backgroundImage"]);
      const srcFromOptions = (_c = imgFromOpts == null ? void 0 : imgFromOpts.src) != null ? _c : "";
      const srcFromImageRegistry = isFromImageRegistry(srcFromOptions);
      const backgroundImage = imgFromOpts ? {
        backgroundImage: __spreadProps(__spreadValues({}, imgFromOpts), {
          src: srcFromImageRegistry ? this.layout.getBgImageSrc() : srcFromOptions
        })
      } : {};
      return {
        options: __spreadValues(__spreadValues({}, opts != null ? opts : {}), backgroundImage)
      };
    };
    /**
     * Sets dashboard scale
     * @param {Number} scale New scale as floating point number
     */
    this.setScale = (scale) => {
      return this.layout.setScale(scale);
    };
    /**
     * Increases dashboard zoom level for one step
     */
    this.zoomIn = () => {
      return this.layout.zoomIn();
    };
    /**
     * Decreases dashboard zoom level for one step
     */
    this.zoomOut = () => {
      return this.layout.zoomOut();
    };
    /**
     * Adjust dashboard's scale to fit the width of the container
     */
    this.fitToWidth = (maxScale = Infinity) => {
      return this.layout.setFitToWidthAndScrollToTopLeft(maxScale);
    };
    /**
     * @returns {Object} Observable that tracks zoom level changes or null if zoom is unsupported
     */
    this.getZoomLevel = () => {
      return this.layout.getZoomObserver();
    };
    this.layout = layout;
    this.telemetry = telemetry;
    Object.defineProperty(this, "options", {
      get() {
        var _a2;
        return (_a2 = this.layout.optionsRef) == null ? void 0 : _a2.current;
      }
    });
  }
};
var AbsoluteLayoutApi_default = AbsoluteLayoutApi;

// src/GridLayoutConstants.ts
var CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL = (0, i18n_exports._)(
  "This panel is too small to be split into duplicates. Stretch or move the panel to make it bigger first."
);
var ITEM_DROP_TARGET_PX = 12;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport9 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport10 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// src/hooks/useBackgroundImage.ts
var useBackgroundImage = (backgroundImageSrc) => {
  const [imageSrc, setImageSrc] = (0, react_exports.useState)("");
  const imageRegistry = (0, dashboard_context_exports.useImageRegistry)();
  const fetchBackgroundImage = (registry, bgImageSrc) => __async(void 0, null, function* () {
    try {
      if (registry) {
        if (registry.isResourceURL(bgImageSrc)) {
          const imageObject = yield registry.getByURL(bgImageSrc);
          setImageSrc(imageObject.dataURI);
        } else {
          setImageSrc(bgImageSrc);
        }
      } else {
        setImageSrc(bgImageSrc);
      }
    } catch (error) {
      if (error instanceof Error) {
        dashboard_utils_exports.console.error(error.message);
      } else {
        dashboard_utils_exports.console.error("An unknown error occurred");
      }
    }
  });
  (0, react_exports.useEffect)(() => {
    if (backgroundImageSrc) {
      fetchBackgroundImage(
        imageRegistry,
        backgroundImageSrc
      );
    } else {
      setImageSrc("");
    }
  }, [imageRegistry, backgroundImageSrc]);
  return imageSrc;
};

// esm-externals:@splunk/dashboard-state
var dashboard_state_exports = {};
__export(dashboard_state_exports, {
  default: () => dashboard_state_default
});
var defaultImport11 = __toESM(require("@splunk/dashboard-state"));
__reExport(dashboard_state_exports, require("@splunk/dashboard-state"));
var dashboard_state_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/datasource-utils
var datasource_utils_exports = {};
__export(datasource_utils_exports, {
  default: () => datasource_utils_default
});
var defaultImport12 = __toESM(require("@splunk/datasource-utils"));
__reExport(datasource_utils_exports, require("@splunk/datasource-utils"));
var datasource_utils_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// src/utils/showHideUtils.ts
var hasNoResults = (searchData) => {
  var _a, _b, _c;
  if (typeof searchData === "undefined") {
    return true;
  }
  return ((_b = (_a = searchData.meta) == null ? void 0 : _a.totalCount) != null ? _b : 0) === 0 && ((_c = searchData == null ? void 0 : searchData.meta) == null ? void 0 : _c.status) !== datasource_utils_exports.DS_STATUS.REFRESHING;
};
var shouldHideItem = ({
  item,
  definition,
  searchData,
  conditionResults
}) => {
  var _a, _b, _c, _d;
  if (!definition) {
    return false;
  }
  if (item.type === "line") {
    return false;
  }
  const {
    hideWhenNoData,
    conditions = [],
    hideWhenConditions
  } = (_b = (_a = definition.containerOptions) == null ? void 0 : _a.visibility) != null ? _b : {};
  if (!!(hideWhenNoData != null ? hideWhenNoData : definition.hideWhenNoData) && hasNoResults(searchData)) {
    return true;
  }
  if (((_c = definition.containerOptions) == null ? void 0 : _c.visibility) && "hideInViewMode" in definition.containerOptions.visibility && !!((_d = definition.containerOptions.visibility) == null ? void 0 : _d.hideInViewMode)) {
    return true;
  }
  if (conditions.length !== 0) {
    return hideWhenConditions === "all-true" ? conditions.every((condId) => conditionResults[condId]) : conditions.some((condId) => conditionResults[condId]);
  }
  return false;
};

// src/hooks/useLayoutShowHide.ts
var getCondIds = (allItems) => allItems === void 0 ? [] : Object.values(allItems).flatMap(
  (itemDef) => {
    var _a, _b, _c;
    return (_c = (_b = (_a = itemDef.containerOptions) == null ? void 0 : _a.visibility) == null ? void 0 : _b.conditions) != null ? _c : [];
  }
);
var useLayoutShowHide = (layoutStructure, handleReflow) => {
  const allVizs = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectVisualizations);
  const allInputs = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectInputs);
  const mode = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectMode);
  const allConditionIds = (0, react_exports.useMemo)(
    () => /* @__PURE__ */ new Set([...getCondIds(allVizs), ...getCondIds(allInputs)]),
    [allInputs, allVizs]
  );
  const conditionResults = (0, dashboard_state_exports.useSelector)(
    (state) => (0, dashboard_state_exports.selectConditionResults)(state, Array.from(allConditionIds))
  );
  const subscriptions = (0, dashboard_ui_exports.useBatchSubscribeToSearches)({
    consumerId: "<layout>"
  });
  const { enableShowHide } = (0, dashboard_context_exports.useFeatureFlags)();
  return (0, react_exports.useMemo)(() => {
    if (!enableShowHide || mode === "edit") {
      return layoutStructure;
    }
    const itemsToRemove = [];
    const filteredStructure = layoutStructure.filter((item) => {
      var _a;
      if (shouldHideItem({
        item,
        definition: (_a = allVizs[item.item]) != null ? _a : allInputs == null ? void 0 : allInputs[item.item],
        searchData: subscriptions[item.item],
        conditionResults
      })) {
        itemsToRemove.push(item);
        return false;
      }
      return true;
    });
    return itemsToRemove.length && handleReflow ? handleReflow(layoutStructure, itemsToRemove) : filteredStructure;
  }, [
    enableShowHide,
    mode,
    layoutStructure,
    handleReflow,
    allVizs,
    allInputs,
    subscriptions,
    conditionResults
  ]);
};

// src/hooks/useMouseDownWithHandleEventListeners.ts
var useMouseDownWithHandleEventListeners = ({
  handleMouseDownOnItem,
  canvasRef,
  scale,
  setStartPosition,
  movable,
  setIsMoving,
  isMovingRef
}) => {
  const handleMouseDownOnVizWithHandle = (0, dashboard_ui_exports.useEventCallback)(
    (e) => {
      const { vizId, initialEvent, type } = e.detail;
      const pos = computeRelativePosition(initialEvent, canvasRef, scale);
      setStartPosition(pos);
      const block = {
        id: vizId,
        type
      };
      handleMouseDownOnItem(initialEvent, block);
    }
  );
  const handleMouseDownOnHandle = (0, dashboard_ui_exports.useEventCallback)((e) => {
    const { vizId, initialEvent, type } = e.detail;
    const pos = computeRelativePosition(initialEvent, canvasRef, scale);
    setStartPosition(pos);
    const block = {
      id: vizId,
      type
    };
    handleMouseDownOnItem(initialEvent, block);
    if (movable) {
      setIsMoving(true);
      if (isMovingRef) {
        isMovingRef.current = true;
      }
    }
  });
  (0, dashboard_ui_exports.useEventListener)({
    eventName: dashboard_ui_exports.EVENT_MOUSE_DOWN_ON_VIZ_WITH_HANDLE,
    target: document,
    listener: handleMouseDownOnVizWithHandle
  });
  (0, dashboard_ui_exports.useEventListener)({
    eventName: dashboard_ui_exports.EVENT_MOUSE_DOWN_ON_HANDLE,
    target: document,
    listener: handleMouseDownOnHandle
  });
};

// esm-externals:rxjs
var rxjs_exports = {};
__export(rxjs_exports, {
  default: () => rxjs_default
});
var defaultImport13 = __toESM(require("rxjs"));
__reExport(rxjs_exports, require("rxjs"));
var rxjs_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// src/AbsoluteLayoutConstants.ts
var GRID_SIZE = 10;
var GRID_PADDING = 1;
var MIN_WIDTH = GRID_SIZE * 2;
var MIN_HEIGHT = GRID_SIZE * 2;
var ZOOM_STEP_SIZE = 0.25;

// src/hooks/useZoom.ts
var useZoom = ({
  canvasRef,
  width,
  height,
  containerWidth,
  containerHeight
}) => {
  const [internalScale, setInternalScale] = (0, react_exports.useState)(1);
  const [fitToWidth, setFitToWidth] = (0, react_exports.useState)(false);
  const scrollbarWidth = (0, react_exports.useMemo)(() => (0, dashboard_utils_exports.getScrollbarWidth)(), []);
  const keyboardListener = (0, dashboard_context_exports.useKeyboardListener)();
  const zoomObserver = (0, react_exports.useRef)(null);
  const currentStepRef = (0, react_exports.useRef)(1);
  currentStepRef.current = Math.round(internalScale / ZOOM_STEP_SIZE) * ZOOM_STEP_SIZE;
  const getZoomObserver = (0, react_exports.useCallback)(() => {
    if (zoomObserver.current == null) {
      zoomObserver.current = new rxjs_exports.BehaviorSubject(1);
    }
    return zoomObserver.current;
  }, []);
  (0, react_exports.useEffect)(() => {
    if (!fitToWidth) {
      return;
    }
    const newScale = computeScaleToFit({
      canvasWidth: width,
      canvasHeight: height,
      containerWidth,
      containerHeight,
      max: fitToWidth,
      scrollbarWidth
    });
    getZoomObserver().next(newScale);
    setInternalScale(newScale);
  }, [
    width,
    height,
    containerWidth,
    containerHeight,
    fitToWidth,
    scrollbarWidth,
    getZoomObserver
  ]);
  const setScale = (0, react_exports.useCallback)(
    (s) => {
      getZoomObserver().next(s);
      setInternalScale(s);
      setFitToWidth(false);
    },
    [getZoomObserver]
  );
  const scrollToTopLeft = (0, react_exports.useCallback)(() => {
    var _a;
    const layoutEl = (_a = canvasRef.current) == null ? void 0 : _a.parentElement;
    if (layoutEl) {
      layoutEl.scrollTop = 0;
      layoutEl.scrollLeft = 0;
    }
  }, [canvasRef]);
  const setFitToWidthAndScrollToTopLeft = (0, react_exports.useCallback)(
    (maxScale = Infinity) => {
      setFitToWidth(maxScale);
      scrollToTopLeft();
    },
    [scrollToTopLeft]
  );
  const zoomIn = (0, react_exports.useCallback)(() => {
    setScale(currentStepRef.current + ZOOM_STEP_SIZE);
  }, [setScale]);
  const zoomOut = (0, react_exports.useCallback)(() => {
    const nextStep = currentStepRef.current - ZOOM_STEP_SIZE;
    if (nextStep >= ZOOM_STEP_SIZE) {
      setScale(nextStep);
    }
  }, [setScale]);
  const handleKeyboardZoom = (0, react_exports.useCallback)(
    ({
      dir,
      preventDefault
    }) => {
      switch (dir) {
        case "in":
          zoomIn();
          break;
        case "out":
          zoomOut();
          break;
        case "reset":
          setFitToWidthAndScrollToTopLeft();
          break;
        default:
          break;
      }
      preventDefault();
    },
    [setFitToWidthAndScrollToTopLeft, zoomIn, zoomOut]
  );
  (0, react_exports.useEffect)(() => {
    if (!keyboardListener) {
      return dashboard_utils_exports.noop;
    }
    const unsubscribeZoom = keyboardListener.subscribe(
      "zoom",
      handleKeyboardZoom
    );
    return () => {
      unsubscribeZoom();
    };
  }, [handleKeyboardZoom, keyboardListener]);
  return {
    scale: internalScale,
    fitToWidth,
    getZoomObserver,
    setScale,
    zoomIn,
    zoomOut,
    setFitToWidthAndScrollToTopLeft
  };
};

// src/components/Canvas/BackgroundImage.tsx
var toBackgroundImageSize = ({
  src,
  imageHeight,
  imageWidth,
  sizeType
}) => {
  const { width: w, height: h } = getImageDimension(src != null ? src : "");
  if (imageWidth && imageHeight) {
    return `${(0, dashboard_utils_exports.toPx)(imageWidth)} ${(0, dashboard_utils_exports.toPx)(imageHeight)}`;
  }
  if (imageWidth || imageHeight) {
    return `${(0, dashboard_utils_exports.toPx)(imageWidth != null ? imageWidth : w)} ${(0, dashboard_utils_exports.toPx)(imageHeight != null ? imageHeight : h)}`;
  }
  return sizeType != null ? sizeType : "contain";
};
var BackgroundImageDiv = styled_components_default.div.attrs(() => ({
  "data-test": "background-image"
}))`
    ${themes_exports.mixins.reset("inline-block")};
    width: 100%;
    height: 100%;
    position: relative;
    background-repeat: no-repeat;
    background-image: ${(props) => `url("${props.src}")`};
    background-size: ${(props) => toBackgroundImageSize(props)};
    background-position: ${(props) => `${(0, dashboard_utils_exports.toPx)(props.imageX)} ${(0, dashboard_utils_exports.toPx)(props.imageY)}`};
    opacity: ${(prop) => validateOpacity(prop.opacity)};
`;
var BackgroundImage = (_a) => {
  var _b = _a, { src } = _b, rest = __objRest(_b, ["src"]);
  const imageSrc = useBackgroundImage(src);
  if (!imageSrc) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(BackgroundImageDiv, __spreadProps(__spreadValues({}, rest), { src: imageSrc }));
};

// src/components/Canvas/CanvasBorder.tsx
var Border = styled_components_default.div.attrs(() => ({
  "data-test": "canvas-border"
}))`
    position: absolute;
    box-sizing: border-box;
    border: 2px dashed
        ${(0, themes_exports.pick)({
  enterprise: {
    light: themes_exports.variables.gray80,
    dark: themes_exports.variables.gray30
  },
  prisma: themes_exports.variables.interactiveColorBorder
})};
    left: 0px;
    top: 0px;
    right: 0px;
    bottom: 0px;
    width: 100%;
    height: 100%;
`;
var CanvasBorder = ({
  showBorder = false
}) => {
  if (!showBorder) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(Border, null);
};

// src/components/Canvas/CanvasGridlines.tsx
var GRID_LINE_OPACITY = 0.1;
var getGridLineColor = (props) => {
  var _a;
  return (_a = props.gridLineColor) != null ? _a : (0, themes_exports.pick)({
    light: "#D8D8D8",
    dark: "#9B9B9B"
  });
};
var GridLines = styled_components_default.div`
    position: absolute;
    box-sizing: border-box;
    left: 0px;
    top: 0px;
    right: 0px;
    bottom: 0px;
    width: 100%;
    height: 100%;
    opacity: ${(prop) => {
  var _a;
  return (_a = prop.gridLineOpacity) != null ? _a : GRID_LINE_OPACITY;
}};
    background-size: ${(prop) => prop.gridWidth + prop.gridLineWidth}px
        ${(prop) => prop.gridHeight + prop.gridLineWidth}px;
    background-image: repeating-linear-gradient(
            0deg,
            ${getGridLineColor},
            ${getGridLineColor} ${(prop) => (0, dashboard_utils_exports.toPx)(prop.gridLineWidth)},
            transparent ${(prop) => prop.gridLineWidth}px,
            transparent ${(prop) => prop.gridHeight + prop.gridLineWidth}px
        ),
        repeating-linear-gradient(
            -90deg,
            ${getGridLineColor},
            ${getGridLineColor} ${(prop) => (0, dashboard_utils_exports.toPx)(prop.gridLineWidth)},
            transparent ${(prop) => prop.gridLineWidth}px,
            transparent ${(prop) => prop.gridWidth + prop.gridLineWidth}px
        );
`;
var CanvasGridlines = (_a) => {
  var _b = _a, { showGrid } = _b, rest = __objRest(_b, ["showGrid"]);
  if (!showGrid) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(GridLines, __spreadProps(__spreadValues({}, rest), { "data-test": "gridlines" }));
};

// src/components/Canvas/Background.tsx
var toScale = (scale) => scale ? {
  transform: `scale(${scale})`,
  transformOrigin: "0 0",
  width: `${100 / scale}%`
} : {
  width: "100%"
};
var Background = styled_components_default.div.attrs((props) => ({
  style: __spreadValues({
    height: props.height
  }, toScale(props.scale))
}))`
    ${themes_exports.mixins.reset("inline-block")};
    position: relative;
    background: ${(prop) => prop.bgColor || // NOTE: this needs to match packages/dashboard-editors/src/layouts/AbsoluteLayoutEditor.jsx
dashboard_ui_exports.customThemeVariables.dashboardBackgroundColor};
`;

// src/components/Canvas/Canvas.tsx
var CanvasContainer = styled_components_default.div.attrs((props) => ({
  style: { width: props.width, height: props.height }
}))`
    ${themes_exports.mixins.reset("block")};
    overflow: ${(prop) => prop.showOverflowContent ? "visible" : "hidden"};
    user-select: ${(prop) => prop.userSelect ? "text" : "none"};
    position: relative;
`;
var Canvas = (_a, canvasRef) => {
  var _b = _a, {
    width,
    height,
    scale,
    backgroundColor: unsanitizedBgColor = "",
    backgroundImageSrc,
    backgroundImageSizeType,
    backgroundImageWidth,
    backgroundImageHeight,
    backgroundImagePositionX,
    backgroundImagePositionY,
    backgroundImageOpacity,
    gridLineOpacity,
    children,
    showOverflowContent = false,
    userSelect = false,
    showGrid = false,
    gridPadding = 0,
    gridLineWidth = 1,
    gridLineColor,
    gridWidth = 9,
    gridHeight = 9,
    showBorder = false,
    cssScaling = true
  } = _b, others = __objRest(_b, [
    "width",
    "height",
    "scale",
    "backgroundColor",
    "backgroundImageSrc",
    "backgroundImageSizeType",
    "backgroundImageWidth",
    "backgroundImageHeight",
    "backgroundImagePositionX",
    "backgroundImagePositionY",
    "backgroundImageOpacity",
    "gridLineOpacity",
    "children",
    "showOverflowContent",
    "userSelect",
    "showGrid",
    "gridPadding",
    "gridLineWidth",
    "gridLineColor",
    "gridWidth",
    "gridHeight",
    "showBorder",
    "cssScaling"
  ]);
  const containerWidth = scale != null ? width * scale : width;
  const containerHeight = scale != null && cssScaling ? height * scale : height;
  const backgroundColor = (0, dashboard_ui_exports.sanitizeColor)(unsanitizedBgColor);
  return /* @__PURE__ */ react_default.createElement(
    CanvasContainer,
    __spreadValues({
      "data-test": "canvas-container",
      "data-width": containerWidth,
      "data-height": containerHeight,
      width: cssScaling ? containerWidth : width,
      height: containerHeight,
      showOverflowContent,
      userSelect,
      ref: canvasRef
    }, others),
    /* @__PURE__ */ react_default.createElement(
      Background,
      {
        "data-test": "canvas",
        "data-width": width,
        "data-height": height,
        "data-scale": scale,
        height,
        scale: cssScaling ? scale : void 0,
        bgColor: backgroundColor
      },
      /* @__PURE__ */ react_default.createElement(
        BackgroundImage,
        {
          src: backgroundImageSrc,
          sizeType: backgroundImageSizeType,
          imageWidth: backgroundImageWidth,
          imageHeight: backgroundImageHeight,
          imageX: backgroundImagePositionX,
          imageY: backgroundImagePositionY,
          opacity: backgroundImageOpacity
        }
      ),
      /* @__PURE__ */ react_default.createElement(CanvasBorder, { showBorder }),
      /* @__PURE__ */ react_default.createElement(
        CanvasGridlines,
        {
          showGrid,
          gridLineOpacity,
          gridPadding,
          gridLineWidth,
          gridLineColor,
          gridWidth,
          gridHeight
        }
      ),
      children
    )
  );
};
var Canvas_default = (0, react_exports.forwardRef)(Canvas);

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport14 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// src/components/SelectBox.jsx
var SelectDiv = styled_components_default.div.attrs(({ x, y, w, h }) => ({
  style: {
    width: w,
    height: h,
    transform: `translate(${x}px, ${y}px)`
  }
}))`
    ${themes_exports.mixins.reset("block")};
    position: absolute;
    background: transparent;
    // the next line is important to avoid blocking the drilldowns, and it allows to select text from visualizations
    pointer-events: none;
    border: 1px solid
        ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    z-index: 1000;
`;
var Wrapper = styled_components_default.div`
    ${themes_exports.mixins.reset("block")};
    background: transparent;
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
`;
var SelectBox = ({ start, end }) => /* @__PURE__ */ react_default.createElement(Wrapper, null, /* @__PURE__ */ react_default.createElement(
  SelectDiv,
  {
    w: Math.abs(start.x - end.x),
    h: Math.abs(start.y - end.y),
    x: Math.min(start.x, end.x),
    y: Math.min(start.y, end.y)
  }
));
SelectBox.propTypes = {
  /**
   * starting position
   */
  start: prop_types_default.shape({
    x: prop_types_default.number,
    y: prop_types_default.number
  }),
  /**
   * end position
   */
  end: prop_types_default.shape({
    x: prop_types_default.number,
    y: prop_types_default.number
  })
};
var SelectBox_default = SelectBox;

// src/utils/findStatusIcon.ts
var findStatusIcon = ({
  canvasRef,
  id
}) => {
  const canvas = canvasRef == null ? void 0 : canvasRef.current;
  if (!canvas) {
    return null;
  }
  return canvas.querySelector(
    `[data-id="${id}"] [data-test="simple-status-icon-container"]`
  );
};

// src/components/AbsoluteCanvas.tsx
var defaultState = {
  startPosition: null,
  currentPosition: null,
  isMoving: false,
  isSelecting: false
};
var DEFAULT_SELECTED_LAYOUT_ITEMS = [];
var AbsoluteCanvas = (props) => {
  const _a = props, {
    scale,
    children,
    canvasRef,
    blockItems,
    onItemMove = dashboard_utils_exports.noop,
    onItemMoved = dashboard_utils_exports.noop,
    onItemSelected,
    movable = false,
    allowMultiselect,
    selectedLayoutItems = DEFAULT_SELECTED_LAYOUT_ITEMS,
    initialState = defaultState,
    onMouseDownCapture,
    onMouseUpCapture
  } = _a, canvasProps = __objRest(_a, [
    "scale",
    "children",
    "canvasRef",
    "blockItems",
    "onItemMove",
    "onItemMoved",
    "onItemSelected",
    "movable",
    "allowMultiselect",
    "selectedLayoutItems",
    "initialState",
    "onMouseDownCapture",
    "onMouseUpCapture"
  ]);
  const [startPosition, setStartPosition] = (0, react_exports.useState)(
    initialState.startPosition
  );
  const [currentPosition, setCurrentPosition] = (0, react_exports.useState)(
    initialState.currentPosition
  );
  const [isMoving, setIsMoving] = (0, react_exports.useState)(initialState.isMoving);
  const [isSelecting, setIsSelecting] = (0, react_exports.useState)(initialState.isSelecting);
  const isMovingRef = (0, react_exports.useRef)(false);
  const { isMouseDownOnItemWithHandle, setIsMouseDownOnItemWithHandle } = (0, dashboard_context_exports.useMouseEventsContext)();
  const isMetaKeyUsed = (0, react_exports.useRef)(false);
  const isSelectedWithMetaKey = (0, react_exports.useRef)(false);
  const isMacOS = (0, dashboard_utils_exports.isMac)();
  const profiler = (0, dashboard_telemetry_exports.useDashboardProfiler)();
  const resetState = (0, react_exports.useCallback)(() => {
    setStartPosition(defaultState.startPosition);
    setCurrentPosition(defaultState.currentPosition);
    setIsMoving(defaultState.isMoving);
    setIsSelecting(defaultState.isSelecting);
    isMovingRef.current = false;
    isMetaKeyUsed.current = false;
    isSelectedWithMetaKey.current = false;
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isMovingRef.current && blockItems && (profiler == null ? void 0 : profiler.hasPartialMeasurement(dashboard_telemetry_exports.VIZ_MOVE_EVENT))) {
      profiler == null ? void 0 : profiler.endMeasurement(dashboard_telemetry_exports.VIZ_MOVE_EVENT);
    }
  }, [blockItems, profiler]);
  (0, react_exports.useEffect)(() => {
    if (selectedLayoutItems.length) {
      profiler == null ? void 0 : profiler.emitAndClearTimer({
        timerName: dashboard_telemetry_exports.VIZ_SELECT_EVENT,
        metadata: {
          numOfSelectedItems: selectedLayoutItems.length
        }
      });
    }
  }, [profiler, selectedLayoutItems]);
  const handleItemSelected = (0, react_exports.useCallback)(
    (e, items = []) => {
      if (items.some(
        ({ id, type }) => {
          var _a2;
          return type === "input" && ((_a2 = findStatusIcon({ canvasRef, id })) == null ? void 0 : _a2.contains(
            e.target
          ));
        }
      )) {
        return;
      }
      profiler == null ? void 0 : profiler.startTimer({
        timerName: dashboard_telemetry_exports.VIZ_SELECT_EVENT
      });
      if (isMacOS && e.metaKey || !isMacOS && e.ctrlKey) {
        const selectedItems = selectedLayoutItems.filter(
          ({ type }) => type === "block" || type === "input"
        );
        isSelectedWithMetaKey.current = true;
        onItemSelected(e, (0, lodash_exports.uniqBy)([...selectedItems, ...items], "id"));
      } else {
        onItemSelected(e, items);
      }
    },
    [canvasRef, profiler, selectedLayoutItems, onItemSelected, isMacOS]
  );
  const handleMouseDownOnItem = (0, react_exports.useCallback)(
    (event, blockItem) => {
      if (isMacOS && event.metaKey || !isMacOS && event.ctrlKey) {
        isMetaKeyUsed.current = true;
      }
      const { id, type = "block" } = blockItem;
      if (selectedLayoutItems.find(
        ({ id: selectedId }) => selectedId === id
      )) {
        return;
      }
      handleItemSelected(event, [{ id, type }]);
    },
    [handleItemSelected, selectedLayoutItems, isMacOS]
  );
  const handleMouseMove = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (!startPosition) {
      return;
    }
    const newPosition = computeRelativePosition(e, canvasRef, scale);
    const offset = getOffset(newPosition, startPosition);
    if (isMoving && considerMoved(offset)) {
      e.stopImmediatePropagation();
      e.preventDefault();
      onItemMove(e, offset);
    }
    setCurrentPosition(newPosition);
  });
  const handleMouseUpWithMetaKey = (event, item) => {
    var _a2;
    if (!item) {
      return;
    }
    const { item: itemId } = item;
    if (itemId && isMetaKeyUsed.current && !isSelectedWithMetaKey.current) {
      const selectedItems = selectedLayoutItems.filter(
        ({ type }) => type === "block" || type === "input"
      );
      const alreadySelected = selectedItems.filter(
        (element) => element.id === itemId
      );
      if (alreadySelected.length) {
        const removedAlreadySelected = selectedItems.filter(
          (element) => element.id !== itemId
        );
        onItemSelected(
          event,
          (0, lodash_exports.uniqBy)([...removedAlreadySelected], "id")
        );
      } else {
        handleItemSelected(event, [
          { id: itemId, type: (_a2 = item == null ? void 0 : item.type) != null ? _a2 : "block" }
        ]);
      }
    }
  };
  const handleMouseUp = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (!startPosition) {
      return;
    }
    e.preventDefault();
    const curPosition = computeRelativePosition(e, canvasRef, scale);
    const offset = getOffset(curPosition, startPosition);
    const isMoved = considerMoved(offset);
    if (isMoving && isMoved) {
      isMovingRef.current = false;
      onItemMoved(e, offset);
    } else if (isSelecting) {
      const boundary = positionsToBoundary(startPosition, curPosition);
      const selectedBlocks = filterBlockItemsByBoundary(
        blockItems,
        boundary
      ).map(
        ({ item, type = "block" }) => ({
          id: item,
          type
        })
      );
      let selectedBlockItems = [];
      if (!isMoved && selectedBlocks.length) {
        selectedBlockItems.push((0, lodash_exports.last)(selectedBlocks));
      } else {
        selectedBlockItems = selectedBlocks;
      }
      handleItemSelected(e, selectedBlockItems);
    } else {
      const item = findTopBlockItemByPosition(blockItems, curPosition);
      const { item: itemId, type = "block" } = item != null ? item : {};
      if (isMetaKeyUsed.current) {
        handleMouseUpWithMetaKey(e, item);
      } else if (itemId && !(selectedLayoutItems.length === 1 && selectedLayoutItems[0].id === itemId) && !isMoved && !isMetaKeyUsed.current) {
        handleItemSelected(e, [{ id: itemId, type }]);
      } else if (!itemId && !findTopBlockItemByPosition(blockItems, startPosition)) {
        handleItemSelected(e, []);
      }
    }
    resetState();
  });
  const handleMouseDown = (0, dashboard_ui_exports.useEventCallback)(
    (e, selectedBlockItem) => {
      if (isMouseDownOnItemWithHandle == null ? void 0 : isMouseDownOnItemWithHandle.current) {
        setIsMouseDownOnItemWithHandle(false);
        return;
      }
      const pos = computeRelativePosition(e, canvasRef, scale);
      setStartPosition(pos);
      const block = selectedBlockItem != null ? selectedBlockItem : findTopBlockItemByPosition(blockItems, pos);
      if (!block) {
        if (allowMultiselect) {
          setIsSelecting(true);
        }
        return;
      }
      const { item, type } = block;
      handleMouseDownOnItem(e, {
        id: item,
        type
      });
      if (movable) {
        setIsMoving(true);
        isMovingRef.current = true;
      }
    }
  );
  const handleMouseDownCapture = (0, dashboard_ui_exports.useEventCallback)((e) => {
    onMouseDownCapture == null ? void 0 : onMouseDownCapture(e);
    const pos = computeRelativePosition(e, canvasRef, scale);
    const selectedBlockItems = blockItems.filter(
      (item) => selectedLayoutItems.some(
        (selectedItem) => selectedItem.id === item.item
      )
    );
    const topSelectedBlock = findTopBlockItemByPosition(
      selectedBlockItems,
      pos
    );
    const topBlock = findTopBlockItemByPosition(blockItems, pos);
    if (topSelectedBlock && topSelectedBlock !== topBlock) {
      handleMouseDown(e, topSelectedBlock);
      e.stopPropagation();
      e.preventDefault();
    }
  });
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mousemove", handleMouseMove, true);
    return () => {
      document.removeEventListener("mousemove", handleMouseMove, true);
    };
  }, [handleMouseMove]);
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mouseup", handleMouseUp);
    return () => {
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [handleMouseUp]);
  useMouseDownWithHandleEventListeners({
    handleMouseDownOnItem,
    canvasRef,
    scale,
    setStartPosition,
    movable,
    setIsMoving,
    isMovingRef
  });
  const selectBox = (0, react_exports.useMemo)(() => {
    if (allowMultiselect && isSelecting && !isMoving && startPosition && currentPosition) {
      return /* @__PURE__ */ react_default.createElement(SelectBox_default, { start: startPosition, end: currentPosition });
    }
    return null;
  }, [
    allowMultiselect,
    isSelecting,
    isMoving,
    startPosition,
    currentPosition
  ]);
  return /* @__PURE__ */ react_default.createElement(
    Canvas_default,
    __spreadProps(__spreadValues({
      ref: canvasRef
    }, canvasProps), {
      scale,
      onMouseDown: handleMouseDown,
      onContextMenu: resetState,
      onMouseDownCapture: handleMouseDownCapture,
      onMouseUpCapture
    }),
    selectBox,
    children
  );
};
var AbsoluteCanvas_default = (0, react_exports.forwardRef)((props, ref) => {
  return /* @__PURE__ */ react_default.createElement(AbsoluteCanvas, __spreadValues({ canvasRef: ref }, props));
});

// src/components/AbsoluteItem.jsx
var AbsoluteDiv = styled_components_default.div.attrs(({ x, y, w, h }) => ({
  style: {
    width: w,
    height: h,
    top: `${y}px`,
    left: `${x}px`
  }
}))`
    display: block;
    position: absolute;
    background: transparent;
`;
var AbsoluteItem = ({
  itemId,
  type = "block",
  x,
  y,
  w,
  h,
  renderLayoutItem
}) => /* @__PURE__ */ react_default.createElement(
  AbsoluteDiv,
  {
    x,
    y,
    w,
    h,
    "data-test": "absolute-item",
    "data-x": x,
    "data-y": y,
    "data-w": w,
    "data-h": h
  },
  renderLayoutItem(
    itemId,
    {
      width: w,
      height: h
    },
    type
  )
);
AbsoluteItem.propTypes = {
  itemId: prop_types_default.string.isRequired,
  type: prop_types_default.string,
  x: prop_types_default.number.isRequired,
  y: prop_types_default.number.isRequired,
  w: prop_types_default.number.isRequired,
  h: prop_types_default.number.isRequired,
  renderLayoutItem: prop_types_default.func.isRequired
};

// src/components/ActionMenuPortal.ts
var ActionMenuPortal = styled_components_default.div.attrs((props) => ({
  "data-test": "action-menu-portal",
  style: {
    width: props.w,
    top: props.y + props.h,
    left: props.x
  }
}))`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: all;
    box-sizing: border-box;
    height: 0px;
    z-index: ${(props) => props.zIndex};
`;
var ActionMenuPortal_default = ActionMenuPortal;

// src/components/Edge.tsx
var EdgeWrapper = styled_components_default.div.attrs(
  ({ x, y, w, h }) => {
    return {
      style: {
        width: w,
        height: h,
        transform: `translate(${x}px, ${y}px)`
      }
    };
  }
)`
    display: block;
    position: absolute;
    background: transparent;
    box-sizing: border-box;

    &:hover {
        cursor: ${(props) => props.orientation === "vertical" ? "col-resize" : "row-resize"};
        background: ${(0, themes_exports.pickVariant)("appearance", {
  invalid: dashboard_ui_exports.customThemeVariables.invalidDropTargetBackgroundColor,
  dropTarget: dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor,
  normal: "transparent",
  hidden: "transparent"
})};
        border: ${(0, themes_exports.pickVariant)("appearance", {
  invalid: `1px solid ${dashboard_ui_exports.customThemeVariables.invalidDropTargetBorderColor}`,
  dropTarget: `1px solid ${dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor}`,
  normal: "none",
  hidden: "none"
})};
        transition: background 0.2s ease-out;
    }
`;
var EdgeComponent = styled_components_default.div.attrs(
  ({ x, y, w, h }) => {
    return {
      style: {
        width: w,
        height: h,
        transform: `translate(${x}px, ${y}px)`
      }
    };
  }
)`
    display: block;
    position: absolute;
    opacity: 0.35;
    pointer-events: none;
    background-color: ${(props) => props.appearance === "dropTarget" ? dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor : (0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    ${EdgeWrapper}:hover + & {
        opacity: 0.7;
    }
`;

// src/components/ErrorMessageOverlay.tsx
var ErrorOverlay = styled_components_default.div`
    position: absolute;
    box-sizing: border-box;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    pointer-events: none;
    background-color: ${(0, themes_exports.pick)({
  light: "#a81916cc",
  dark: "#a81916b3"
})};
    color: white;
    overflow: hidden;
    padding: 8px;
    z-index: 2;
`;
var MessageContainer = styled_components_default.div`
    padding-top: 8px;
`;
var OverlayTitle = styled_components_default.div`
    font-weight: bold;
`;
var ErrorMessageOverlay = ({ messages }) => {
  if (!Array.isArray(messages) || messages.length === 0) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(ErrorOverlay, { "data-test": "error-overlay" }, /* @__PURE__ */ react_default.createElement(OverlayTitle, null, (0, i18n_exports._)("Layout Errors:")), messages.map((message) => /* @__PURE__ */ react_default.createElement(
    MessageContainer,
    {
      "data-test": "error-overlay-message",
      key: message
    },
    message
  )));
};

// src/components/GridCanvas.tsx
var defaultState2 = {
  startPosition: null,
  isMoving: false
};
var DEFAULT_SELECTED_LAYOUT_ITEMS2 = [];
var noop3 = () => void 0;
var GridCanvas = (props) => {
  const _a = props, {
    movable = false,
    selectable = false,
    selectedLayoutItems = DEFAULT_SELECTED_LAYOUT_ITEMS2,
    panelPadding = 0,
    scale = 1,
    onItemMove = noop3,
    onItemMoved = noop3,
    onItemSelected,
    children,
    canvasRef,
    blockItems
  } = _a, canvasProps = __objRest(_a, [
    "movable",
    "selectable",
    "selectedLayoutItems",
    "panelPadding",
    "scale",
    "onItemMove",
    "onItemMoved",
    "onItemSelected",
    "children",
    "canvasRef",
    "blockItems"
  ]);
  const { enableGridLayoutCssScaling } = (0, dashboard_context_exports.useFeatureFlags)();
  const [startPosition, setStartPosition] = (0, react_exports.useState)(
    defaultState2.startPosition
  );
  const [isMoving, setIsMoving] = (0, react_exports.useState)(defaultState2.isMoving);
  const { isMouseDownOnItemWithHandle, setIsMouseDownOnItemWithHandle } = (0, dashboard_context_exports.useMouseEventsContext)();
  const resetState = (0, react_exports.useCallback)(() => {
    setIsMoving(defaultState2.isMoving);
    setStartPosition(defaultState2.startPosition);
  }, []);
  const mouseScale = enableGridLayoutCssScaling ? scale : 1;
  const handleItemSelected = (0, react_exports.useCallback)(
    (e, itemIds = []) => {
      if (itemIds.some(
        ({ id, type }) => {
          var _a2;
          return type === "input" && ((_a2 = findStatusIcon({ canvasRef, id })) == null ? void 0 : _a2.contains(
            e.target
          ));
        }
      )) {
        return;
      }
      if (e.metaKey) {
        const selectedItems = selectedLayoutItems.filter(
          ({ type }) => type === "block"
        );
        onItemSelected(e, (0, lodash_exports.uniqBy)([...selectedItems, ...itemIds], "id"));
      } else {
        onItemSelected(e, itemIds);
      }
    },
    [canvasRef, selectedLayoutItems, onItemSelected]
  );
  const handleMouseDownOnItem = (0, react_exports.useCallback)(
    (event, blockItem) => {
      const { id, type = "block" } = blockItem;
      if (!selectedLayoutItems.find(
        ({ id: selectedId }) => selectedId === id
      )) {
        handleItemSelected(event, [{ id, type }]);
      }
    },
    [handleItemSelected, selectedLayoutItems]
  );
  const handleMouseDown = (0, react_exports.useCallback)(
    (e) => {
      if (isMouseDownOnItemWithHandle == null ? void 0 : isMouseDownOnItemWithHandle.current) {
        setIsMouseDownOnItemWithHandle(false);
        return;
      }
      const pos = computeRelativePosition(e, canvasRef, mouseScale);
      const block = findTopBlockItemByPosition(
        blockItems,
        pos,
        panelPadding
      );
      if (selectable) {
        setStartPosition(pos);
      }
      if (block) {
        handleMouseDownOnItem(e, {
          id: block.item,
          type: block.type
        });
        if (movable) {
          setIsMoving(true);
        }
      }
    },
    [
      isMouseDownOnItemWithHandle,
      canvasRef,
      mouseScale,
      blockItems,
      panelPadding,
      selectable,
      setIsMouseDownOnItemWithHandle,
      handleMouseDownOnItem,
      movable
    ]
  );
  const handleMouseMove = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (startPosition) {
      const currentPosition = computeRelativePosition(
        e,
        canvasRef,
        mouseScale
      );
      if (currentPosition) {
        const offset = getOffset(currentPosition, startPosition);
        if (isMoving && considerMoved(offset)) {
          e.preventDefault();
          onItemMove(e, { currentPosition });
        }
      }
    }
  });
  const handleMouseUp = (0, dashboard_ui_exports.useEventCallback)((e) => {
    if (startPosition) {
      const currentPosition = computeRelativePosition(
        e,
        canvasRef,
        mouseScale
      );
      if (currentPosition) {
        const offset = getOffset(currentPosition, startPosition);
        if (isMoving && considerMoved(offset)) {
          onItemMoved(e, offset);
        } else {
          let blocks = blockItems;
          if (panelPadding) {
            blocks = blocks.map(
              (block) => applyVizPadding({
                item: block,
                padding: panelPadding
              })
            );
          }
          const boundary = positionsToBoundary(
            startPosition,
            currentPosition
          );
          const selectedBlocks = filterBlockItemsByBoundary(
            blocks,
            boundary
          ).map(({ item, type = "block" }) => ({
            id: item,
            type
          }));
          const topItem = selectedBlocks[selectedBlocks.length - 1];
          handleItemSelected(e, topItem ? [topItem] : []);
        }
        resetState();
      }
    }
  });
  useMouseDownWithHandleEventListeners({
    handleMouseDownOnItem,
    canvasRef,
    scale: mouseScale,
    setStartPosition,
    movable,
    setIsMoving
  });
  (0, react_exports.useEffect)(() => {
    document.addEventListener("mouseup", handleMouseUp);
    return () => {
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [handleMouseUp]);
  (0, dashboard_ui_exports.useMouseMoveHandler)({ onMouseMove: handleMouseMove, isEnabled: movable });
  return /* @__PURE__ */ react_default.createElement(
    Canvas_default,
    __spreadProps(__spreadValues({
      ref: canvasRef
    }, canvasProps), {
      scale,
      onMouseDown: handleMouseDown,
      onContextMenu: resetState,
      cssScaling: enableGridLayoutCssScaling,
      showGrid: false
    }),
    children
  );
};
var GridCanvas_default = (0, react_exports.forwardRef)(
  (props, ref) => /* @__PURE__ */ react_default.createElement(GridCanvas, __spreadValues({ canvasRef: ref }, props))
);

// src/components/GridItem.tsx
var GridDiv = styled_components_default.div`
    height: 100%;
    width: 100%;
    grid-row: ${(props) => props.id}-start / ${(props) => props.id}-end;
    grid-column: ${(props) => props.id}-start / ${(props) => props.id}-end;
    background: transparent;
`;
var GridItem = ({
  itemId,
  type = "block",
  renderLayoutItem
}) => /* @__PURE__ */ react_default.createElement(GridDiv, { id: itemId, "data-test": "grid-item" }, renderLayoutItem(itemId, { width: "100%", height: "100%" }, type));
GridItem.propTypes = {
  itemId: prop_types_default.string.isRequired,
  type: prop_types_default.string,
  renderLayoutItem: prop_types_default.func.isRequired
};

// src/components/ItemDragPlaceholder.tsx
var Placeholder = styled_components_default.div.attrs(
  ({ position }) => ({
    style: positionToStyle(position)
  })
)`
    background-color: ${(0, themes_exports.pick)({
  enterprise: {
    light: themes_exports.variables.backgroundColorHover,
    dark: themes_exports.variables.neutral300
  },
  prisma: themes_exports.variables.interactiveColorOverlayDrag
})};
    opacity: 0.75;
    user-select: none;
    position: absolute;
    flex-direction: column;
    top: 0;
    left: 0;
    cursor: move;
`;

// src/components/ItemDropTarget.jsx
var DropTarget = styled_components_default.div.attrs(({ position }) => ({
  style: positionToStyle(position)
}))`
    background-color: ${(0, themes_exports.pickVariant)("validDropTarget", {
  true: dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor,
  false: dashboard_ui_exports.customThemeVariables.invalidDropTargetBackgroundColor
})};
    border-width: '1px';
    border-style: 'solid';
    border-color: ${(0, themes_exports.pickVariant)("validDropTarget", {
  true: dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor,
  false: dashboard_ui_exports.customThemeVariables.invalidDropTargetBorderColor
})};
    user-select: none;
    position: absolute;
    pointer-events: none;
`;
var ItemDropTarget = ({ position, direction }) => {
  const validDropTarget = (direction === "e" || direction === "w") && position.w >= 128 || (direction === "n" || direction === "s") && position.h >= 128;
  const dropTargetPosition = (0, react_exports.useMemo)(() => {
    let updatedPosition = null;
    switch (direction) {
      case "n":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          h: ITEM_DROP_TARGET_PX
        });
        break;
      case "s":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          y: position.y + position.h - ITEM_DROP_TARGET_PX,
          h: ITEM_DROP_TARGET_PX
        });
        break;
      case "w":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          w: ITEM_DROP_TARGET_PX
        });
        break;
      case "e":
        updatedPosition = __spreadProps(__spreadValues({}, position), {
          x: position.x + position.w - ITEM_DROP_TARGET_PX,
          w: ITEM_DROP_TARGET_PX
        });
        break;
      default:
        updatedPosition = position;
        break;
    }
    return updatedPosition;
  }, [position, direction]);
  if (validDropTarget) {
    return null;
  }
  return /* @__PURE__ */ react_default.createElement(
    DropTarget,
    {
      "data-test": "item-drop-target",
      position: dropTargetPosition,
      validDropTarget
    }
  );
};
ItemDropTarget.propTypes = {
  position: prop_types_default.shape({
    x: prop_types_default.number.isRequired,
    y: prop_types_default.number.isRequired,
    w: prop_types_default.number.isRequired,
    h: prop_types_default.number.isRequired
  }).isRequired,
  direction: prop_types_default.oneOf(["n", "s", "w", "e"]).isRequired
};

// src/components/Layer.tsx
var Layer = styled_components_default.div`
    position: absolute;
    top: 0px;
    left: 0px;
    right: 0px;
    bottom: 0px;
    pointer-events: none;
    z-index: ${(props) => props.zIndex};
`;
var Layer_default = Layer;

// esm-externals:@splunk/react-icons/enterprise/Plus
var Plus_exports = {};
__export(Plus_exports, {
  default: () => Plus_default
});
var defaultImport15 = __toESM(require("@splunk/react-icons/enterprise/Plus"));
__reExport(Plus_exports, require("@splunk/react-icons/enterprise/Plus"));
var Plus_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// src/utils/outlineUtils.ts
var getVerticalPosition = (dir, offset) => {
  if (dir[0] === "n") {
    return `top: -${offset}px`;
  }
  if (dir[0] === "s") {
    return `bottom: -${offset}px`;
  }
  return `top: calc(50% - ${offset}px)`;
};
var getHorizontalPosition = (dir, offset) => {
  if (dir.slice(-1) === "w") {
    return `left: -${offset}px`;
  }
  if (dir.slice(-1) === "e") {
    return `right: -${offset}px`;
  }
  return `left: calc(50% - ${offset}px)`;
};

// src/components/Port.tsx
var portOffset = 8;
var PORT_DIRECTIONS = ["n", "e", "s", "w"];
var PortContainer = styled_components_default.div.attrs(({ port }) => ({
  "data-test": "port",
  "data-test-port": port
}))`
    text-align: center;
    width: 16px;
    height: 16px;
    line-height: 16px;
    box-sizing: border-box;
    border-radius: 50%;
    position: absolute;
    color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    ${({ port }) => getVerticalPosition(port, portOffset)};
    ${({ port }) => getHorizontalPosition(port, portOffset)};
    z-index: 999;
    pointer-events: auto;
    user-select: none;
    &:hover {
        background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    }
`;
var Port = ({
  port,
  onMouseEnter,
  onMouseLeave
}) => /* @__PURE__ */ react_default.createElement(
  PortContainer,
  {
    port,
    onMouseEnter,
    onMouseLeave
  },
  /* @__PURE__ */ react_default.createElement(Plus_default, null)
);

// src/components/PreviewPlaceholderItem.jsx
var PlaceholderComponent = styled_components_default.div.attrs(({ position }) => ({
  style: {
    width: position.w,
    height: position.h,
    transform: `translate(${position.x}px, ${position.y}px)`
  }
}))`
    display: block;
    position: absolute;
    pointer-events: none;
    box-sizing: border-box;
    border: 1px solid ${dashboard_ui_exports.customThemeVariables.validDropTargetBorderColor};
    background-color: ${dashboard_ui_exports.customThemeVariables.validDropTargetBackgroundColor};
`;
var PreviewPlaceholderItem = ({ position }) => {
  return /* @__PURE__ */ react_default.createElement(
    PlaceholderComponent,
    {
      position,
      "data-test": "preview-placeholder",
      "data-test-preview-position": `${position.x},${position.y}-${position.w},${position.h}`
    }
  );
};
PreviewPlaceholderItem.propTypes = {
  position: prop_types_default.shape({
    x: prop_types_default.number.isRequired,
    y: prop_types_default.number.isRequired,
    w: prop_types_default.number.isRequired,
    h: prop_types_default.number.isRequired
  }).isRequired
};

// esm-externals:@splunk/ui-utils/format
var format_exports = {};
__export(format_exports, {
  default: () => format_default
});
var defaultImport16 = __toESM(require("@splunk/ui-utils/format"));
__reExport(format_exports, require("@splunk/ui-utils/format"));
var format_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// src/components/ResizeHandle.tsx
var resizeHandleOffset = 7;
var computeCursor = (dir) => {
  switch (dir) {
    case "n":
    case "s":
      return "ns-resize";
    case "e":
    case "w":
      return "ew-resize";
    case "ne":
    case "sw":
      return "nesw-resize";
    case "se":
    case "nw":
    default:
      return "nwse-resize";
  }
};
var computeDirection = (dir) => {
  switch (dir) {
    case "n":
      return (0, i18n_exports._)("North");
    case "s":
      return (0, i18n_exports._)("South");
    case "e":
      return (0, i18n_exports._)("East");
    case "w":
      return (0, i18n_exports._)("West");
    case "ne":
      return (0, i18n_exports._)("North-East");
    case "sw":
      return (0, i18n_exports._)("South-West");
    case "se":
      return (0, i18n_exports._)("South-East");
    case "nw":
      return (0, i18n_exports._)("North-West");
    default:
      return "";
  }
};
var Handle = styled_components_default.button.attrs(({ direction }) => ({
  "data-test": "handle",
  "data-test-direction": direction
}))`
    width: 10px;
    height: 10px;
    background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    border: none;
    border-radius: 20%;
    padding: 0;
    position: absolute;
    ${({ direction }) => getVerticalPosition(direction, resizeHandleOffset)};
    ${({ direction }) => getHorizontalPosition(direction, resizeHandleOffset)};
    cursor: ${({ direction }) => computeCursor(direction)};
    z-index: 999;
    pointer-events: auto;
    user-select: none;
`;
var ResizeHandle = ({
  onMouseDown,
  onKeyDown,
  direction
}) => {
  const handleMouseDown = (0, react_exports.useCallback)(
    (e) => {
      onMouseDown(e, direction);
    },
    [onMouseDown, direction]
  );
  const handleKeyDown = (0, react_exports.useCallback)(
    (e) => {
      onKeyDown(e, direction);
    },
    [onKeyDown, direction]
  );
  return /* @__PURE__ */ react_default.createElement(
    Handle,
    {
      "aria-label": (0, format_exports.sprintf)((0, i18n_exports._)("Move %(direction)s direction"), {
        direction: computeDirection(direction)
      }),
      direction,
      onMouseDown: handleMouseDown,
      onKeyDown: handleKeyDown
    }
  );
};

// src/components/ResponsiveBox.tsx
var ResponsiveBox = styled_components_default.div.attrs(
  ({ itemId, x, y, w, h, "data-test": dataTest, zIndex }) => {
    const attributes = {
      "data-test": dataTest != null ? dataTest : "responsive-box",
      "data-id": itemId,
      "data-test-viz-item-position": `${x},${y},${w},${h}`,
      style: {
        width: `${w}px`,
        height: `${h}px`,
        top: `${y}px`,
        left: `${x}px`,
        zIndex
      }
    };
    if (!zIndex) {
      delete attributes.style.zIndex;
    }
    return attributes;
  }
)`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: none;
    box-sizing: border-box;
    visibility: ${(props) => {
  return props.appearance === "hidden" ? "hidden" : "visible";
}};
    opacity: ${(props) => props.appearance === "highlighted" ? 1 : 0.5};
`;
ResponsiveBox.defaultProps = {
  appearance: "highlighted"
};
var ResponsiveBox_default = ResponsiveBox;

// src/components/DragHandlePortal.tsx
var DragHandlePortal = styled_components_default.div.attrs(
  (props) => ({
    "data-test": "drag-handle-portal",
    style: {
      width: props.w,
      top: props.y,
      left: props.x
    }
  })
)`
    display: block;
    position: absolute;
    background: transparent;
    pointer-events: all;
    box-sizing: border-box;
    height: 0px;
    z-index: ${(props) => props.zIndex};
    visibility: ${({ isHidden }) => isHidden ? "hidden" : "visible"};
`;

// src/components/ResponsiveBlockItem.tsx
var defaultPortalState = Object.freeze({
  current: null
});
var ResponsiveBlockItem = ({
  x: originalX,
  y: originalY,
  w: originalW,
  h: originalH,
  canvasHeight,
  padding,
  itemId,
  type = "block",
  errorMessages,
  onItemSelected,
  renderLayoutItem,
  appearance = "highlighted",
  isMouseDownEventRef
}) => {
  var _a;
  const selectIsSelected = (0, react_exports.useMemo)(dashboard_state_exports.makeSelectIsSelected, []);
  const mode = (0, dashboard_state_exports.useSelector)(dashboard_state_exports.selectMode);
  const isSelected = (0, dashboard_state_exports.useSelector)((state) => selectIsSelected(state, itemId));
  const [isClicked, setIsClicked] = (0, react_exports.useState)(false);
  const [actionMenuPortal, setActionMenuPortal] = (0, react_exports.useState)(defaultPortalState);
  const [dragHandlePortal, setDragHandlePortal] = (0, react_exports.useState)(defaultPortalState);
  const layerData = (0, dashboard_context_exports.useLayoutLayers)();
  const {
    layer: itemLayer,
    actionMenu: actionMenuLayer,
    dragHandle: dragHandleLayer
  } = (_a = layerData == null ? void 0 : layerData[itemId]) != null ? _a : {};
  const renderActionMenuInPortal = typeof itemLayer === "number";
  const {
    position: { x, y, w, h }
  } = applyVizPadding({
    item: {
      position: {
        x: originalX,
        y: originalY,
        w: originalW,
        h: originalH
      }
    },
    padding
  });
  const layoutItem = (0, react_exports.useMemo)(
    () => renderLayoutItem(
      itemId,
      {
        width: w,
        height: h,
        y,
        canvasHeight,
        renderActionMenuInPortal,
        actionMenuPortal,
        dragHandlePortal
      },
      type,
      onItemSelected
    ),
    [
      renderLayoutItem,
      itemId,
      type,
      w,
      h,
      y,
      canvasHeight,
      onItemSelected,
      renderActionMenuInPortal,
      actionMenuPortal,
      dragHandlePortal
    ]
  );
  const handleFocus = (0, react_exports.useCallback)(
    (event) => {
      if (isMouseDownEventRef == null ? void 0 : isMouseDownEventRef.current) {
        setIsClicked(true);
        return;
      }
      if (!event.relatedTarget) {
        return;
      }
      setIsClicked(false);
      if (
        // The tabindex was moved to the SelectableContainer (in renderLayoutItem), so we'll check that thats the target
        event.target.getAttribute("data-test") === "select-outline" && event.target.getAttribute("data-id") === itemId
      ) {
        onItemSelected(event, [{ id: itemId, type }]);
      }
    },
    [isMouseDownEventRef, itemId, onItemSelected, type]
  );
  const trackActionMenuPortal = (0, react_exports.useCallback)((element) => {
    setActionMenuPortal({ current: element });
  }, []);
  const trackDragHandlePortal = (0, react_exports.useCallback)((element) => {
    setDragHandlePortal({ current: element });
  }, []);
  const isHidden = appearance === "hidden";
  return /* @__PURE__ */ react_default.createElement(
    dashboard_ui_exports.AbsoluteItemContainer,
    {
      "data-id": itemId,
      "data-selected": `${isSelected}`,
      "data-click-focus": `${isClicked && isSelected && mode === "view"}`
    },
    /* @__PURE__ */ react_default.createElement(
      ResponsiveBox_default,
      {
        "data-test": "absolute-item",
        itemId,
        appearance,
        x,
        y,
        w,
        h,
        onFocusCapture: handleFocus
      },
      layoutItem,
      /* @__PURE__ */ react_default.createElement(ErrorMessageOverlay, { messages: errorMessages })
    ),
    renderActionMenuInPortal && /* @__PURE__ */ react_default.createElement(
      ActionMenuPortal_default,
      {
        x,
        y,
        w,
        h,
        ref: trackActionMenuPortal,
        zIndex: actionMenuLayer
      }
    ),
    /* @__PURE__ */ react_default.createElement(
      DragHandlePortal,
      {
        x,
        y,
        w,
        ref: trackDragHandlePortal,
        zIndex: dragHandleLayer,
        isHidden
      }
    )
  );
};
var ResponsiveBlockItem_default = react_default.memo(ResponsiveBlockItem);

// src/components/ResponsiveBlockOutline.tsx
var keyDirectionMap = {
  ArrowUp: ["n", "ne", "se", "s", "sw", "nw"],
  ArrowDown: ["n", "ne", "se", "s", "sw", "nw"],
  ArrowLeft: ["ne", "e", "se", "sw", "w", "nw"],
  ArrowRight: ["ne", "e", "se", "sw", "w", "nw"]
};
var isKeyAllowedCheck = (key) => Object.keys(keyDirectionMap).includes(key);
var noop4 = () => void 0;
var ResponsiveBlockOutline = ({
  itemId,
  scale = 1,
  connectable = false,
  resizable = false,
  onResize = noop4,
  onResized = noop4,
  onLineConnect = noop4,
  onLineDisconnect = noop4,
  handleDirections,
  x,
  y,
  w,
  h
}) => {
  const startPosition = (0, react_exports.useRef)(
    null
  );
  const resizing = (0, react_exports.useRef)(false);
  const resizeDir = (0, react_exports.useRef)(null);
  const keyUpOffset = (0, react_exports.useRef)({ offsetX: 0, offsetY: 0 });
  const handleResizeMouseDown = (0, react_exports.useCallback)(
    (e, dir) => {
      e.preventDefault();
      e.stopPropagation();
      startPosition.current = getClientPosition(e, scale);
      resizing.current = true;
      resizeDir.current = dir;
    },
    [scale]
  );
  const handleMouseMove = (0, react_exports.useCallback)(
    (e) => {
      if (startPosition.current && resizing.current && resizeDir.current) {
        e.preventDefault();
        const currentPosition = getClientPosition(e, scale);
        const offset = getOffset(
          currentPosition,
          startPosition.current
        );
        onResize(e, itemId, offset, resizeDir.current);
      }
    },
    [scale, onResize, itemId]
  );
  const handleMouseUp = (0, react_exports.useCallback)(
    (e) => {
      if (startPosition.current && resizing.current && resizeDir.current) {
        e.preventDefault();
        const currentPosition = getClientPosition(e, scale);
        const offset = getOffset(
          currentPosition,
          startPosition.current
        );
        startPosition.current = null;
        resizing.current = false;
        onResized(e, itemId, offset, resizeDir.current);
        resizeDir.current = null;
      }
    },
    [itemId, scale, onResized]
  );
  const handleResizeKeyDown = (0, react_exports.useCallback)(
    (e, dir) => {
      const { key } = e;
      const isKeyAllowed = isKeyAllowedCheck(key);
      const isDirectionAllowed = isKeyAllowed && keyDirectionMap[key].includes(dir);
      if (!isDirectionAllowed) {
        return;
      }
      e.preventDefault();
      e.stopPropagation();
      resizeDir.current = dir;
      if (e.key === "ArrowUp") {
        keyUpOffset.current.offsetY -= GRID_SIZE;
      }
      if (e.key === "ArrowDown") {
        keyUpOffset.current.offsetY += GRID_SIZE;
      }
      if (e.key === "ArrowLeft") {
        keyUpOffset.current.offsetX -= GRID_SIZE;
      }
      if (e.key === "ArrowRight") {
        keyUpOffset.current.offsetX += GRID_SIZE;
      }
      onResize(e, itemId, keyUpOffset.current, dir);
    },
    [itemId, onResize]
  );
  const handleKeyUp = (0, react_exports.useCallback)(
    (e) => {
      if (keyUpOffset.current && resizeDir.current) {
        onResized(e, itemId, keyUpOffset.current, resizeDir.current);
        resizeDir.current = null;
        keyUpOffset.current = { offsetX: 0, offsetY: 0 };
      }
    },
    [itemId, onResized]
  );
  const handlePortEnter = (0, react_exports.useCallback)(
    (port) => (e) => {
      e.preventDefault();
      onLineConnect(itemId, port);
    },
    [itemId, onLineConnect]
  );
  const handlePortLeave = (0, react_exports.useCallback)(
    (port) => (e) => {
      e.preventDefault();
      onLineDisconnect(itemId, port);
    },
    [itemId, onLineDisconnect]
  );
  (0, react_exports.useLayoutEffect)(() => {
    if (resizable) {
      document.addEventListener("mousemove", handleMouseMove);
    }
    return () => {
      document.removeEventListener("mousemove", handleMouseMove);
    };
  }, [resizable, handleMouseMove]);
  (0, react_exports.useLayoutEffect)(() => {
    if (resizable) {
      document.addEventListener("mouseup", handleMouseUp);
    }
    return () => {
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [resizable, handleMouseUp]);
  (0, react_exports.useLayoutEffect)(() => {
    if (resizable) {
      document.addEventListener("keyup", handleKeyUp);
    }
    return () => {
      document.removeEventListener("keyup", handleKeyUp);
    };
  }, [resizable, handleKeyUp]);
  const ResizeHandles = (0, react_exports.useMemo)(() => {
    if (!resizable) {
      return null;
    }
    return handleDirections.map((dir) => /* @__PURE__ */ react_default.createElement(
      ResizeHandle,
      {
        key: `handle-${dir}`,
        onMouseDown: handleResizeMouseDown,
        onKeyDown: handleResizeKeyDown,
        direction: dir
      }
    ));
  }, [
    resizable,
    handleDirections,
    handleResizeMouseDown,
    handleResizeKeyDown
  ]);
  const Ports = (0, react_exports.useMemo)(() => {
    if (!connectable) {
      return null;
    }
    return PORT_DIRECTIONS.map((port) => /* @__PURE__ */ react_default.createElement(
      Port,
      {
        key: `port-${port}`,
        port,
        onMouseEnter: handlePortEnter(port),
        onMouseLeave: handlePortLeave(port)
      }
    ));
  }, [connectable, handlePortEnter, handlePortLeave]);
  return /* @__PURE__ */ react_default.createElement(ResponsiveBox_default, { itemId, x, y, w, h }, ResizeHandles, Ports);
};
var ResponsiveBlockOutline_default = ResponsiveBlockOutline;

// src/components/ResponsiveLine.tsx
var allowedKeys = ["ArrowDown", "ArrowUp", "ArrowLeft", "ArrowRight"];
var LineBox = styled_components_default.div`
    position: absolute;
    pointer-events: none;
    z-index: ${(props) => props.zIndex};
`;
var AdjustHandle = styled_components_default.button.attrs(({ x, y }) => ({
  style: {
    transform: `translate(${x}px, ${y}px)`
  }
}))`
    width: 10px;
    height: 10px;
    left: -5px;
    top: -5px;
    background-color: ${(0, themes_exports.pick)({
  enterprise: themes_exports.variables.accentColorL10,
  prisma: themes_exports.variables.interactiveColorPrimary
})};
    border: none;
    padding: 0;
    border-radius: 50%;
    position: absolute;
    z-index: 999;
    pointer-events: auto;
    cursor: move;
    user-select: none;
`;
var ResponsiveLine = ({
  fromX,
  fromY,
  fromItem,
  fromPort,
  toX,
  toY,
  toItem,
  toPort,
  lineId,
  scale = 1,
  selectable = false,
  editable = false,
  renderLayoutItem,
  onItemSelected = dashboard_utils_exports.noop,
  onLineDragStart = dashboard_utils_exports.noop,
  onLineMove = dashboard_utils_exports.noop,
  onLineMoved = dashboard_utils_exports.noop,
  onLineDrag = dashboard_utils_exports.noop,
  onLineDragged = dashboard_utils_exports.noop
}) => {
  const [startPosition, setStartPosition] = (0, react_exports.useState)(null);
  const [action, setAction] = (0, react_exports.useState)(null);
  const keyUpOffset = (0, react_exports.useRef)({ offsetX: 0, offsetY: 0 });
  const layerData = (0, dashboard_context_exports.useLayoutLayers)();
  const lineLayer = (0, react_exports.useMemo)(() => {
    const selectionLayer = Object.values(layerData != null ? layerData : {}).map((entry) => entry.selection).filter(Boolean)[0];
    return typeof selectionLayer === "number" ? selectionLayer + 1 : void 0;
  }, [layerData]);
  const handleLineSelected = (0, react_exports.useCallback)(
    (e) => {
      e.stopPropagation();
      setStartPosition(getClientPosition(e, scale));
      setAction("move");
      onItemSelected(e, [{ id: lineId, type: "line" }]);
    },
    [lineId, onItemSelected, scale]
  );
  const handleLineSelectedOnEnter = (0, react_exports.useCallback)(
    (e) => {
      if (e.key === "Enter") {
        onItemSelected(e, [{ id: lineId, type: "line" }]);
      }
    },
    [lineId, onItemSelected]
  );
  const handleKeyDown = (0, react_exports.useCallback)(
    (e) => {
      e.preventDefault();
      if (e.key === "ArrowUp") {
        keyUpOffset.current.offsetY -= 1;
      }
      if (e.key === "ArrowDown") {
        keyUpOffset.current.offsetY += 1;
      }
      if (e.key === "ArrowLeft") {
        keyUpOffset.current.offsetX -= 1;
      }
      if (e.key === "ArrowRight") {
        keyUpOffset.current.offsetX += 1;
      }
      onLineDrag(e, keyUpOffset.current);
    },
    [onLineDrag]
  );
  const handleKeyDownFrom = (0, react_exports.useCallback)(
    (e) => {
      if (!allowedKeys.includes(e.key)) {
        return;
      }
      if (keyUpOffset.current.offsetX === 0 && keyUpOffset.current.offsetY === 0) {
        onLineDragStart(e, "from");
      }
      handleKeyDown(e);
    },
    [onLineDragStart, handleKeyDown]
  );
  const handleKeyDownTo = (0, react_exports.useCallback)(
    (e) => {
      if (!allowedKeys.includes(e.key)) {
        return;
      }
      if (keyUpOffset.current.offsetX === 0 && keyUpOffset.current.offsetY === 0) {
        onLineDragStart(e, "to");
      }
      handleKeyDown(e);
    },
    [onLineDragStart, handleKeyDown]
  );
  const handleKeyUp = (0, react_exports.useCallback)(
    (e) => {
      var _a, _b, _c;
      const isLineHandleFocused = ((_a = document.activeElement) == null ? void 0 : _a.tagName) === "BUTTON" && ((_c = (_b = document.activeElement) == null ? void 0 : _b.getAttribute("data-test")) == null ? void 0 : _c.startsWith("line-handle"));
      if (!allowedKeys.includes(e.key) || keyUpOffset.current.offsetX === 0 && keyUpOffset.current.offsetY === 0 || !isLineHandleFocused) {
        return;
      }
      onLineDragged(e, keyUpOffset.current);
      keyUpOffset.current = { offsetX: 0, offsetY: 0 };
    },
    [onLineDragged]
  );
  const handleMouseDownFrom = (0, react_exports.useCallback)(
    (e) => {
      e.stopPropagation();
      setStartPosition(getClientPosition(e, scale));
      setAction("drag");
      onLineDragStart(e, "from");
    },
    [onLineDragStart, scale]
  );
  const handleMouseDownTo = (0, react_exports.useCallback)(
    (e) => {
      e.stopPropagation();
      setStartPosition(getClientPosition(e, scale));
      setAction("drag");
      onLineDragStart(e, "to");
    },
    [onLineDragStart, scale]
  );
  const handleMouseUp = (0, react_exports.useCallback)(
    (e) => {
      if (startPosition == null || action == null) {
        return;
      }
      setStartPosition(null);
      const currentPosition = getClientPosition(e, scale);
      const offset = getOffset(currentPosition, startPosition);
      if (!offset.offsetX && !offset.offsetY) {
        return;
      }
      switch (action) {
        case "drag":
          onLineDragged(e, offset);
          break;
        case "move":
          onLineMoved(e, offset);
          break;
        default:
          break;
      }
    },
    [action, onLineDragged, onLineMoved, scale, startPosition]
  );
  const handleMouseMove = (0, react_exports.useCallback)(
    (e) => {
      if (startPosition == null || action == null) {
        return;
      }
      if (e.buttons <= 0 || e.buttons % 2 === 0) {
        handleMouseUp(e);
        return;
      }
      e.preventDefault();
      const currentPosition = getClientPosition(e, scale);
      const offset = getOffset(currentPosition, startPosition);
      if (!offset.offsetX && !offset.offsetY) {
        return;
      }
      switch (action) {
        case "drag":
          onLineDrag(e, offset);
          break;
        case "move":
          onLineMove(e, offset);
          break;
        default:
          break;
      }
    },
    [action, handleMouseUp, onLineDrag, onLineMove, scale, startPosition]
  );
  const from = { x: fromX, y: fromY };
  const to = { x: toX, y: toY };
  const boxPos = computeLineBoxPosition(from, to);
  const relativePos = computeLineRelativePosition(from, to, boxPos);
  const lineBoxStyle = (0, react_exports.useMemo)(
    () => ({
      transform: `translate(${boxPos.x}px, ${boxPos.y}px)`
    }),
    [boxPos.x, boxPos.y]
  );
  const fromHandleElement = (0, react_exports.useMemo)(() => {
    if (!editable) {
      return null;
    }
    return /* @__PURE__ */ react_default.createElement(
      AdjustHandle,
      {
        "data-test": "line-handle-from",
        "data-test-item": fromItem,
        "data-test-port": fromPort,
        x: relativePos.from.x,
        y: relativePos.from.y,
        onMouseDown: handleMouseDownFrom,
        onKeyDown: handleKeyDownFrom,
        "aria-label": (0, i18n_exports._)("From line handle")
      }
    );
  }, [
    editable,
    fromItem,
    fromPort,
    relativePos.from.x,
    relativePos.from.y,
    handleMouseDownFrom,
    handleKeyDownFrom
  ]);
  const toHandleElement = (0, react_exports.useMemo)(() => {
    if (!editable) {
      return null;
    }
    return /* @__PURE__ */ react_default.createElement(
      AdjustHandle,
      {
        "data-test": "line-handle-to",
        "data-test-item": toItem,
        "data-test-port": toPort,
        x: relativePos.to.x,
        y: relativePos.to.y,
        onMouseDown: handleMouseDownTo,
        onKeyDown: handleKeyDownTo,
        "aria-label": (0, i18n_exports._)("To line handle")
      }
    );
  }, [
    editable,
    toItem,
    toPort,
    relativePos.to.x,
    relativePos.to.y,
    handleMouseDownTo,
    handleKeyDownTo
  ]);
  const lineElement = (0, react_exports.useMemo)(
    () => renderLayoutItem(
      lineId,
      {
        from: {
          x: relativePos.from.x,
          y: relativePos.from.y
        },
        to: {
          x: relativePos.to.x,
          y: relativePos.to.y
        },
        // todo: this is inconsistent with the ResponsiveBlockItem which accepts the `onSelect` callback as the 4th argument of `renderLayoutItem`.
        onLineSelect: selectable ? handleLineSelected : dashboard_utils_exports.noop
      },
      "line"
    ),
    [
      handleLineSelected,
      lineId,
      relativePos.from.x,
      relativePos.from.y,
      relativePos.to.x,
      relativePos.to.y,
      renderLayoutItem,
      selectable
    ]
  );
  (0, react_exports.useEffect)(() => {
    if (editable) {
      document.addEventListener("mousemove", handleMouseMove);
      document.addEventListener("mouseup", handleMouseUp);
    }
    return () => {
      document.removeEventListener("mousemove", handleMouseMove);
      document.removeEventListener("mouseup", handleMouseUp);
    };
  }, [editable, handleMouseMove, handleMouseUp]);
  (0, react_exports.useEffect)(() => {
    if (editable) {
      document.addEventListener("keyup", handleKeyUp);
    }
    return () => {
      document.removeEventListener("keyup", handleKeyUp);
    };
  }, [editable, handleKeyUp]);
  return /* @__PURE__ */ react_default.createElement(
    LineBox,
    {
      "data-test": "line-box",
      tabIndex: !editable ? 0 : void 0,
      onKeyDown: handleLineSelectedOnEnter,
      style: lineBoxStyle,
      "data-viz-type": "abslayout.line",
      "data-id": lineId,
      "data-test-line-position": `${from.x},${from.y}-${to.x},${to.y}`,
      zIndex: lineLayer
    },
    fromHandleElement,
    toHandleElement,
    lineElement
  );
};
var ResponsiveLine_default = ResponsiveLine;

// src/utils/absoluteLayoutUtils.ts
var initializeLayoutStructureState = (layoutStructure) => layoutStructure.reduce((obj, item) => {
  obj[item.item] = __spreadValues({}, item);
  return obj;
}, {});
var reducer = (state, action) => {
  switch (action.type) {
    case "lineMove":
      return __spreadProps(__spreadValues({}, state), {
        [action.payload.item]: action.payload
      });
    case "lineDragStart":
      return __spreadProps(__spreadValues({}, state), {
        [action.payload.item]: action.payload
      });
    case "lineDrag": {
      const lineToDrag = state[action.payload.id];
      return isLineConnected({
        line: lineToDrag,
        dir: action.payload.dir
      }) ? state : __spreadProps(__spreadValues({}, state), {
        [action.payload.id]: __spreadProps(__spreadValues({}, lineToDrag), {
          position: __spreadProps(__spreadValues({}, lineToDrag.position), {
            [action.payload.dir]: action.payload.absPos
          })
        })
      });
    }
    case "lineConnect": {
      const lineToConnect = state[action.payload.lineId];
      return isLineConnected({
        line: lineToConnect,
        dir: action.payload.lineDir
      }) ? state : __spreadProps(__spreadValues({}, state), {
        [action.payload.lineId]: connectLine({
          line: lineToConnect,
          dir: action.payload.lineDir,
          itemId: action.payload.itemId,
          port: action.payload.port
        })
      });
    }
    case "lineDisconnect": {
      const lineToDisconnect = state[action.payload.lineId];
      return isLineConnected({
        line: lineToDisconnect,
        dir: action.payload.lineDir
      }) ? __spreadProps(__spreadValues({}, state), {
        [action.payload.lineId]: disconnectLine({
          line: lineToDisconnect,
          dir: action.payload.lineDir,
          absPos: computeLineAbsPosition({
            layoutStructure: Object.values(state),
            position: lineToDisconnect.position
          })[action.payload.lineDir]
        })
      }) : state;
    }
    case "blockResize":
      return __spreadProps(__spreadValues({}, state), {
        [action.payload.item]: action.payload
      });
    case "blocksMove":
      return action.payload.reduce(
        (s, blockItem) => __spreadProps(__spreadValues({}, s), {
          [blockItem.item]: blockItem
        }),
        __spreadValues({}, state)
      );
    case "reset":
      return initializeLayoutStructureState(action.payload);
    default:
      return state;
  }
};
var updateLayoutStructureOnKeyboardMove = ({
  selectedLineItems,
  selectedBlockItems,
  layoutStructure,
  dir,
  snap,
  gridSize
}) => {
  const updatedLines = selectedLineItems.map(({ item }) => {
    const offset = createOffset(dir, 1, 1);
    return handleSingleLineMove({
      layoutStructure,
      lineId: item,
      offset
    });
  });
  const updatedBlocks = selectedBlockItems.map((blockItem) => {
    const { position } = blockItem;
    const snapOffset2 = snap ? snapOffsetToXY({
      position,
      offset: createOffset(dir, gridSize, gridSize),
      gridWidth: gridSize,
      gridHeight: gridSize,
      spacing: 0,
      padding: 0
    }) : createOffset(dir, 1, 1);
    return updateBlockItemPosition(blockItem, snapOffset2);
  });
  const updatedItems = [...updatedLines, ...updatedBlocks];
  const updatedLayoutStructure = layoutStructure.map(
    (item) => {
      var _a;
      return (_a = updatedItems.find((line) => line.item === item.item)) != null ? _a : item;
    }
  );
  return updatedLayoutStructure;
};

// src/absoluteLayoutOptionsSchema.ts
var absoluteLayoutOptionsSchema_default = {
  backgroundColor: {
    anyOf: [
      {
        pattern: dashboard_definition_exports.COLOR_PATTERN_WITH_RGBA_AND_TOKEN,
        type: "string",
        description: `Specify the color of the layout background color using using a hex code, rgb/rgba value, an HTML color name, or a token.

The default for light mode is "#F2F4f5". The default for dark mode is "#3C444D". The default for SCP mode is "#15161B"`
      },
      {
        type: "string",
        enum: dashboard_ui_exports.namedColors,
        description: `Specify the color of the layout background color using a valid web color such as 'blue'`
      }
    ]
  },
  display: {
    type: "string",
    default: "auto",
    enum: ["actual-size", "fit-to-width", "auto", "auto-scale"],
    description: `Specify the display behavior. Valid options are:


actual-size: The dashboard will not change size when the browser is resized.


fit-to-width: The dashboard will change in size as the browser is resized, always filling the available width of the browser.


auto: The dashboard will change in size as the browser is resized, to a maximum zoom of 100%.`
  },
  backgroundImage: {
    type: "object",
    properties: {
      w: {
        type: "number",
        description: `Specify the image's h (height) and w (width) in pixels. These options should not be specified if you set the sizeType option. If they are, they will overrule that setting.`
      },
      h: {
        type: "number",
        description: `Specify the image's h (height) and w (width) in pixels. These options should not be specified if you set the sizeType option. If they are, they will overrule that setting.`
      },
      x: {
        type: "number",
        description: "Specify, in pixels, the position of the background image on the x-axis and y-axis. These options should not be specified if you set the sizeType option. If they are, they will overrule that setting."
      },
      y: {
        type: "number",
        description: "Specify, in pixels, the position of the background image on the x-axis and y-axis. These options should not be specified if you set the sizeType option. If they are, they will overrule that setting."
      },
      src: {
        type: "string",
        description: "The url of background image."
      },
      opacity: {
        type: "number",
        minimum: 0,
        maximum: 1,
        description: "The opacity of the image."
      },
      sizeType: {
        type: "string",
        enum: ["auto", "contain", "cover"],
        default: "contain",
        description: `Specify one of the following:


auto: Scales the image while maintaining the image proportion.


contain: Increases the size of the of the image as much as possible without cropping or stretching it.


cover: Increases the size of the image without stretching it. The image may be cropped vertically and horizontally so that no empty space is shown.`
      }
    },
    description: `A background image must be one of the following types: jpg, jpeg, png, svg, or gif

Specify the location of a background image using the option src. For example: "src": "https://www.myImageLocation.com/galleryX/image1.png`,
    additionalProperties: false
  },
  width: {
    type: "number",
    default: dashboard_utils_exports.DEFAULT_CANVAS_WIDTH,
    description: "Canvas width in pixels."
  },
  height: {
    type: "number",
    default: dashboard_utils_exports.DEFAULT_CANVAS_HEIGHT,
    description: "Canvas height in pixels."
  }
};

// src/enhancers/withLayoutShowHide.tsx
var EmptyStructure = [];
var withLayoutShowHide = (Layout, { schema, reflowFn }) => {
  const EnhancedLayout = (props) => {
    var _a;
    const layoutStructure = useLayoutShowHide(
      (_a = props.layoutStructure) != null ? _a : EmptyStructure,
      reflowFn
    );
    return /* @__PURE__ */ react_default.createElement(
      Layout,
      __spreadProps(__spreadValues({}, props), {
        layoutStructure,
        rawLayoutStructure: props.layoutStructure
      })
    );
  };
  EnhancedLayout.schema = schema;
  return EnhancedLayout;
};

// src/AbsoluteLayout.tsx
var emptySelectedItems = [];
var emptyLayoutStructure = [];
var AbsoluteLayout = (props) => {
  const {
    mode = "view",
    showGrid = true,
    options: {
      width = absoluteLayoutOptions.width,
      height = absoluteLayoutOptions.height,
      display = absoluteLayoutOptions.display,
      backgroundColor,
      backgroundImage
    } = {},
    layoutStructure = emptyLayoutStructure,
    rawLayoutStructure = emptyLayoutStructure,
    containerWidth,
    containerHeight,
    selectedItems = emptySelectedItems,
    renderLayoutItem,
    onLayoutItemsSelect = dashboard_utils_exports.noop,
    onLayoutStructureChange = dashboard_utils_exports.noop,
    layoutApiRef = dashboard_utils_exports.noop
  } = props;
  const activeLine = (0, react_exports.useRef)(null);
  const [layoutStructureState, dispatch] = (0, react_exports.useReducer)(
    reducer,
    layoutStructure,
    initializeLayoutStructureState
  );
  const canvasRef = (0, react_exports.useRef)(null);
  const layoutApi = (0, react_exports.useRef)(null);
  const savedScroll = (0, react_exports.useRef)(null);
  const isMouseDownEventRef = (0, react_exports.useRef)(false);
  const layoutStructureRef = (0, react_exports.useRef)(layoutStructure);
  layoutStructureRef.current = layoutStructure;
  const keyboardListener = (0, dashboard_context_exports.useKeyboardListener)();
  const featureFlags = (0, dashboard_context_exports.useFeatureFlags)();
  const preset = (0, dashboard_context_exports.usePreset)();
  const dashboardApi = (0, dashboard_context_exports.useDashboardCoreApi)();
  const telemetry = (0, dashboard_telemetry_exports.useTelemetryApi)();
  const profiler = (0, dashboard_telemetry_exports.useDashboardProfiler)();
  const {
    scale,
    setScale,
    fitToWidth,
    getZoomObserver,
    zoomIn,
    zoomOut,
    setFitToWidthAndScrollToTopLeft
  } = useZoom({
    canvasRef,
    width,
    height,
    containerWidth,
    containerHeight
  });
  const previousScale = (0, dashboard_ui_exports.usePrevious)(scale);
  const previousLayoutStructure = (0, dashboard_ui_exports.usePrevious)(layoutStructure);
  const getCanvasDomElement = (0, react_exports.useCallback)(() => {
    return canvasRef.current;
  }, []);
  const handleKeyboardMove = (0, react_exports.useCallback)(
    ({
      dir,
      snap,
      preventDefault
    }) => {
      var _a, _b, _c, _d, _e;
      if (!(0, dashboard_utils_exports.allowKeyboardShortcut)()) {
        return;
      }
      const selectedLineItems = findSelectedLineItems({
        layoutStructure,
        selectedItems
      });
      const selectedBlockItems = findSelectedBlockItems({
        layoutStructure,
        selectedItems
      });
      const isResizeHandleFocused = ((_a = document.activeElement) == null ? void 0 : _a.tagName) === "BUTTON" && ((_b = document.activeElement) == null ? void 0 : _b.hasAttribute("direction"));
      const isLineHandleFocused = ((_c = document.activeElement) == null ? void 0 : _c.tagName) === "BUTTON" && ((_e = (_d = document.activeElement) == null ? void 0 : _d.getAttribute("data-test")) == null ? void 0 : _e.startsWith("line-handle"));
      if (selectedLineItems.length === 0 && selectedBlockItems.length === 0 || mode !== "edit" || isResizeHandleFocused || isLineHandleFocused) {
        return;
      }
      const updatedLayoutStructure = updateLayoutStructureOnKeyboardMove({
        selectedBlockItems,
        selectedLineItems,
        dir,
        snap,
        gridSize: GRID_SIZE,
        layoutStructure
      });
      onLayoutStructureChange(updatedLayoutStructure);
      preventDefault();
    },
    [layoutStructure, mode, onLayoutStructureChange, selectedItems]
  );
  const handleLayoutStructureChange = (0, react_exports.useCallback)(() => {
    const updatedLayoutStructure = layoutStructure.map(
      (item) => {
        var _a;
        return (_a = layoutStructureState[item.item]) != null ? _a : item;
      }
    );
    onLayoutStructureChange(updatedLayoutStructure);
  }, [layoutStructure, layoutStructureState, onLayoutStructureChange]);
  const handleLineMove = (0, react_exports.useCallback)(
    (_e, offset) => {
      const selectedLineItems = findSelectedLineItems({
        layoutStructure,
        selectedItems
      });
      if (selectedLineItems.length === 0) {
        return;
      }
      const lineId = selectedLineItems[0].item;
      dispatch({
        type: "lineMove",
        payload: handleSingleLineMove({
          layoutStructure,
          lineId,
          offset
        })
      });
    },
    [layoutStructure, selectedItems]
  );
  const handleLineMoved = (0, react_exports.useCallback)(() => {
    handleLayoutStructureChange();
  }, [handleLayoutStructureChange]);
  const handleLineDragStart = (0, react_exports.useCallback)(
    (_e, dir) => {
      const selectedLineItems = findSelectedLineItems({
        layoutStructure,
        selectedItems
      });
      if (selectedLineItems.length !== 1) {
        return;
      }
      const lineId = selectedLineItems[0].item;
      const line = handleSingleLineDragStart({
        lineId,
        layoutStructure,
        lineDir: dir
      });
      dispatch({
        type: "lineDragStart",
        payload: line
      });
      activeLine.current = { id: lineId, dir };
    },
    [layoutStructure, selectedItems]
  );
  const handleLineDrag = (0, react_exports.useCallback)(
    (_e, offset) => {
      if (!activeLine.current) {
        return;
      }
      const line = layoutStructure.find(
        (item) => {
          var _a;
          return item.item === ((_a = activeLine.current) == null ? void 0 : _a.id);
        }
      );
      const absPos = computeLineAbsPosition({
        layoutStructure,
        position: line.position
      })[activeLine.current.dir];
      dispatch({
        type: "lineDrag",
        payload: {
          id: activeLine.current.id,
          dir: activeLine.current.dir,
          absPos: {
            x: absPos.x + offset.offsetX,
            y: absPos.y + offset.offsetY
          }
        }
      });
    },
    [layoutStructure]
  );
  const handleLineDragged = (0, react_exports.useCallback)(() => {
    activeLine.current = null;
    handleLayoutStructureChange();
  }, [handleLayoutStructureChange]);
  const handleLineConnected = (0, react_exports.useCallback)((itemId, port) => {
    if (!activeLine.current) {
      return;
    }
    const lineId = activeLine.current.id;
    dispatch({
      type: "lineConnect",
      payload: {
        lineId,
        lineDir: activeLine.current.dir,
        itemId,
        port
      }
    });
  }, []);
  const handleLineDisconnected = (0, react_exports.useCallback)(() => {
    if (!activeLine.current) {
      return;
    }
    dispatch({
      type: "lineDisconnect",
      payload: {
        lineId: activeLine.current.id,
        lineDir: activeLine.current.dir
      }
    });
  }, []);
  const handleItemSelected = (0, react_exports.useCallback)(
    (_e, newSelectedItems = emptySelectedItems) => {
      onLayoutItemsSelect(newSelectedItems);
    },
    [onLayoutItemsSelect]
  );
  const handleBlockItemResize = (0, react_exports.useCallback)(
    (_e, itemId, offset, dir) => {
      const item = layoutStructure.find(
        (itm) => itm.item === itemId
      );
      const snapOffset2 = snapOffsetToWH({
        position: item.position,
        offset,
        gridWidth: GRID_SIZE,
        gridHeight: GRID_SIZE,
        spacing: 0,
        padding: 0
      });
      const newItem = updateBlockItemSize({
        item,
        offset: snapOffset2,
        dir,
        options: {
          minHeight: MIN_HEIGHT,
          minWidth: MIN_WIDTH
        }
      });
      if ((0, lodash_exports.isEqual)(
        newItem.position,
        layoutStructureState[newItem.item].position
      )) {
        return;
      }
      profiler == null ? void 0 : profiler.startMeasurement(dashboard_telemetry_exports.VIZ_RESIZE_EVENT);
      dispatch({
        type: "blockResize",
        payload: newItem
      });
    },
    [layoutStructure, layoutStructureState, profiler]
  );
  const handleBlockItemResized = (0, react_exports.useCallback)(() => {
    profiler == null ? void 0 : profiler.emitAndClearMeasurements({
      measurementName: dashboard_telemetry_exports.VIZ_RESIZE_EVENT
    });
    handleLayoutStructureChange();
  }, [handleLayoutStructureChange, profiler]);
  const handleBlockItemMove = (0, react_exports.useCallback)(
    (_e, offset) => {
      const selectedBlockItems = findSelectedBlockItems({
        layoutStructure,
        selectedItems
      });
      if (selectedBlockItems.length === 0) {
        return;
      }
      const firstBlockItem = selectedBlockItems[0];
      const moveOffset = snapOffsetToXY({
        position: firstBlockItem.position,
        offset,
        gridWidth: GRID_SIZE,
        gridHeight: GRID_SIZE,
        spacing: 0,
        padding: 0
      });
      const updatedSelectedBlockItems = selectedBlockItems.map(
        (blockItem) => updateBlockItemPosition(blockItem, moveOffset)
      );
      const firstUpdatedBlockItem = updatedSelectedBlockItems[0];
      if ((0, lodash_exports.isEqual)(
        firstUpdatedBlockItem.position,
        layoutStructureState[firstUpdatedBlockItem.item].position
      )) {
        return;
      }
      profiler == null ? void 0 : profiler.startMeasurement(dashboard_telemetry_exports.VIZ_MOVE_EVENT);
      dispatch({
        type: "blocksMove",
        payload: updatedSelectedBlockItems
      });
    },
    [layoutStructure, layoutStructureState, profiler, selectedItems]
  );
  const handleBlockItemMoved = (0, react_exports.useCallback)(() => {
    profiler == null ? void 0 : profiler.emitAndClearMeasurements({
      measurementName: dashboard_telemetry_exports.VIZ_MOVE_EVENT,
      metadata: { numVisualizationsMoved: selectedItems == null ? void 0 : selectedItems.length }
    });
    handleLayoutStructureChange();
  }, [handleLayoutStructureChange, profiler, selectedItems]);
  const blockItems = (0, react_exports.useMemo)(
    () => layoutStructure.filter((item) => (0, dashboard_utils_exports.isBlockItem)(item)).map(
      (block) => {
        var _a;
        return (_a = layoutStructureState[block.item]) != null ? _a : block;
      }
    ),
    [layoutStructure, layoutStructureState]
  );
  const lineItems = (0, react_exports.useMemo)(
    () => layoutStructure.filter(({ type }) => type === "line").map(
      (line) => {
        var _a;
        return (_a = layoutStructureState[line.item]) != null ? _a : line;
      }
    ),
    [layoutStructure, layoutStructureState]
  );
  const optionsRef = (0, react_exports.useRef)(props.options);
  optionsRef.current = props.options;
  const bgImageSrcRef = (0, react_exports.useRef)();
  const realBGImageUrl = useBackgroundImage(backgroundImage == null ? void 0 : backgroundImage.src);
  bgImageSrcRef.current = realBGImageUrl;
  const getBgImageSrc = (0, react_exports.useCallback)(() => {
    return bgImageSrcRef.current;
  }, []);
  if (!layoutApi.current) {
    layoutApi.current = new AbsoluteLayoutApi_default({
      getZoomObserver,
      setFitToWidthAndScrollToTopLeft,
      zoomIn,
      zoomOut,
      setScale,
      optionsRef,
      layoutStructureRef,
      getCanvasDomElement,
      telemetry,
      getBgImageSrc
    });
  }
  (0, react_exports.useEffect)(() => {
    if (!(0, lodash_exports.isEqual)(layoutStructure, previousLayoutStructure)) {
      dispatch({
        type: "reset",
        payload: layoutStructure
      });
    }
  }, [layoutStructure, previousLayoutStructure]);
  (0, react_exports.useEffect)(() => {
    layoutApiRef(layoutApi.current);
    return () => {
      layoutApiRef(null);
    };
  }, [layoutApiRef]);
  (0, react_exports.useEffect)(() => {
    if (!keyboardListener) {
      return dashboard_utils_exports.noop;
    }
    const unsubscribeMove = keyboardListener.subscribe(
      "move",
      handleKeyboardMove
    );
    return () => {
      unsubscribeMove();
    };
  }, [handleKeyboardMove, keyboardListener]);
  (0, react_exports.useEffect)(() => {
    if (!keyboardListener) {
      return dashboard_utils_exports.noop;
    }
    const unsubscribeCancel = keyboardListener.subscribe(
      "cancel",
      () => handleItemSelected(null, [])
    );
    return () => {
      unsubscribeCancel();
    };
  }, [handleItemSelected, keyboardListener]);
  (0, react_exports.useEffect)(() => {
    if (display === "fit-to-width" || display === "auto-scale") {
      setFitToWidthAndScrollToTopLeft();
    } else if (display === "actual-size") {
      setScale(1);
    } else {
      setFitToWidthAndScrollToTopLeft(1);
    }
  }, [display, setFitToWidthAndScrollToTopLeft, setScale]);
  if (previousScale != null && previousScale >= 1 && scale < 1 && featureFlags.enableZoomCenter) {
    const previousLayout = getCanvasDomElement().parentElement;
    if (previousLayout) {
      savedScroll.current = {
        x: previousLayout.scrollLeft + previousLayout.offsetWidth / 2,
        y: previousLayout.scrollTop + previousLayout.offsetHeight / 2
      };
    }
  }
  (0, react_exports.useLayoutEffect)(() => {
    var _a, _b;
    if (fitToWidth || previousScale == null || previousScale === scale) {
      return;
    }
    const layout = getCanvasDomElement().parentElement;
    if (!layout) {
      return;
    }
    const { offsetWidth, offsetHeight, scrollTop, scrollLeft } = layout;
    if (previousScale < 1 && scale > 1 && ((_a = savedScroll == null ? void 0 : savedScroll.current) == null ? void 0 : _a.x) != null && ((_b = savedScroll == null ? void 0 : savedScroll.current) == null ? void 0 : _b.y) != null && featureFlags.enableZoomCenter) {
      layout.scrollLeft = savedScroll.current.x - layout.offsetWidth / 2;
      layout.scrollTop = savedScroll.current.y - layout.offsetHeight / 2;
    } else {
      const scaleRatio = scale / previousScale;
      const newScroll = shiftViewportOnZoom({
        offsetWidth,
        offsetHeight,
        scrollTop,
        scrollLeft,
        scaleRatio
      });
      layout.scrollLeft = newScroll.scrollLeft;
      layout.scrollTop = newScroll.scrollTop;
    }
  }, [
    featureFlags.enableZoomCenter,
    fitToWidth,
    getCanvasDomElement,
    previousScale,
    scale
  ]);
  (0, react_exports.useEffect)(() => {
    if (activeLine.current && layoutStructureState[activeLine.current.id] == null) {
      activeLine.current = null;
    }
  }, [layoutStructureState]);
  const image = (0, react_exports.useMemo)(
    () => backgroundImage ? validateBackgroundImage({
      backgroundImage,
      canvasWidth: width,
      canvasHeight: height
    }) : {},
    [backgroundImage, height, width]
  );
  const modeSpecificProps = (0, react_exports.useMemo)(
    () => mode === "edit" ? {
      movable: true,
      showOverflowContent: true,
      showGrid,
      showBorder: true,
      gridLineWidth: 1,
      gridPadding: GRID_PADDING,
      onItemMove: handleBlockItemMove,
      onItemMoved: handleBlockItemMoved,
      userSelect: false,
      allowMultiselect: true
    } : {
      movable: false,
      showOverflowContent: false,
      showGrid: false,
      showBorder: false,
      userSelect: true,
      allowMultiselect: false
    },
    [handleBlockItemMove, handleBlockItemMoved, mode, showGrid]
  );
  const allBlockItems = (0, react_exports.useMemo)(
    () => getAllBlockItems({ layoutStructure, layoutStructureState }),
    [layoutStructure, layoutStructureState]
  );
  const blockItemElements = (0, react_exports.useMemo)(() => {
    return allBlockItems.map(({ item, type, position: { x, y, w, h } }) => /* @__PURE__ */ react_default.createElement(
      ResponsiveBlockItem_default,
      {
        key: item,
        itemId: item,
        type,
        x,
        y,
        w,
        h,
        canvasHeight: height,
        renderLayoutItem,
        onItemSelected: handleItemSelected,
        isMouseDownEventRef
      }
    ));
  }, [handleItemSelected, height, allBlockItems, renderLayoutItem]);
  const lineElements = (0, react_exports.useMemo)(() => {
    const selectedLineItems = findSelectedLineItems({
      layoutStructure,
      selectedItems
    });
    const selectable = mode === "edit";
    return lineItems.map((line) => {
      const editable = selectedLineItems.length === 1 && selectedLineItems[0].item === line.item && selectable;
      let absPos = { from: { x: 0, y: 0 }, to: { x: 0, y: 0 } };
      try {
        absPos = computeLineAbsPosition({
          layoutStructure: Object.values(layoutStructureState),
          position: line.position
        });
      } catch (err) {
        if (err instanceof Error && err.message.endsWith(InvalidBlockItemError)) {
          absPos = computeLineAbsPosition({
            layoutStructure: rawLayoutStructure,
            position: line.position
          });
        }
      }
      const fromTestHooks = "item" in line.position.from && "port" in line.position.from ? {
        fromItem: line.position.from.item,
        fromPort: line.position.from.port
      } : {};
      const toTestHooks = "item" in line.position.to && "port" in line.position.to ? {
        toItem: line.position.to.item,
        toPort: line.position.to.port
      } : {};
      return /* @__PURE__ */ react_default.createElement(
        ResponsiveLine_default,
        __spreadValues(__spreadValues({
          key: line.item,
          lineId: line.item,
          scale,
          selectable,
          editable,
          renderLayoutItem,
          onLineMove: handleLineMove,
          onLineMoved: handleLineMoved,
          onLineDragStart: handleLineDragStart,
          onLineDrag: handleLineDrag,
          onLineDragged: handleLineDragged,
          onItemSelected: handleItemSelected,
          fromX: absPos.from.x,
          fromY: absPos.from.y,
          toX: absPos.to.x,
          toY: absPos.to.y
        }, fromTestHooks), toTestHooks)
      );
    });
  }, [
    handleItemSelected,
    handleLineDrag,
    handleLineDragStart,
    handleLineDragged,
    handleLineMove,
    handleLineMoved,
    rawLayoutStructure,
    layoutStructure,
    layoutStructureState,
    lineItems,
    mode,
    renderLayoutItem,
    scale,
    selectedItems
  ]);
  const outlineElements = (0, react_exports.useMemo)(() => {
    const selectedLineItems = findSelectedLineItems({
      layoutStructure: Object.values(layoutStructureState),
      selectedItems
    });
    const selectedBlockItems = findSelectedBlockItems({
      layoutStructure: Object.values(layoutStructureState),
      selectedItems
    });
    return allBlockItems.map((block) => {
      const connectable = mode === "edit" && selectedBlockItems.length === 0 && selectedLineItems.length === 1 && activeLine != null;
      const resizable = mode === "edit" && selectedBlockItems.length === 1 && selectedBlockItems[0].item === block.item;
      const selected = selectedBlockItems.findIndex((b) => b.item === block.item) >= 0;
      if (!connectable && !resizable && !selected) {
        return null;
      }
      const definition = dashboard_definition_exports.DashboardDefinition.fromJSON(
        dashboardApi == null ? void 0 : dashboardApi.getDefinition()
      );
      const itemPresetType = definition.getItemPresetType(block.item);
      const handleDirections = preset.getResizeHandleDirections(itemPresetType);
      return /* @__PURE__ */ react_default.createElement(
        ResponsiveBlockOutline_default,
        {
          key: block.item,
          itemId: block.item,
          x: block.position.x,
          y: block.position.y,
          w: block.position.w,
          h: block.position.h,
          scale,
          connectable,
          resizable,
          onResize: handleBlockItemResize,
          onResized: handleBlockItemResized,
          onLineConnect: handleLineConnected,
          onLineDisconnect: handleLineDisconnected,
          handleDirections
        }
      );
    });
  }, [
    layoutStructureState,
    selectedItems,
    allBlockItems,
    mode,
    activeLine,
    dashboardApi,
    preset,
    scale,
    handleBlockItemResize,
    handleBlockItemResized,
    handleLineConnected,
    handleLineDisconnected
  ]);
  const handleMouseDownCapture = (0, react_exports.useCallback)(() => {
    isMouseDownEventRef.current = true;
  }, []);
  const handleMouseUpCapture = (0, react_exports.useCallback)(() => {
    isMouseDownEventRef.current = false;
  }, []);
  return /* @__PURE__ */ react_default.createElement(
    AbsoluteCanvas_default,
    __spreadValues({
      "data-test": "absolute-layout",
      blockItems,
      width,
      height,
      scale,
      gridWidth: GRID_SIZE - 1,
      gridHeight: GRID_SIZE - 1,
      backgroundColor,
      backgroundImageSrc: image.src,
      backgroundImageSizeType: image.sizeType,
      backgroundImageWidth: image.w,
      backgroundImageHeight: image.h,
      backgroundImagePositionX: image.x,
      backgroundImagePositionY: image.y,
      backgroundImageOpacity: image.opacity,
      selectedLayoutItems: selectedItems,
      onItemSelected: handleItemSelected,
      ref: canvasRef,
      onMouseDownCapture: handleMouseDownCapture,
      onMouseUpCapture: handleMouseUpCapture
    }, modeSpecificProps),
    /* @__PURE__ */ react_default.createElement(
      Layer_default,
      {
        key: "block-item-layer",
        "data-test": "block-item-layer",
        zIndex: 0
      },
      lineElements,
      blockItemElements.map((el, i) => /* @__PURE__ */ react_default.createElement(react_default.Fragment, { key: el.key }, el, /* @__PURE__ */ react_default.createElement(Layer_default, { key: "outline-layer", "data-test": "outline-layer" }, outlineElements[i])))
    )
  );
};
var AbsoluteLayout_default = withLayoutShowHide(AbsoluteLayout, {
  schema: absoluteLayoutOptionsSchema_default
});
//# sourceMappingURL=AbsoluteLayout.js.map
