/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
import {
  i18n_exports
} from "./chunk-PLOB2GBC.js";

// src/GridLayoutConstants.ts
var CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL = (0, i18n_exports._)(
  "This panel is too small to be split into duplicates. Stretch or move the panel to make it bigger first."
);
var EDGE_THICKNESS_PX = 4;
var GRID_PADDING_PX = 1;
var GRID_SIZE_PX = 10;
var MIN_HEIGHT_PX = 64;
var MIN_WIDTH_PX = 64;
var SNAP_RANGE_PX = 8;
var PLACEHOLDER_SIZE_PX = 128;
var ITEM_DROP_TARGET_PX = 12;
var VIZ_DEFAULT_HEIGHT_PX = 400;
var VIZ_PREVIEW_DELAY_MS = 50;
var EDGE_PREVIEW_DELAY_MS = 500;

export {
  CLONE_LAYOUT_ITEMS_MSG_PANEL_TOO_SMALL,
  EDGE_THICKNESS_PX,
  GRID_PADDING_PX,
  GRID_SIZE_PX,
  MIN_HEIGHT_PX,
  MIN_WIDTH_PX,
  SNAP_RANGE_PX,
  PLACEHOLDER_SIZE_PX,
  ITEM_DROP_TARGET_PX,
  VIZ_DEFAULT_HEIGHT_PX,
  VIZ_PREVIEW_DELAY_MS,
  EDGE_PREVIEW_DELAY_MS
};
//# sourceMappingURL=chunk-DLFGXT3M.js.map
