import type { AbsoluteLayoutStructure, SelectedItem, AbsoluteLayoutOptions } from '@splunk/dashboard-types';
import { AbsoluteLayoutApi } from './apis';
import type { RenderLayoutItem } from './types';
export interface AbsoluteLayoutProps {
    mode?: 'view' | 'edit';
    showGrid?: boolean;
    options?: AbsoluteLayoutOptions;
    layoutStructure?: AbsoluteLayoutStructure;
    rawLayoutStructure?: AbsoluteLayoutStructure;
    containerWidth: number;
    containerHeight: number;
    selectedItems?: SelectedItem[];
    renderLayoutItem: RenderLayoutItem;
    onLayoutItemsSelect?: (selectedItems: SelectedItem[]) => void;
    onLayoutStructureChange?: (layoutStructure: AbsoluteLayoutStructure) => void;
    layoutApiRef?: (layoutAPi: AbsoluteLayoutApi | null) => void;
}
declare const _default: import("./enhancers").EnhancedLayout<AbsoluteLayoutProps>;
export default _default;
//# sourceMappingURL=AbsoluteLayout.d.ts.map