export default AbsoluteItem;
/**
 * Absolute positioned item
 * @param {*} param0
 */
declare function AbsoluteItem({ itemId, type, x, y, w, h, renderLayoutItem, }: any): React.JSX.Element;
declare namespace AbsoluteItem {
    namespace propTypes {
        let itemId: T.Validator<string>;
        let type: T.Requireable<string>;
        let x: T.Validator<number>;
        let y: T.Validator<number>;
        let w: T.Validator<number>;
        let h: T.Validator<number>;
        let renderLayoutItem: T.Validator<(...args: any[]) => any>;
    }
}
import React from 'react';
import T from 'prop-types';
//# sourceMappingURL=AbsoluteItem.d.ts.map