import T from 'prop-types';
import type { LayoutItemType } from '@splunk/dashboard-types';
import type { RenderLayoutItem } from '../types';
interface GridItemProps {
    itemId: string;
    type?: LayoutItemType;
    renderLayoutItem: RenderLayoutItem;
}
/**
 * Item positioned on a grid.
 */
declare const GridItem: {
    ({ itemId, type, renderLayoutItem, }: GridItemProps): JSX.Element;
    propTypes: {
        itemId: T.Validator<string>;
        type: T.Requireable<string>;
        renderLayoutItem: T.Validator<(...args: any[]) => any>;
    };
};
export default GridItem;
//# sourceMappingURL=GridItem.d.ts.map