import React from 'react';
import type { ReactElement } from 'react';
import type { StructureItemType } from '@splunk/dashboard-types';
import type { RenderLayoutItem, OnItemSelected } from '../types';
export interface ResponsiveBlockItemProps {
    x: number;
    y: number;
    w: number;
    h: number;
    canvasHeight: number;
    padding?: number;
    itemId: string;
    type?: StructureItemType;
    renderLayoutItem: RenderLayoutItem;
    onItemSelected: OnItemSelected;
    appearance?: 'hidden' | 'visible' | 'highlighted';
    errorMessages?: string[];
    isMouseDownEventRef?: React.MutableRefObject<boolean>;
}
declare const _default: React.MemoExoticComponent<({ x: originalX, y: originalY, w: originalW, h: originalH, canvasHeight, padding, itemId, type, errorMessages, onItemSelected, renderLayoutItem, appearance, isMouseDownEventRef, }: ResponsiveBlockItemProps) => ReactElement>;
export default _default;
//# sourceMappingURL=ResponsiveBlockItem.d.ts.map