import React from 'react';
import type { AbsoluteLayoutStructure, GridLayoutStructure, SchemaObject } from '@splunk/dashboard-types';
import { type ReflowFn } from '../hooks';
type GenericLayoutProps = {
    layoutStructure?: AbsoluteLayoutStructure | GridLayoutStructure;
};
export interface EnhancedLayout<P extends GenericLayoutProps> {
    (props: P): JSX.Element;
    schema: SchemaObject;
}
export declare const withLayoutShowHide: <P extends GenericLayoutProps>(Layout: React.ComponentType<P>, { schema, reflowFn }: {
    schema: SchemaObject;
    reflowFn?: ReflowFn;
}) => EnhancedLayout<P>;
export {};
//# sourceMappingURL=withLayoutShowHide.d.ts.map