import type { Dispatch, MutableRefObject, Ref, SetStateAction, MouseEvent } from 'react';
import type { Coordinate, SelectedItem } from '@splunk/dashboard-types';
export interface MouseDownWithHandleProps {
    handleMouseDownOnItem: (event: MouseEvent, blockItem: SelectedItem) => void;
    canvasRef: Ref<HTMLDivElement>;
    scale?: number;
    setStartPosition: Dispatch<SetStateAction<null | Coordinate>>;
    movable: boolean;
    setIsMoving: Dispatch<SetStateAction<boolean>>;
    isMovingRef?: MutableRefObject<boolean>;
}
export declare const useMouseDownWithHandleEventListeners: ({ handleMouseDownOnItem, canvasRef, scale, setStartPosition, movable, setIsMoving, isMovingRef, }: MouseDownWithHandleProps) => void;
//# sourceMappingURL=useMouseDownWithHandleEventListeners.d.ts.map