import type { ReflowFn } from '../hooks';
/**
 * Generate a new layout structure which has all itemsToRemove entries taken out
 * of the structure and any remaining content updated to fill the space originally
 * ued by the removed block items
 * @param {AbsoluteBlockItem[]} initialStructure The initial layout structure array to be processed
 * @param {AbsoluteBlockItem[]} itemsToRemove The array of all AbsoluteBlockItem objects to be removed from the structure
 * @returns {AbsoluteBlockItem[]} The updated layout structure with applied item removals
 */
export declare const gridLayoutShowHideReflow: ReflowFn;
//# sourceMappingURL=gridLayoutShowHide.d.ts.map