declare const _default: {
    toArrow: {
        type: string;
        default: boolean;
        description: string;
    };
    fromArrow: {
        type: string;
        default: boolean;
        description: string;
    };
    strokeColor: {
        anyOf: ({
            type: string;
            pattern: RegExp;
            description: string;
        } | {
            type: string;
            pattern: string;
            description?: undefined;
        })[];
    };
    strokeDataSeries: {
        type: string;
        pattern: string;
        description: string;
        default: string;
    };
    strokeDataPoint: {
        type: string;
        pattern: string;
        description: string;
        default: string;
    };
    strokeDasharray: {
        type: string;
        default: number;
        description: string;
    };
    strokeWidth: {
        type: string;
        default: number;
        description: string;
    };
    strokeOpacity: {
        type: string;
        default: number;
        description: string;
    };
};
export default _default;
//# sourceMappingURL=ConnectedLineOptionsSchema.d.ts.map